
Changelog
*********


Python 3.4.10 final
===================

*Release date: 2019-03-18*


Security
--------

* bpo-36216: Changes urlsplit() to raise ValueError when the URL
  contains characters that decompose under IDNA encoding (NFKC-
  normalization) into characters that affect how the URL is parsed.

* bpo-35121: Don't send cookies of domain A without Domain attribute
  to domain B when domain A is a suffix match of domain B while using
  a cookiejar with "http.cookiejar.DefaultCookiePolicy" policy. Patch
  by Karthikeyan Singaravelan.


Library
-------

* bpo-35121: Don't set cookie for a request when the request path is
  a prefix match of the cookie's path attribute but doesn't end with
  "/". Patch by Karthikeyan Singaravelan.


Python 3.4.10 release candidate 1
=================================

*Release date: 2019-03-03*


Security
--------

* bpo-35746: [CVE-2019-5010] Fix a NULL pointer deref in ssl module.
  The cert parser did not handle CRL distribution points with empty DP
  or URI correctly. A malicious or buggy certificate can result into
  segfault. Vulnerability (TALOS-2018-0758) reported by Colin Read and
  Nicolas Edet of Cisco.

* bpo-34791: The xml.sax and xml.dom.domreg no longer use
  environment variables to override parser implementations when
  sys.flags.ignore_environment is set by -E or -I arguments.

* bpo-34623: CVE-2018-14647: The C accelerated _elementtree module
  now initializes hash randomization salt from _Py_HashSecret instead
  of libexpat's default CSPRNG.


Library
-------

* bpo-33329: Fix multiprocessing regression on newer glibcs


Python 3.4.9 final
==================

*Release date: 2018-08-02*

There were no changes between 3.4.9rc1 and 3.4.9 final.


Python 3.4.9 release candidate 1
================================

*Release date: 2018-07-19*


Security
--------

* bpo-33001: Minimal fix to prevent buffer overrun in os.symlink on
  Windows

* bpo-32981: Regexes in difflib and poplib were vulnerable to
  catastrophic backtracking. These regexes formed potential DOS
  vectors (REDOS). They have been refactored. This resolves
  CVE-2018-1060 and CVE-2018-1061. Patch by Jamie Davis.


Python 3.4.8 final
==================

*Release date: 2018-02-04*

There were no new changes in version 3.4.8.


Python 3.4.8 release candidate 1
================================

*Release date: 2018-01-23*


Security
--------

* bpo-30657: Fixed possible integer overflow in
  PyBytes_DecodeEscape, CVE-2017-1000158. Original patch by Jay
  Bosamiya; rebased to Python 3 by Miro Hrončok.

* bpo-30947: Upgrade libexpat embedded copy from version 2.2.1 to
  2.2.3 to get security fixes.

* bpo-29169: Update zlib from 1.2.8 to 1.2.11 to get security fixes.


Library
-------

* bpo-32072: Fixed issues with binary plists:

  * Fixed saving bytearrays.

  * Identical objects will be saved only once.

  * Equal references will be load as identical objects.

  * Added support for saving and loading recursive data structures.

* bpo-31170: expat: Update libexpat from 2.2.3 to 2.2.4. Fix copying
  of partial characters for UTF-8 input (libexpat bug 115):
  https://github.com/libexpat/libexpat/issues/115


Build
-----

* bpo-29572: Update Windows build and OS X installers to use OpenSSL
  1.0.2k.


Python 3.4.7 final
==================

*Release date: 2017-08-09*


Library
-------

* bpo-30119: ftplib.FTP.putline() now throws ValueError on commands
  that contains CR or LF. Patch by Dong-hee Na.


Python 3.4.7 release candidate 1
================================

*Release date: 2017-07-23*


Security
--------

* bpo-29591: Update expat copy from 2.1.1 to 2.2.0 to get fixes of
  CVE-2016-0718 and CVE-2016-4472. See
  https://sourceforge.net/p/expat/bugs/537/ for more information.

* bpo-30694: Upgrade expat copy from 2.2.0 to 2.2.1 to get fixes of
  multiple security vulnerabilities including: CVE-2017-9233 (External
  entity infinite loop DoS), CVE-2016-9063 (Integer overflow, re-fix),
  CVE-2016-0718 (Fix regression bugs from 2.2.0's fix to
  CVE-2016-0718) and CVE-2012-0876 (Counter hash flooding with
  SipHash).  Note: the CVE-2016-5300 (Use os- specific entropy sources
  like getrandom) doesn't impact Python, since Python already gets
  entropy from the OS to set the expat secret using
  "XML_SetHashSalt()".

* bpo-26657: Fix directory traversal vulnerability with http.server
  on Windows. This fixes a regression that was introduced in 3.3.4rc1
  and 3.4.0rc1. Based on patch by Philipp Hagemeister.

* bpo-30500: Fix urllib.parse.splithost() to correctly parse
  fragments. For example, "splithost('//127.0.0.1#@evil.com/')" now
  correctly returns the "127.0.0.1" host, instead of treating
  "@evil.com" as the host in an authentification ("login@host").

* bpo-30730: Prevent environment variables injection in subprocess
  on Windows.  Prevent passing other invalid environment variables and
  command arguments.


Core and Builtins
-----------------

* bpo-26617: Fix crash when GC runs during weakref callbacks.

* bpo-27945: Fixed various segfaults with dict when input
  collections are mutated during searching, inserting or comparing.
  Based on patches by Duane Griffin and Tim Mitchell.


Library
-------

* bpo-27850: Remove 3DES from ssl module's default cipher list to
  counter measure sweet32 attack (CVE-2016-2183).


Documentation
-------------

* bpo-25008: Document smtpd.py as effectively deprecated and add a
  pointer to aiosmtpd, a third-party asyncio-based replacement.


Python 3.4.6 final
==================

*Release date: 2017-01-17*

There were no changes between 3.4.6rc1 and 3.4.6 final.


Python 3.4.6 release candidate 1
================================

*Release date: 2017-01-02*


Core and Builtins
-----------------

* bpo-28648: Fixed crash in Py_DecodeLocale() in debug build on Mac
  OS X when decode astral characters.  Patch by Xiang Zhang.

* bpo-28426: Fixed potential crash in PyUnicode_AsDecodedObject() in
  debug build.


Library
-------

* bpo-28563: Fixed possible DoS and arbitrary code execution when
  handle plural form selections in the gettext module.  The expression
  parser now supports exact syntax supported by GNU gettext.

* In the curses module, raise an error if window.getstr() or
  window.instr() is passed a negative value.

* bpo-27783: Fix possible usage of uninitialized memory in
  operator.methodcaller.

* bpo-27774: Fix possible Py_DECREF on unowned object in _sre.

* bpo-27760: Fix possible integer overflow in binascii.b2a_qp.

* bpo-27758: Fix possible integer overflow in the _csv module for
  large record lengths.

* bpo-27568: Prevent HTTPoxy attack (CVE-2016-1000110). Ignore the
  HTTP_PROXY variable when REQUEST_METHOD environment is set, which
  indicates that the script is in CGI mode.

* bpo-27759: Fix selectors incorrectly retain invalid file
  descriptors. Patch by Mark Williams.


Build
-----

* bpo-28248: Update Windows build to use OpenSSL 1.0.2j.


Tests
-----

* bpo-27369: In test_pyexpat, avoid testing an error message detail
  that changed in Expat 2.2.0.


Python 3.4.5 final
==================

*Release date: 2016-06-26*


Tests
-----

* bpo-26867: Ubuntu's openssl OP_NO_SSLv3 is forced on by default;
  fix test.


Python 3.4.5 release candidate 1
================================

*Release date: 2016-06-11*


Core and Builtins
-----------------

* bpo-26478: Fix semantic bugs when using binary operators with
  dictionary views and tuples.

* bpo-26171: Fix possible integer overflow and heap corruption in
  zipimporter.get_data().


Library
-------

* bpo-26556: Update expat to 2.1.1, fixes CVE-2015-1283.

* Fix TLS stripping vulnerability in smptlib, CVE-2016-0772.
  Reported by Team Oststrom

* bpo-25939: On Windows open the cert store readonly in
  ssl.enum_certificates.

* bpo-26012: Don't traverse into symlinks for ** pattern in
  pathlib.Path.[r]glob().

* bpo-24120: Ignore PermissionError when traversing a tree with
  pathlib.Path.[r]glob(). Patch by Ulrich Petri.

* Skip getaddrinfo if host is already resolved. Patch by A. Jesse
  Jiryu Davis.

* Add asyncio.timeout() context manager.

* bpo-26050: Add asyncio.StreamReader.readuntil() method. Patch by
  Марк Коренберг.


Tests
-----

* bpo-25940: Changed test_ssl to use self-signed.pythontest.net.
  This avoids relying on svn.python.org, which recently changed root
  certificate.


Python 3.4.4 final
==================

*Release date: 2015/12/20*


Windows
-------

* bpo-25844: Corrected =/== typo potentially leading to crash in
  launcher.


Python 3.4.4 release candidate 1
================================

*Release date: 2015/12/06*


Core and Builtins
-----------------

* bpo-25709: Fixed problem with in-place string concatenation and
  utf-8 cache.

* bpo-24097: Fixed crash in object.__reduce__() if slot name is
  freed inside __getattr__.

* bpo-24731: Fixed crash on converting objects with special methods
  __bytes__, __trunc__, and __float__ returning instances of
  subclasses of bytes, int, and float to subclasses of bytes, int, and
  float correspondingly.

* bpo-25388: Fixed tokenizer crash when processing undecodable
  source code with a null byte.

* bpo-22995: Default implementation of __reduce__ and __reduce_ex__
  now rejects builtin types with not defined __new__.

* bpo-24802: Avoid buffer overreads when int(), float(), compile(),
  exec() and eval() are passed bytes-like objects.  These objects are
  not necessarily terminated by a null byte, but the functions assumed
  they were.

* bpo-24402: Fix input() to prompt to the redirected stdout when
  sys.stdout.fileno() fails.

* bpo-24806: Prevent builtin types that are not allowed to be
  subclassed from being subclassed through multiple inheritance.

* bpo-24848: Fixed a number of bugs in UTF-7 decoding of misformed
  data.

* bpo-25280: Import trace messages emitted in verbose (-v) mode are
  no longer formatted twice.

* bpo-25003: os.urandom() doesn't use getentropy() on Solaris
  because getentropy() is blocking, whereas os.urandom() should not
  block. getentropy() is supported since Solaris 11.3.

* bpo-25182: The stdprinter (used as sys.stderr before the io module
  is imported at startup) now uses the backslashreplace error handler.

* bpo-24891: Fix a race condition at Python startup if the file
  descriptor of stdin (0), stdout (1) or stderr (2) is closed while
  Python is creating sys.stdin, sys.stdout and sys.stderr objects.
  These attributes are now set to None if the creation of the object
  failed, instead of raising an OSError exception. Initial patch
  written by Marco Paolini.

* bpo-21167: NAN operations are now handled correctly when python is
  compiled with ICC even if -fp-model strict is not specified.

* bpo-4395: Better testing and documentation of binary operators.
  Patch by Martin Panter.

* bpo-24467: Fixed possible buffer over-read in bytearray. The
  bytearray object now always allocates place for trailing null byte
  and it's buffer now is always null-terminated.

* bpo-24115: Update uses of PyObject_IsTrue(), PyObject_Not(),
  PyObject_IsInstance(), PyObject_RichCompareBool() and
  _PyDict_Contains() to check for and handle errors correctly.

* bpo-24257: Fixed system error in the comparison of faked
  types.SimpleNamespace.

* bpo-22939: Fixed integer overflow in iterator object.  Patch by
  Clement Rouault.

* bpo-23985: Fix a possible buffer overrun when deleting a slice
  from the front of a bytearray and then appending some other bytes
  data.

* bpo-24102: Fixed exception type checking in standard error
  handlers.

* bpo-23757: PySequence_Tuple() incorrectly called the concrete list
  API when the data was a list subclass.

* bpo-24407: Fix crash when dict is mutated while being updated.

* bpo-24096: Make warnings.warn_explicit more robust against
  mutation of the warnings.filters list.

* bpo-23996: Avoid a crash when a delegated generator raises an
  unnormalized StopIteration exception.  Patch by Stefan Behnel.

* bpo-24022: Fix tokenizer crash when processing undecodable source
  code.

* bpo-23309: Avoid a deadlock at shutdown if a daemon thread is
  aborted while it is holding a lock to a buffered I/O object, and the
  main thread tries to use the same I/O object (typically stdout or
  stderr).  A fatal error is emitted instead.

* bpo-22977: Fixed formatting Windows error messages on Wine. Patch
  by Martin Panter.

* bpo-23803: Fixed str.partition() and str.rpartition() when a
  separator is wider then partitioned string.

* bpo-23192: Fixed generator lambdas.  Patch by Bruno Cauet.

* bpo-23629: Fix the default __sizeof__ implementation for variable-
  sized objects.

* bpo-24044: Fix possible null pointer dereference in list.sort in
  out of memory conditions.

* bpo-21354: PyCFunction_New function is exposed by python DLL
  again.


Library
-------

* bpo-24903: Fix regression in number of arguments compileall
  accepts when '-d' is specified.  The check on the number of
  arguments has been dropped completely as it never worked correctly
  anyway.

* bpo-25764: In the subprocess module, preserve any exception caused
  by fork() failure when preexec_fn is used.

* bpo-6478: _strptime's regexp cache now is reset after changing
  timezone with time.tzset().

* bpo-25177: Fixed problem with the mean of very small and very
  large numbers. As a side effect, statistics.mean and
  statistics.variance should be significantly faster.

* bpo-25718: Fixed copying object with state with boolean value is
  false.

* bpo-10131: Fixed deep copying of minidom documents.  Based on
  patch by Marian Ganisin.

* bpo-25725: Fixed a reference leak in pickle.loads() when
  unpickling invalid data including tuple instructions.

* bpo-25663: In the Readline completer, avoid listing duplicate
  global names, and search the global namespace before searching
  builtins.

* bpo-25688: Fixed file leak in ElementTree.iterparse() raising an
  error.

* bpo-23914: Fixed SystemError raised by unpickler on broken pickle
  data.

* bpo-25691: Fixed crash on deleting ElementTree.Element attributes.

* bpo-25624: ZipFile now always writes a ZIP_STORED header for
  directory entries.  Patch by Dingyuan Wang.

* bpo-25583: Avoid incorrect errors raised by
  os.makedirs(exist_ok=True) when the OS gives priority to errors such
  as EACCES over EEXIST.

* bpo-25593: Change semantics of EventLoop.stop() in asyncio.

* bpo-6973: When we know a subprocess.Popen process has died, do not
  allow the send_signal(), terminate(), or kill() methods to do
  anything as they could potentially signal a different process.

* bpo-25578: Fix (another) memory leak in SSLSocket.getpeercer().

* bpo-25590: In the Readline completer, only call getattr() once per
  attribute.

* bpo-25498: Fix a crash when garbage-collecting ctypes objects
  created by wrapping a memoryview.  This was a regression made in
  3.4.3.  Based on patch by Eryksun.

* bpo-18010: Fix the pydoc web server's module search function to
  handle exceptions from importing packages.

* bpo-25510: fileinput.FileInput.readline() now returns b'' instead
  of '' at the end if the FileInput was opened with binary mode. Patch
  by Ryosuke Ito.

* bpo-25530: Disable the vulnerable SSLv3 protocol by default when
  creating ssl.SSLContext.

* bpo-25569: Fix memory leak in SSLSocket.getpeercert().

* bpo-21827: Fixed textwrap.dedent() for the case when largest
  common whitespace is a substring of smallest leading whitespace.
  Based on patch by Robert Li.

* bpo-25471: Sockets returned from accept() shouldn't appear to be
  nonblocking.

* bpo-25441: asyncio: Raise error from drain() when socket is
  closed.

* bpo-25411: Improved Unicode support in SMTPHandler through better
  use of the email package. Thanks to user simon04 for the patch.

* bpo-25380: Fixed protocol for the STACK_GLOBAL opcode in
  pickletools.opcodes.

* bpo-23972: Updates asyncio datagram create method allowing
  reuseport and reuseaddr socket options to be set prior to binding
  the socket. Mirroring the existing asyncio create_server method the
  reuseaddr option for datagram sockets defaults to True if the O/S is
  'posix' (except if the platform is Cygwin). Patch by Chris Laws.

* bpo-25304: Add asyncio.run_coroutine_threadsafe().  This lets you
  submit a coroutine to a loop from another thread, returning a
  concurrent.futures.Future.  By Vincent Michel.

* bpo-25319: When threading.Event is reinitialized, the underlying
  condition should use a regular lock rather than a recursive lock.

* bpo-25232: Fix CGIRequestHandler to split the query from the URL
  at the first question mark (?) rather than the last. Patch from
  Xiang Zhang.

* bpo-24657: Prevent CGIRequestHandler from collapsing slashes in
  the query part of the URL as if it were a path. Patch from Xiang
  Zhang.

* bpo-22958: Constructor and update method of
  weakref.WeakValueDictionary now accept the self and the dict keyword
  arguments.

* bpo-22609: Constructor of collections.UserDict now accepts the
  self keyword argument.

* bpo-25262: Added support for BINBYTES8 opcode in Python
  implementation of unpickler. Highest 32 bits of 64-bit size for
  BINUNICODE8 and BINBYTES8 opcodes no longer silently ignored on
  32-bit platforms in C implementation.

* bpo-25034: Fix string.Formatter problem with auto-numbering and
  nested format_specs. Patch by Anthon van der Neut.

* bpo-25233: Rewrite the guts of asyncio.Queue and asyncio.Semaphore
  to be more understandable and correct.

* bpo-23600: Default implementation of tzinfo.fromutc() was
  returning wrong results in some cases.

* bpo-25203: Failed readline.set_completer_delims() no longer left
  the module in inconsistent state.

* Prevent overflow in _Unpickler_Read.

* bpo-25047: The XML encoding declaration written by Element Tree
  now respects the letter case given by the user. This restores the
  ability to write encoding names in uppercase like "UTF-8", which
  worked in Python 2.

* bpo-19143: platform module now reads Windows version from
  kernel32.dll to avoid compatibility shims.

* bpo-23517: Fix rounding in fromtimestamp() and utcfromtimestamp()
  methods of datetime.datetime: microseconds are now rounded to
  nearest with ties going to nearest even integer (ROUND_HALF_EVEN),
  instead of being rounding towards zero (ROUND_DOWN). It's important
  that these methods use the same rounding mode than
  datetime.timedelta to keep the property: (datetime(1970,1,1) +
  timedelta(seconds=t)) == datetime.utcfromtimestamp(t). It also the
  rounding mode used by round(float) for example.

* bpo-24684: socket.socket.getaddrinfo() now calls
  PyUnicode_AsEncodedString() instead of calling the encode() method
  of the host, to handle correctly custom string with an encode()
  method which doesn't return a byte string. The encoder of the IDNA
  codec is now called directly instead of calling the encode() method
  of the string.

* bpo-24982: shutil.make_archive() with the "zip" format now adds
  entries for directories (including empty directories) in ZIP file.

* bpo-24857: Comparing call_args to a long sequence now correctly
  returns a boolean result instead of raising an exception.  Patch by
  A Kaptur.

* bpo-25019: Fixed a crash caused by setting non-string key of expat
  parser. Based on patch by John Leitch.

* bpo-24917: time_strftime() buffer over-read.

* bpo-23144: Make sure that HTMLParser.feed() returns all the data,
  even when convert_charrefs is True.

* bpo-16180: Exit pdb if file has syntax error, instead of trapping
  user in an infinite loop.  Patch by Xavier de Gaye.

* bpo-21112: Fix regression in unittest.expectedFailure on
  subclasses. Patch from Berker Peksag.

* bpo-24931: Instances of subclasses of namedtuples have their own
  __dict__ which breaks the inherited __dict__ property and breaks the
  _asdict() method. Removed the __dict__ property to prevent the
  conflict and fixed _asdict().

* bpo-24764: cgi.FieldStorage.read_multi() now ignores the Content-
  Length header in part headers. Patch written by Peter Landry and
  reviewed by Pierre Quentel.

* bpo-24774: Fix docstring in http.server.test. Patch from Chiu-
  Hsiang Hsu.

* bpo-21159: Improve message in
  configparser.InterpolationMissingOptionError. Patch from Łukasz
  Langa.

* bpo-23888: Handle fractional time in cookie expiry. Patch by ssh.

* bpo-23004: mock_open() now reads binary data correctly when the
  type of read_data is bytes.  Initial patch by Aaron Hill.

* bpo-23652: Make it possible to compile the select module against
  the libc headers from the Linux Standard Base, which do not include
  some EPOLL macros.  Patch by Matt Frank.

* bpo-22932: Fix timezones in email.utils.formatdate. Patch from
  Dmitry Shachnev.

* bpo-23779: imaplib raises TypeError if authenticator tries to
  abort. Patch from Craig Holmquist.

* bpo-23319: Fix ctypes.BigEndianStructure, swap correctly bytes.
  Patch written by Matthieu Gautier.

* bpo-23254: Document how to close the TCPServer listening socket.
  Patch from Martin Panter.

* bpo-19450: Update Windows and OS X installer builds to use SQLite
  3.8.11.

* bpo-23441: rcompleter now prints a tab character instead of
  displaying possible completions for an empty word.  Initial patch by
  Martin Sekera.

* bpo-24735: Fix invalid memory access in
  itertools.combinations_with_replacement().

* bpo-17527: Add PATCH to wsgiref.validator. Patch from Luca
  Sbardella.

* bpo-24683: Fixed crashes in _json functions called with arguments
  of inappropriate type.

* bpo-21697: shutil.copytree() now correctly handles symbolic links
  that point to directories.  Patch by Eduardo Seabra and Thomas
  Kluyver.

* bpo-24620: Random.setstate() now validates the value of state last
  element.

* bpo-22153: Improve unittest docs. Patch from Martin Panter and
  evilzero.

* bpo-24206: Fixed __eq__ and __ne__ methods of inspect classes.

* bpo-21750: mock_open.read_data can now be read from each instance,
  as it could in Python 3.3.

* bpo-23247: Fix a crash in the StreamWriter.reset() of CJK codecs.

* bpo-18622: unittest.mock.mock_open().reset_mock would recurse
  infinitely. Patch from Nicola Palumbo and Laurent De Buyst.

* bpo-24608: chunk.Chunk.read() now always returns bytes, not str.

* bpo-18684: Fixed reading out of the buffer in the re module.

* bpo-24259: tarfile now raises a ReadError if an archive is
  truncated inside a data segment.

* bpo-24552: Fix use after free in an error case of the _pickle
  module.

* bpo-24514: tarfile now tolerates number fields consisting of only
  whitespace.

* bpo-19176: Fixed doctype() related bugs in C implementation of
  ElementTree. A deprecation warning no longer issued by XMLParser
  subclass with default doctype() method.  Direct call of doctype()
  now issues a warning.  Parser's doctype() now is not called if
  target's doctype() is called.  Based on patch by Martin Panter.

* bpo-20387: Restore semantic round-trip correctness in
  tokenize/untokenize for tab- indented blocks.

* bpo-24456: Fixed possible buffer over-read in adpcm2lin() and
  lin2adpcm() functions of the audioop module.

* bpo-24336: The contextmanager decorator now works with functions
  with keyword arguments called "func" and "self".  Patch by Martin
  Panter.

* bpo-24489: ensure a previously set C errno doesn't disturb
  cmath.polar().

* bpo-5633: Fixed timeit when the statement is a string and the
  setup is not.

* bpo-24326: Fixed audioop.ratecv() with non-default weightB
  argument. Original patch by David Moore.

* bpo-23840: tokenize.open() now closes the temporary binary file on
  error to fix a resource warning.

* bpo-24257: Fixed segmentation fault in sqlite3.Row constructor
  with faked cursor type.

* bpo-22107: tempfile.gettempdir() and tempfile.mkdtemp() now try
  again when a directory with the chosen name already exists on
  Windows as well as on Unix. tempfile.mkstemp() now fails early if
  parent directory is not valid (not exists or is a file) on Windows.

* bpo-6598: Increased time precision and random number range in
  email.utils.make_msgid() to strengthen the uniqueness of the message
  ID.

* bpo-24091: Fixed various crashes in corner cases in C
  implementation of ElementTree.

* bpo-21931: msilib.FCICreate() now raises TypeError in the case of
  a bad argument instead of a ValueError with a bogus FCI error
  number. Patch by Jeffrey Armstrong.

* bpo-23796: peek and read1 methods of BufferedReader now raise
  ValueError if they called on a closed object. Patch by John
  Hergenroeder.

* bpo-24521: Fix possible integer overflows in the pickle module.

* bpo-22931: Allow '[' and ']' in cookie values.

* bpo-20274: Remove ignored and erroneous "kwargs" parameters from
  three METH_VARARGS methods on _sqlite.Connection.

* bpo-24094: Fix possible crash in json.encode with poorly behaved
  dict subclasses.

* Asyncio issue 222 / PR 231 (Victor Stinner) -- fix @coroutine
  functions without __name__.

* bpo-9246: On POSIX, os.getcwd() now supports paths longer than
  1025 bytes. Patch written by William Orr.

* The keywords attribute of functools.partial is now always a
  dictionary.

* bpo-24099: Fix free-after-use bug in heapq's siftup and siftdown
  functions. (See also: bpo-24100, bpo-24101)

* Backport collections.deque fixes from Python 3.5.  Prevents
  reentrant badness during deletion by deferring the decref until the
  container has been restored to a consistent state.

* bpo-23008: Fixed resolving attributes with boolean value is False
  in pydoc.

* Fix asyncio issue 235: LifoQueue and PriorityQueue's put didn't
  increment unfinished tasks (this bug was introduced in 3.4.3 when
  JoinableQueue was merged with Queue).

* bpo-23908: os functions now reject paths with embedded null
  character on Windows instead of silently truncate them.

* bpo-23728: binascii.crc_hqx() could return an integer outside of
  the range 0-0xffff for empty data.

* bpo-23811: Add missing newline to the PyCompileError error
  message. Patch by Alex Shkop.

* bpo-17898: Fix exception in gettext.py when parsing certain plural
  forms.

* bpo-22982: Improve BOM handling when seeking to multiple positions
  of a writable text file.

* bpo-23865: close() methods in multiple modules now are idempotent
  and more robust at shutdown. If they need to release multiple
  resources, all are released even if errors occur.

* bpo-23881: urllib.request.ftpwrapper constructor now closes the
  socket if the FTP connection failed to fix a ResourceWarning.

* bpo-23400: Raise same exception on both Python 2 and 3 if sem_open
  is not available. Patch by Davin Potts.

* bpo-15133: _tkinter.tkapp.getboolean() now supports Tcl_Obj and
  always returns bool. tkinter.BooleanVar now validates input values
  (accepted bool, int, str, and Tcl_Obj).  tkinter.BooleanVar.get()
  now always returns bool.

* bpo-23338: Fixed formatting ctypes error messages on Cygwin. Patch
  by Makoto Kato.

* bpo-16840: Tkinter now supports 64-bit integers added in Tcl 8.4
  and arbitrary precision integers added in Tcl 8.5.

* bpo-23834: Fix socket.sendto(), use the C Py_ssize_t type to store
  the result of sendto() instead of the C int type.

* bpo-21526: Tkinter now supports new boolean type in Tcl 8.5.

* bpo-23838: linecache now clears the cache and returns an empty
  result on MemoryError.

* bpo-18473: Fixed 2to3 and 3to2 compatible pickle mappings.  Fixed
  ambigious reverse mappings.  Added many new mappings.  Import
  mapping is no longer applied to modules already mapped with full
  name mapping.

* bpo-23745: The new email header parser now handles duplicate MIME
  parameter names without error, similar to how get_param behaves.

* bpo-23792: Ignore KeyboardInterrupt when the pydoc pager is
  active. This mimics the behavior of the standard unix pagers, and
  prevents pipepager from shutting down while the pager itself is
  still running.

* bpo-23742: ntpath.expandvars() no longer loses unbalanced single
  quotes.

* bpo-21802: The reader in BufferedRWPair now is closed even when
  closing writer failed in BufferedRWPair.close().

* bpo-23671: string.Template now allows to specify the "self"
  parameter as keyword argument.  string.Formatter now allows to
  specify the "self" and the "format_string" parameters as keyword
  arguments.

* bpo-21560: An attempt to write a data of wrong type no longer
  cause GzipFile corruption.  Original patch by Wolfgang Maier.

* bpo-23647: Increase impalib's MAXLINE to accommodate modern
  mailbox sizes.

* bpo-23539: If body is None, http.client.HTTPConnection.request now
  sets Content-Length to 0 for PUT, POST, and PATCH headers to avoid
  411 errors from some web servers.

* bpo-22351: The nntplib.NNTP constructor no longer leaves the
  connection and socket open until the garbage collector cleans them
  up.  Patch by Martin Panter.

* bpo-23136: _strptime now uniformly handles all days in week 0,
  including Dec 30 of previous year.  Based on patch by Jim Carroll.

* bpo-23700: Iterator of NamedTemporaryFile now keeps a reference to
  NamedTemporaryFile instance.  Patch by Bohuslav Kabrda.

* bpo-22903: The fake test case created by unittest.loader when it
  fails importing a test module is now picklable.

* bpo-23568: Add rdivmod support to MagicMock() objects. Patch by
  Håkan Lövdahl.

* bpo-23138: Fixed parsing cookies with absent keys or values in
  cookiejar. Patch by Demian Brecht.

* bpo-23051: multiprocessing.Pool methods imap() and
  imap_unordered() now handle exceptions raised by an iterator.  Patch
  by Alon Diamant and Davin Potts.

* bpo-22928: Disabled HTTP header injections in http.client.
  Original patch by Demian Brecht.

* bpo-23615: Modules bz2, tarfile and tokenize now can be reloaded
  with imp.reload(). Patch by Thomas Kluyver.

* bpo-23476: In the ssl module, enable OpenSSL's
  X509_V_FLAG_TRUSTED_FIRST flag on certificate stores when it is
  available.

* bpo-23576: Avoid stalling in SSL reads when EOF has been reached
  in the SSL layer but the underlying connection hasn't been closed.

* bpo-23504: Added an __all__ to the types module.

* bpo-20204: Added the __module__ attribute to _tkinter classes.

* bpo-23521: Corrected pure python implementation of timedelta
  division.

  Eliminated OverflowError from timedelta * float for some floats;
  Corrected rounding in timedlta true division.

* bpo-21619: Popen objects no longer leave a zombie after exit in
  the with statement if the pipe was broken.  Patch by Martin Panter.

* bpo-6639: Module-level turtle functions no longer raise TclError
  after closing the window.

* bpo-814253: Warnings now are raised when group references and
  conditional group references are used in lookbehind assertions in
  regular expressions. (See also: bpo-9179)

* bpo-23215: Multibyte codecs with custom error handlers that
  ignores errors consumed too much memory and raised SystemError or
  MemoryError. Original patch by Aleksi Torhamo.

* bpo-5700: io.FileIO() called flush() after closing the file.
  flush() was not called in close() if closefd=False.

* bpo-23374: Fixed pydoc failure with non-ASCII files when stdout
  encoding differs from file system encoding (e.g. on Mac OS).

* bpo-23481: Remove RC4 from the SSL module's default cipher list.

* bpo-21548: Fix pydoc.synopsis() and pydoc.apropos() on modules
  with empty docstrings.

* bpo-22885: Fixed arbitrary code execution vulnerability in the
  dbm.dumb module. Original patch by Claudiu Popa.

* bpo-23146: Fix mishandling of absolute Windows paths with forward
  slashes in pathlib.

* bpo-23421: Fixed compression in tarfile CLI.  Patch by wdv4758h.

* bpo-23367: Fix possible overflows in the unicodedata module.

* bpo-23361: Fix possible overflow in Windows subprocess creation
  code.

* bpo-23801: Fix issue where cgi.FieldStorage did not always ignore
  the entire preamble to a multipart body.

* bpo-23310: Fix MagicMock's initializer to work with __methods__,
  just like configure_mock().  Patch by Kasia Jachim.

* asyncio: New event loop APIs: set_task_factory() and
  get_task_factory().

* asyncio: async() function is deprecated in favour of
  ensure_future().

* bpo-23898: Fix inspect.classify_class_attrs() to support
  attributes with overloaded __eq__ and __bool__.  Patch by Mike
  Bayer.

* bpo-24298: Fix inspect.signature() to correctly unwrap wrappers
  around bound methods.

* bpo-23572: Fixed functools.singledispatch on classes with falsy
  metaclasses.  Patch by Ethan Furman.


IDLE
----

* bpo-15348: Stop the debugger engine (normally in a user process)
  before closing the debugger window (running in the IDLE process).
  This prevents the RuntimeErrors that were being caught and ignored.

* bpo-24455: Prevent IDLE from hanging when a) closing the shell
  while the debugger is active (15347); b) closing the debugger with
  the [X] button (15348); and c) activating the debugger when already
  active (24455). The patch by Mark Roseman does this by making two
  changes. 1. Suspend and resume the gui.interaction method with the
  tcl vwait mechanism intended for this purpose (instead of
  root.mainloop & .quit). 2. In gui.run, allow any existing
  interaction to terminate first.

* Change 'The program' to 'Your program' in an IDLE 'kill program?'
  message to make it clearer that the program referred to is the
  currently running user program, not IDLE itself.

* bpo-24750: Improve the appearance of the IDLE editor window status
  bar. Patch by Mark Roseman.

* bpo-25313: Change the handling of new built-in text color themes
  to better address the compatibility problem introduced by the
  addition of IDLE Dark. Consistently use the revised
  idleConf.CurrentTheme everywhere in idlelib.

* bpo-24782: Extension configuration is now a tab in the IDLE
  Preferences dialog rather than a separate dialog.   The former tabs
  are now a sorted list.  Patch by Mark Roseman.

* bpo-22726: Re-activate the config dialog help button with some
  content about the other buttons and the new IDLE Dark theme.

* bpo-24820: IDLE now has an 'IDLE Dark' built-in text color theme.
  It is more or less IDLE Classic inverted, with a cobalt blue
  background. Strings, comments, keywords, ... are still green, red,
  orange, ... . To use it with IDLEs released before November 2015,
  hit the 'Save as New Custom Theme' button and enter a new name, such
  as 'Custom Dark'.  The custom theme will work with any IDLE release,
  and can be modified.

* bpo-25224: README.txt is now an idlelib index for IDLE developers
  and curious users. The previous user content is now in the IDLE doc
  chapter. 'IDLE' now means 'Integrated Development and Learning
  Environment'.

* bpo-24820: Users can now set breakpoint colors in Settings ->
  Custom Highlighting. Original patch by Mark Roseman.

* bpo-24972: Inactive selection background now matches active
  selection background, as configured by users, on all systems.  Found
  items are now always highlighted on Windows.  Initial patch by Mark
  Roseman.

* bpo-24570: Idle: make calltip and completion boxes appear on Macs
  affected by a tk regression.  Initial patch by Mark Roseman.

* bpo-24988: Idle ScrolledList context menus (used in debugger) now
  work on Mac Aqua. Patch by Mark Roseman.

* bpo-24801: Make right-click for context menu work on Mac Aqua.
  Patch by Mark Roseman.

* bpo-25173: Associate tkinter messageboxes with a specific widget.
  For Mac OSX, make them a 'sheet'.  Patch by Mark Roseman.

* bpo-25198: Enhance the initial html viewer now used for Idle Help.
  * Properly indent fixed-pitch text (patch by Mark Roseman). * Give
  code snippet a very Sphinx- like light blueish-gray background. *
  Re-use initial width and height set by users for shell and editor. *
  When the Table of Contents (TOC) menu is used, put the section
  header at the top of the screen.

* bpo-25225: Condense and rewrite Idle doc section on text colors.

* bpo-21995: Explain some differences between IDLE and console
  Python.

* bpo-22820: Explain need for *print* when running file from Idle
  editor.

* bpo-25224: Doc: augment Idle feature list and no-subprocess
  section.

* bpo-25219: Update doc for Idle command line options. Some were
  missing and notes were not correct.

* bpo-24861: Most of idlelib is private and subject to change. Use
  idleib.idle.* to start Idle. See idlelib.__init__.__doc__.

* bpo-25199: Idle: add synchronization comments for future
  maintainers.

* bpo-16893: Replace help.txt with help.html for Idle doc display.
  The new idlelib/help.html is rstripped
  Doc/build/html/library/idle.html. It looks better than help.txt and
  will better document Idle as released. The tkinter html viewer that
  works for this file was written by Mark Roseman. The now unused
  EditorWindow.HelpDialog class and helt.txt file are deprecated.

* bpo-24199: Deprecate unused idlelib.idlever with possible removal
  in 3.6.

* bpo-24790: Remove extraneous code (which also create 2 & 3
  conflicts).

* bpo-23672: Allow Idle to edit and run files with astral chars in
  name. Patch by Mohd Sanad Zaki Rizvi.

* bpo-24745: Idle editor default font. Switch from Courier to
  platform-sensitive TkFixedFont.  This should not affect current
  customized font selections.  If there is a problem, edit
  $HOME/.idlerc/config-main.cfg and remove 'fontxxx' entries from
  [Editor Window].  Patch by Mark Roseman.

* bpo-21192: Idle editor. When a file is run, put its name in the
  restart bar. Do not print false prompts. Original patch by Adnan
  Umer.

* bpo-13884: Idle menus. Remove tearoff lines. Patch by Roger Serwy.

* bpo-23184: remove unused names and imports in idlelib. Initial
  patch by Al Sweigart.


Tests
-----

* bpo-25616: Tests for OrderedDict are extracted from
  test_collections into separate file test_ordered_dict.

* bpo-25099: Make test_compileall not fail when an entry on sys.path
  cannot be written to (commonly seen in administrative installs on
  Windows).

* bpo-24751: When running regrtest with the "-w" command line
  option, a test run is no longer marked as a failure if all tests
  succeed when re-run.

* bpo-21520: test_zipfile no longer fails if the word 'bad' appears
  anywhere in the name of the current directory.

* bpo-23799: Added test.support.start_threads() for running and
  cleaning up multiple threads.

* bpo-22390: test.regrtest now emits a warning if temporary files or
  directories are left after running a test.

* bpo-23583: Added tests for standard IO streams in IDLE.


Build
-----

* bpo-23445: pydebug builds now use "gcc -Og" where possible, to
  make the resulting executable faster.

* bpo-24603: Update Windows builds to use OpenSSL1.0.2d and OS X
  10.5 installer to use OpenSSL 1.0.2e.


C API
-----

* bpo-23998: PyImport_ReInitLock() now checks for lock allocation
  error


Documentation
-------------

* bpo-12067: Rewrite Comparisons section in the Expressions chapter
  of the language reference. Some of the details of comparing mixed
  types were incorrect or ambiguous. NotImplemented is only relevant
  at a lower level than the Expressions chapter. Added details of
  comparing range() objects, and default behaviour and consistency
  suggestions for user-defined classes. Patch from Andy Maier.

* bpo-24952: Clarify the default size argument of stack_size() in
  the "threading" and "_thread" modules. Patch from Mattip.

* bpo-24808: Update the types of some PyTypeObject fields. Patch by
  Joseph Weston.

* bpo-22812: Fix unittest discovery examples. Patch from Pam
  McA'Nulty.

* bpo-24129: Clarify the reference documentation for name
  resolution. This includes removing the assumption that readers will
  be familiar with the name resolution scheme Python used prior to the
  introduction of lexical scoping for function namespaces. Patch by
  Ivan Levkivskyi.

* bpo-20769: Improve reload() docs. Patch by Dorian Pula.

* bpo-23589: Remove duplicate sentence from the FAQ.  Patch by
  Yongzhi Pan.

* bpo-24729: Correct IO tutorial to match implementation regarding
  encoding parameter to open function.

* bpo-24351: Clarify what is meant by "identifier" in the context of
  string.Template instances.

* bpo-22155: Add File Handlers subsection with createfilehandler to
  tkinter doc.  Remove obsolete example from FAQ.  Patch by Martin
  Panter.

* bpo-24029: Document the name binding behavior for submodule
  imports.

* bpo-24077: Fix typo in man page for -I command option: -s, not -S.


Tools/Demos
-----------

* bpo-25440: Fix output of python-config --extension-suffix.

* bpo-23330: h2py now supports arbitrary filenames in #include.

* bpo-24031: make patchcheck now supports git checkouts, too.


Windows
-------

* bpo-24306: Sets component ID for launcher to match 3.5 and later
  to avoid downgrading.

* bpo-25022: Removed very outdated PC/example_nt/ directory.


Python 3.4.3 final
==================

*Release date: 2015-02-23*


Core and Builtins
-----------------

* bpo-22735: Fix many edge cases (including crashes) involving
  custom mro() implementations.

* bpo-22896: Avoid using PyObject_AsCharBuffer(),
  PyObject_AsReadBuffer() and PyObject_AsWriteBuffer().

* bpo-21295: Revert some changes (issue #16795) to AST line numbers
  and column offsets that constituted a regression.

* bpo-21408: The default __ne__() now returns NotImplemented if
  __eq__() returned NotImplemented.  Original patch by Martin Panter.

* bpo-23321: Fixed a crash in str.decode() when error handler
  returned replacment string longer than mailformed input data.

* bpo-23048: Fix jumping out of an infinite while loop in the pdb.

* bpo-20335: bytes constructor now raises TypeError when encoding or
  errors is specified with non-string argument.  Based on patch by
  Renaud Blanch.

* bpo-22335: Fix crash when trying to enlarge a bytearray to
  0x7fffffff bytes on a 32-bit platform.

* bpo-22653: Fix an assertion failure in debug mode when doing a
  reentrant dict insertion in debug mode.

* bpo-22643: Fix integer overflow in Unicode case operations (upper,
  lower, title, swapcase, casefold).

* bpo-22604: Fix assertion error in debug mode when dividing a
  complex number by (nan+0j).

* bpo-22470: Fixed integer overflow issues in "backslashreplace",
  "xmlcharrefreplace", and "surrogatepass" error handlers.

* bpo-22520: Fix overflow checking when generating the repr of a
  unicode object.

* bpo-22519: Fix overflow checking in PyBytes_Repr.

* bpo-22518: Fix integer overflow issues in latin-1 encoding.

* bpo-23165: Perform overflow checks before allocating memory in the
  _Py_char2wchar function.


Library
-------

* bpo-23399: pyvenv creates relative symlinks where possible.

* bpo-23099: Closing io.BytesIO with exported buffer is rejected now
  to prevent corrupting exported buffer.

* bpo-23363: Fix possible overflow in itertools.permutations.

* bpo-23364: Fix possible overflow in itertools.product.

* bpo-23366: Fixed possible integer overflow in
  itertools.combinations.

* bpo-23369: Fixed possible integer overflow in
  _json.encode_basestring_ascii.

* bpo-23353: Fix the exception handling of generators in
  PyEval_EvalFrameEx(). At entry, save or swap the exception state
  even if PyEval_EvalFrameEx() is called with throwflag=0. At exit,
  the exception state is now always restored or swapped, not only if
  why is WHY_YIELD or WHY_RETURN. Patch co-written with Antoine
  Pitrou.

* bpo-18518: timeit now rejects statements which can't be compiled
  outside a function or a loop (e.g. "return" or "break").

* bpo-23094: Fixed readline with frames in Python implementation of
  pickle.

* bpo-23268: Fixed bugs in the comparison of ipaddress classes.

* bpo-21408: Removed incorrect implementations of __ne__() which
  didn't returned NotImplemented if __eq__() returned NotImplemented.
  The default __ne__() now works correctly.

* bpo-19996: "email.feedparser.FeedParser" now handles (malformed)
  headers with no key rather than assuming the body has started.

* bpo-23248: Update ssl error codes from latest OpenSSL git master.

* bpo-23098: 64-bit dev_t is now supported in the os module.

* bpo-23250: In the http.cookies module, capitalize "HttpOnly" and
  "Secure" as they are written in the standard.

* bpo-23063: In the disutils' check command, fix parsing of reST
  with code or code-block directives.

* bpo-23209: selectors.BaseSelector.close() now clears its internal
  reference to the selector mapping to break a reference cycle.
  Initial patch written by Martin Richard. (See also: bpo-23225)

* bpo-21356: Make ssl.RAND_egd() optional to support LibreSSL. The
  availability of the function is checked during the compilation.
  Patch written by Bernard Spil.

* bpo-20896: The "ssl.get_server_certificate()" function now uses
  the "PROTOCOL_SSLv23" protocol by default, not "PROTOCOL_SSLv3", for
  maximum compatibility and support platforms where "PROTOCOL_SSLv3"
  support is disabled. (See also: bpo-22935)

* bpo-23111: In the ftplib, make ssl.PROTOCOL_SSLv23 the default
  protocol version.

* bpo-23132: Mitigate regression in speed and clarity in
  functools.total_ordering.

* bpo-22585: On OpenBSD 5.6 and newer, os.urandom() now calls
  getentropy(), instead of reading /dev/urandom, to get pseudo-random
  bytes.

* bpo-23112: Fix SimpleHTTPServer to correctly carry the query
  string and fragment when it redirects to add a trailing slash.

* bpo-23093: In the io, module allow more operations to work on
  detached streams.

* bpo-19104: pprint now produces evaluable output for wrapped
  strings.

* bpo-23071: Added missing names to codecs.__all__.  Patch by Martin
  Panter.

* bpo-15513: Added a __sizeof__ implementation for pickle classes.

* bpo-19858: pickletools.optimize() now aware of the MEMOIZE opcode,
  can produce more compact result and no longer produces invalid
  output if input data contains MEMOIZE opcodes together with PUT or
  BINPUT opcodes.

* bpo-22095: Fixed HTTPConnection.set_tunnel with default port.  The
  port value in the host header was set to "None".  Patch by Demian
  Brecht.

* bpo-23016: A warning no longer produces an AttributeError when the
  program is run with pythonw.exe.

* bpo-21775: shutil.copytree(): fix crash when copying to VFAT. An
  exception handler assumed that that OSError objects always have a
  'winerror' attribute. That is not the case, so the exception handler
  itself raised AttributeError when run on Linux (and, presumably, any
  other non-Windows OS). Patch by Greg Ward.

* bpo-1218234: Fix inspect.getsource() to load updated source of
  reloaded module. Initial patch by Berker Peksag.

* bpo-22959: In the constructor of http.client.HTTPSConnection,
  prefer the context's check_hostname attribute over the
  *check_hostname* parameter.

* bpo-16043: Add a default limit for the amount of data
  xmlrpclib.gzip_decode will return. This resolves CVE-2013-1753.

* bpo-22966: Fix __pycache__ pyc file name clobber when pyc_compile
  is asked to compile a source file containing multiple dots in the
  source file name.

* bpo-21971: Update turtledemo doc and add module to the index.

* bpo-21032: Fixed socket leak if HTTPConnection.getresponse()
  fails. Original patch by Martin Panter.

* bpo-22960: Add a context argument to xmlrpclib.ServerProxy
  constructor.

* bpo-22915: SAX parser now supports files opened with file
  descriptor or bytes path.

* bpo-22609: Constructors and update methods of mapping classes in
  the collections module now accept the self keyword argument.

* bpo-22788: Add *context* parameter to
  logging.handlers.HTTPHandler.

* bpo-22921: Allow SSLContext to take the *hostname* parameter even
  if OpenSSL doesn't support SNI.

* bpo-22894: TestCase.subTest() would cause the test suite to be
  stopped when in failfast mode, even in the absence of failures.

* bpo-22638: SSLv3 is now disabled throughout the standard library.
  It can still be enabled by instantiating a SSLContext manually.

* bpo-22370: Windows detection in pathlib is now more robust.

* bpo-22841: Reject coroutines in asyncio add_signal_handler().
  Patch by Ludovic.Gasc.

* bpo-22849: Fix possible double free in the io.TextIOWrapper
  constructor.

* bpo-12728: Different Unicode characters having the same uppercase
  but different lowercase are now matched in case-insensitive regular
  expressions.

* bpo-22821: Fixed fcntl() with integer argument on 64-bit big-
  endian platforms.

* bpo-22406: Fixed the uu_codec codec incorrectly ported to 3.x.
  Based on patch by Martin Panter.

* bpo-17293: uuid.getnode() now determines MAC address on AIX using
  netstat. Based on patch by Aivars Kalvāns.

* bpo-22769: Fixed ttk.Treeview.tag_has() when called without
  arguments.

* bpo-22417: Verify certificates by default in httplib (PEP 476).

* bpo-22775: Fixed unpickling of http.cookies.SimpleCookie with
  protocol 2 and above. Patch by Tim Graham.

* bpo-22366: urllib.request.urlopen will accept a context object
  (SSLContext) as an argument which will then used be for HTTPS
  connection. Patch by Alex Gaynor.

* bpo-22776: Brought excluded code into the scope of a try block in
  SysLogHandler.emit().

* bpo-22665: Add missing get_terminal_size and SameFileError to
  shutil.__all__.

* bpo-17381: Fixed handling of case-insensitive ranges in regular
  expressions.

* bpo-22410: Module level functions in the re module now cache
  compiled locale-dependent regular expressions taking into account
  the locale.

* bpo-22759: Query methods on pathlib.Path() (exists(), is_dir(),
  etc.) now return False when the underlying stat call raises
  NotADirectoryError.

* bpo-8876: distutils now falls back to copying files when hard
  linking doesn't work. This allows use with special filesystems such
  as VirtualBox shared folders.

* bpo-18853: Fixed ResourceWarning in shlex.__nain__.

* bpo-9351: Defaults set with set_defaults on an argparse subparser
  are no longer ignored when also set on the parent parser.

* bpo-21991: Make email.headerregistry's header 'params' attributes
  be read-only (MappingProxyType).  Previously the dictionary was
  modifiable but a new one was created on each access of the
  attribute.

* bpo-22641: In asyncio, the default SSL context for client
  connections is now created using ssl.create_default_context(), for
  stronger security.

* bpo-22435: Fix a file descriptor leak when SocketServer bind
  fails.

* bpo-13096: Fixed segfault in CTypes POINTER handling of large
  values.

* bpo-11694: Raise ConversionError in xdrlib as documented.  Patch
  by Filip Gruszczyński and Claudiu Popa.

* bpo-22462: Fix pyexpat's creation of a dummy frame to make it
  appear in exception tracebacks.

* bpo-21173: Fix len() on a WeakKeyDictionary when .clear() was
  called with an iterator alive.

* bpo-11866: Eliminated race condition in the computation of names
  for new threads.

* bpo-21905: Avoid RuntimeError in pickle.whichmodule() when
  sys.modules is mutated while iterating.  Patch by Olivier Grisel.

* bpo-22219: The zipfile module CLI now adds entries for directories
  (including empty directories) in ZIP file.

* bpo-22449: In the ssl.SSLContext.load_default_certs, consult the
  environmental variables SSL_CERT_DIR and SSL_CERT_FILE on Windows.

* bpo-20076: Added non derived UTF-8 aliases to locale aliases
  table.

* bpo-20079: Added locales supported in glibc 2.18 to locale alias
  table.

* bpo-22396: On 32-bit AIX platform, don't expose os.posix_fadvise()
  nor os.posix_fallocate() because their prototypes in system headers
  are wrong.

* bpo-22517: When a io.BufferedRWPair object is deallocated, clear
  its weakrefs.

* bpo-22448: Improve canceled timer handles cleanup to prevent
  unbound memory usage. Patch by Joshua Moore-Oliva.

* bpo-23009: Make sure selectors.EpollSelecrtor.select() works when
  no FD is registered.


IDLE
----

* bpo-20577: Configuration of the max line length for the
  FormatParagraph extension has been moved from the General tab of the
  Idle preferences dialog to the FormatParagraph tab of the Config
  Extensions dialog. Patch by Tal Einat.

* bpo-16893: Update Idle doc chapter to match current Idle and add
  new information.

* bpo-3068: Add Idle extension configuration dialog to Options menu.
  Changes are written to HOME/.idlerc/config-extensions.cfg. Original
  patch by Tal Einat.

* bpo-16233: A module browser (File : Class Browser, Alt+C) requires
  an editor window with a filename.  When Class Browser is requested
  otherwise, from a shell, output window, or 'Untitled' editor, Idle
  no longer displays an error box. It now pops up an Open Module box
  (Alt+M). If a valid name is entered and a module is opened, a
  corresponding browser is also opened.

* bpo-4832: Save As to type Python files automatically adds .py to
  the name you enter (even if your system does not display it).  Some
  systems automatically add .txt when type is Text files.

* bpo-21986: Code objects are not normally pickled by the pickle
  module. To match this, they are no longer pickled when running under
  Idle.

* bpo-23180: Rename IDLE "Windows" menu item to "Window". Patch by
  Al Sweigart.


Tests
-----

* bpo-23392: Added tests for marshal C API that works with FILE*.

* bpo-18982: Add tests for CLI of the calendar module.

* bpo-19548: Added some additional checks to test_codecs to ensure
  that statements in the updated documentation remain accurate. Patch
  by Martin Panter.

* bpo-22838: All test_re tests now work with unittest test
  discovery.

* bpo-22173: Update lib2to3 tests to use unittest test discovery.

* bpo-16000: Convert test_curses to use unittest.

* bpo-21456: Skip two tests in test_urllib2net.py if _ssl module not
  present. Patch by Remi Pointel.

* bpo-22770: Prevent some Tk segfaults on OS X when running gui
  tests.

* bpo-23211: Workaround test_logging failure on some OS X 10.6
  systems.

* bpo-23345: Prevent test_ssl failures with large OpenSSL patch
  level values (like 0.9.8zc).

* bpo-22289: Prevent test_urllib2net failures due to ftp connection
  timeout.


Build
-----

* bpo-15506: Use standard PKG_PROG_PKG_CONFIG autoconf macro in the
  configure script.

* bpo-22935: Allow the ssl module to be compiled if openssl doesn't
  support SSL 3.

* bpo-16537: Check whether self.extensions is empty in setup.py.
  Patch by Jonathan Hosmer.

* bpo-18096: Fix library order returned by python-config.

* bpo-17219: Add library build dir for Python extension cross-
  builds.

* bpo-17128: Use private version of OpenSSL for 3.4.3 OS X 10.5+
  installer.


C API
-----

* bpo-22079: PyType_Ready() now checks that statically allocated
  type has no dynamically allocated bases.


Documentation
-------------

* bpo-19548: Update the codecs module documentation to better cover
  the distinction between text encodings and other codecs, together
  with other clarifications. Patch by Martin Panter.

* bpo-22914: Update the Python 2/3 porting HOWTO to describe a more
  automated approach.

* bpo-21514: The documentation of the json module now refers to new
  JSON RFC 7159 instead of obsoleted RFC 4627.


Tools/Demos
-----------

* bpo-22314: pydoc now works when the LINES environment variable is
  set.


Windows
-------

* bpo-17896: The Windows build scripts now expect external library
  sources to be in "PCbuild\..\externals" rather than "PCbuild\..\..".

* bpo-17717: The Windows build scripts now use a copy of NASM pulled
  from svn.python.org to build OpenSSL.

* bpo-22644: The bundled version of OpenSSL has been updated to
  1.0.1j.


Python 3.4.2 final
==================

*Release date: 2014-10-06*


Library
-------

* bpo-10510: distutils register and upload methods now use HTML
  standards compliant CRLF line endings.

* bpo-9850: Fixed macpath.join() for empty first component.  Patch
  by Oleg Oshmyan.

* bpo-22427: TemporaryDirectory no longer attempts to clean up twice
  when used in the with statement in generator.

* bpo-20912: Now directories added to ZIP file have correct Unix and
  MS-DOS directory attributes.

* bpo-21866: ZipFile.close() no longer writes ZIP64 central
  directory records if allowZip64 is false.

* bpo-22415: Fixed debugging output of the GROUPREF_EXISTS opcode in
  the re module. Removed trailing spaces in debugging output.

* bpo-22423: Unhandled exception in thread no longer causes
  unhandled AttributeError when sys.stderr is None.

* bpo-21332: Ensure that "bufsize=1" in subprocess.Popen() selects
  line buffering, rather than block buffering.  Patch by Akira Li.


Python 3.4.2 release candidate 1
================================

*Release date: 2014-09-22*


Core and Builtins
-----------------

* bpo-22258: Fix the the internal function set_inheritable() on
  Illumos. This platform exposes the function "ioctl(FIOCLEX)", but
  calling it fails with errno is ENOTTY: "Inappropriate ioctl for
  device". set_inheritable() now falls back to the slower "fcntl()"
  ("F_GETFD" and then "F_SETFD").

* bpo-21669: With the aid of heuristics in SyntaxError.__init__, the
  parser now attempts to generate more meaningful (or at least more
  search engine friendly) error messages when "exec" and "print" are
  used as statements.

* bpo-21642: In the conditional if-else expression, allow an integer
  written with no space between itself and the "else" keyword (e.g.
  "True if 42else False") to be valid syntax.

* bpo-21523: Fix over-pessimistic computation of the stack effect of
  some opcodes in the compiler.  This also fixes a quadratic
  compilation time issue noticeable when compiling code with a large
  number of "and" and "or" operators.


Library
-------

* bpo-21091: Fix API bug: email.message.EmailMessage.is_attachment
  is now a method. Since EmailMessage is provisional, we can change
  the API in a maintenance release, but we use a trick to remain
  backward compatible with 3.4.0/1.

* bpo-21079: Fix email.message.EmailMessage.is_attachment to return
  the correct result when the header has parameters as well as a
  value.

* bpo-22247: Add NNTPError to nntplib.__all__.

* bpo-4180: The warnings registries are now reset when the filters
  are modified.

* bpo-22419: Limit the length of incoming HTTP request in wsgiref
  server to 65536 bytes and send a 414 error code for higher lengths.
  Patch contributed by Devin Cook.

* Lax cookie parsing in http.cookies could be a security issue when
  combined with non-standard cookie handling in some Web browsers.
  Reported by Sergey Bobrov.

* bpo-22384: An exception in Tkinter callback no longer crashes the
  program when it is run with pythonw.exe.

* bpo-22168: Prevent turtle AttributeError with non-default Canvas
  on OS X.

* bpo-21147: sqlite3 now raises an exception if the request contains
  a null character instead of truncate it.  Based on patch by Victor
  Stinner.

* bpo-21951: Fixed a crash in Tkinter on AIX when called Tcl command
  with empty string or tuple argument.

* bpo-21951: Tkinter now most likely raises MemoryError instead of
  crash if the memory allocation fails.

* bpo-22338: Fix a crash in the json module on memory allocation
  failure.

* bpo-22226: First letter no longer is stripped from the "status"
  key in the result of Treeview.heading().

* bpo-19524: Fixed resource leak in the HTTP connection when an
  invalid response is received.  Patch by Martin Panter.

* bpo-22051: turtledemo no longer reloads examples to re-run them.
  Initialization of variables and gui setup should be done in main(),
  which is called each time a demo is run, but not on import.

* bpo-21933: Turtledemo users can change the code font size with a
  menu selection or control(command) '-' or '+' or control-mousewheel.
  Original patch by Lita Cho.

* bpo-21597: The separator between the turtledemo text pane and the
  drawing canvas can now be grabbed and dragged with a mouse.  The
  code text pane can be widened to easily view or copy the full width
  of the text.  The canvas can be widened on small screens.  Original
  patches by Jan Kanis and Lita Cho.

* bpo-18132: Turtledemo buttons no longer disappear when the window
  is shrunk.  Original patches by Jan Kanis and Lita Cho.

* bpo-22216: smtplib now resets its state more completely after a
  quit.  The most obvious consequence of the previous behavior was a
  STARTTLS failure during a connect/starttls/quit/connect/starttls
  sequence.

* bpo-22185: Fix an occasional RuntimeError in
  threading.Condition.wait() caused by mutation of the waiters queue
  without holding the lock.  Patch by Doug Zongker.

* bpo-22182: Use e.args to unpack exceptions correctly in
  distutils.file_util.move_file. Patch by Claudiu Popa.

* The webbrowser module now uses subprocess's start_new_session=True
  rather than a potentially risky preexec_fn=os.setsid call.

* bpo-22236: Fixed Tkinter images copying operations in
  NoDefaultRoot mode.

* bpo-22191: Fix warnings.__all__.

* bpo-15696: Add a __sizeof__ implementation for mmap objects on
  Windows.

* bpo-22068: Avoided reference loops with Variables and Fonts in
  Tkinter.

* bpo-22165: SimpleHTTPRequestHandler now supports undecodable file
  names.

* bpo-8797: Raise HTTPError on failed Basic Authentication
  immediately. Initial patch by Sam Bull.

* bpo-20729: Restored the use of lazy
  iterkeys()/itervalues()/iteritems() in the mailbox module.

* bpo-21448: Changed FeedParser feed() to avoid O(N**2) behavior
  when parsing long line. Original patch by Raymond Hettinger.

* bpo-22184: The functools LRU Cache decorator factory now gives an
  earlier and clearer error message when the user forgets the required
  parameters.

* bpo-17923: glob() patterns ending with a slash no longer match
  non- dirs on AIX.  Based on patch by Delhallt.

* bpo-21121: Don't force 3rd party C extensions to be built with
  -Werror=declaration- after-statement.

* bpo-21975: Fixed crash when using uninitialized sqlite3.Row (in
  particular when unpickling pickled sqlite3.Row).  sqlite3.Row is now
  initialized in the __new__() method.

* bpo-21580: Now Tkinter correctly handles bytes arguments passed to
  Tk. In particular this allows to initialize images from binary data.

* bpo-17172: Make turtledemo start as active on OS X even when run
  with subprocess. Patch by Lita Cho.

* bpo-21704: Fix build error for _multiprocessing when semaphores
  are not available. Patch by Arfrever Frehtes Taifersar Arahesis.

* Fix repr(_socket.socket) on Windows 64-bit: don't fail with
  OverflowError on closed socket. repr(socket.socket) already works
  fine.

* bpo-16133: The asynchat.async_chat.handle_read() method now
  ignores BlockingIOError exceptions.

* bpo-22044: Fixed premature DECREF in call_tzinfo_method. Patch by
  Tom Flanagan.

* bpo-19884: readline: Disable the meta modifier key if stdout is
  not a terminal to not write the ANSI sequence "033[1034h" into
  stdout. This sequence is used on some terminal (ex: TERM=xterm-
  256color") to enable support of 8 bit characters.

* bpo-21888: plistlib's load() and loads() now work if the fmt
  parameter is specified.

* bpo-21044: tarfile.open() now handles fileobj with an integer
  'name' attribute.  Based on patch by Antoine Pietri.

* bpo-21867: Prevent turtle crash due to invalid undo buffer size.

* bpo-19076: Don't pass the redundant 'file' argument to
  self.error().

* bpo-21942: Fixed source file viewing in pydoc's server mode on
  Windows.

* bpo-11259: asynchat.async_chat().set_terminator() now raises a
  ValueError if the number of received bytes is negative.

* bpo-12523: asynchat.async_chat.push() now raises a TypeError if it
  doesn't get a bytes string

* bpo-21707: Add missing kwonlyargcount argument to
  ModuleFinder.replace_paths_in_code().

* bpo-20639: calling Path.with_suffix('') allows removing the suffix
  again. Patch by July Tikhonov.

* bpo-21714: Disallow the construction of invalid paths using
  Path.with_name().  Original patch by Antony Lee.

* bpo-21897: Fix a crash with the f_locals attribute with closure
  variables when frame.clear() has been called.

* bpo-21151: Fixed a segfault in the winreg module when "None" is
  passed as a "REG_BINARY" value to SetValueEx.  Patch by John
  Ehresman.

* bpo-21090: io.FileIO.readall() does not ignore I/O errors anymore.
  Before, it ignored I/O errors if at least the first C call read()
  succeed.

* bpo-21781: ssl.RAND_add() now supports strings longer than 2 GB.

* bpo-11453: asyncore: emit a ResourceWarning when an unclosed
  file_wrapper object is destroyed. The destructor now closes the file
  if needed. The close() method can now be called twice: the second
  call does nothing.

* bpo-21858: Better handling of Python exceptions in the sqlite3
  module.

* bpo-21476: Make sure the email.parser.BytesParser TextIOWrapper is
  discarded after parsing, so the input file isn't unexpectedly
  closed.

* bpo-21729: Used the "with" statement in the dbm.dumb module to
  ensure files closing. Patch by Claudiu Popa.

* bpo-21491: socketserver: Fix a race condition in child processes
  reaping.

* bpo-21832: Require named tuple inputs to be exact strings.

* bpo-19145: The times argument for itertools.repeat now handles
  negative values the same way for keyword arguments as it does for
  positional arguments.

* bpo-21812: turtle.shapetransform did not tranform the turtle on
  the first call.  (Issue identified and fixed by Lita Cho.)

* bpo-21635: The difflib SequenceMatcher.get_matching_blocks()
  method cache didn't match the actual result.  The former was a list
  of tuples and the latter was a list of named tuples.

* bpo-21722: The distutils "upload" command now exits with a non-
  zero return code when uploading fails.  Patch by Martin Dengler.

* bpo-21723: asyncio.Queue: support any type of number (ex: float)
  for the maximum size. Patch written by Vajrasky Kok.

* bpo-21326: Add a new is_closed() method to asyncio.BaseEventLoop.
  run_forever() and run_until_complete() methods of
  asyncio.BaseEventLoop now raise an exception if the event loop was
  closed.

* bpo-21774: Fixed NameError for an incorrect variable reference in
  the XML Minidom code for creating processing instructions. (Found
  and fixed by Claudiu Popa.)

* bpo-21766: Prevent a security hole in CGIHTTPServer by URL
  unquoting paths before checking for a CGI script at that path.

* bpo-21310: Fixed possible resource leak in failed open().

* bpo-21677: Fixed chaining nonnormalized exceptions in io close()
  methods.

* bpo-11709: Fix the pydoc.help function to not fail when sys.stdin
  is not a valid file.

* bpo-13223: Fix pydoc.writedoc so that the HTML documentation for
  methods that use 'self' in the example code is generated correctly.

* bpo-21463: In urllib.request, fix pruning of the FTP cache.

* bpo-21618: The subprocess module could fail to close open fds that
  were inherited by the calling process and already higher than POSIX
  resource limits would otherwise allow.  On systems with a
  functioning /proc/self/fd or /dev/fd interface the max is now
  ignored and all fds are closed.

* bpo-21552: Fixed possible integer overflow of too long string
  lengths in the tkinter module on 64-bit platforms.

* bpo-14315: The zipfile module now ignores extra fields in the
  central directory that are too short to be parsed instead of letting
  a struct.unpack error bubble up as this "bad data" appears in many
  real world zip files in the wild and is ignored by other zip tools.

* bpo-21402: tkinter.ttk now works when default root window is not
  set.

* bpo-10203: sqlite3.Row now truly supports sequence protocol.  In
  particular it supports reverse() and negative indices.  Original
  patch by Claudiu Popa.

* bpo-18807: If copying (no symlinks) specified for a venv, then the
  python interpreter aliases (python, python3) are now created by
  copying rather than symlinking.

* bpo-14710: pkgutil.get_loader() no longer raises an exception when
  None is found in sys.modules.

* bpo-14710: pkgutil.find_loader() no longer raises an exception
  when a module doesn't exist.

* bpo-21481: Argparse equality and inequality tests now return
  NotImplemented when comparing to an unknown type.

* bpo-8743: Fix interoperability between set objects and the
  collections.Set() abstract base class.

* bpo-13355: random.triangular() no longer fails with a
  ZeroDivisionError when low equals high.

* bpo-21538: The plistlib module now supports loading of binary
  plist files when reference or offset size is not a power of two.

* bpo-21801: Validate that __signature__ is None or an instance of
  Signature.

* bpo-21923: Prevent AttributeError in
  distutils.sysconfig.customize_compiler due to possible uninitialized
  _config_vars.

* bpo-21323: Fix http.server to again handle scripts in CGI
  subdirectories, broken by the fix for security issue #19435.  Patch
  by Zach Byrne.

* bpo-22176: Update the ctypes module's libffi to v3.1.  This
  release adds support for the Linux AArch64 and POWERPC ELF ABIv2
  little endian architectures.


Build
-----

* bpo-15661: python.org OS X installers are now distributed as
  signed installer packages compatible with the Gatekeeper security
  feature.

* bpo-21958: Define HAVE_ROUND when building with Visual Studio 2013
  and above.  Patch by Zachary Turner.

* bpo-15759: "make suspicious", "make linkcheck" and "make doctest"
  in Doc/ now display special message when and only when there are
  failures.

* bpo-17095: Fix Modules/Setup *shared* support.

* bpo-21811: Anticipated fixes to support OS X versions > 10.9.

* bpo-21166: Prevent possible segfaults and other random failures of
  python --generate- posix-vars in pybuilddir.txt build target.


IDLE
----

* bpo-17390: Adjust Editor window title; remove 'Python', move
  version to end.

* bpo-14105: Idle debugger breakpoints no longer disappear when
  inseting or deleting lines.

* bpo-17172: Turtledemo can now be run from Idle. Currently, the
  entry is on the Help menu, but it may move to Run. Patch by
  Ramchandra Apt and Lita Cho.

* bpo-21765: Add support for non-ascii identifiers to HyperParser.

* bpo-21940: Add unittest for WidgetRedirector. Initial patch by
  Saimadhav Heblikar.

* bpo-18592: Add unittest for SearchDialogBase. Patch by Phil
  Webster.

* bpo-21694: Add unittest for ParenMatch. Patch by Saimadhav
  Heblikar.

* bpo-21686: add unittest for HyperParser. Original patch by
  Saimadhav Heblikar.

* bpo-12387: Add missing upper(lower)case versions of default
  Windows key bindings for Idle so Caps Lock does not disable them.
  Patch by Roger Serwy.

* bpo-21695: Closing a Find-in-files output window while the search
  is still in progress no longer closes Idle.

* bpo-18910: Add unittest for textView. Patch by Phil Webster.

* bpo-18292: Add unittest for AutoExpand. Patch by Saihadhav
  Heblikar.

* bpo-18409: Add unittest for AutoComplete. Patch by Phil Webster.


Tests
-----

* bpo-22166: With the assistance of a new internal
  _codecs._forget_codec helping function, test_codecs now clears the
  encoding caches to avoid the appearance of a reference leak

* bpo-22236: Tkinter tests now don't reuse default root window.  New
  root window is created for every test class.

* bpo-20746: Fix test_pdb to run in refleak mode (-R).  Patch by
  Xavier de Gaye.

* bpo-22060: test_ctypes has been somewhat cleaned up and
  simplified; it now uses unittest test discovery to find its tests.

* bpo-22104: regrtest.py no longer holds a reference to the suite of
  tests loaded from test modules that don't define test_main().

* bpo-22002: Added "load_package_tests" function to test.support and
  used it to implement/augment test discovery in test_asyncio,
  test_email, test_importlib, test_json, and test_tools.

* bpo-21976: Fix test_ssl to accept LibreSSL version strings.
  Thanks to William Orr.

* bpo-21918: Converted test_tools from a module to a package
  containing separate test files for each tested script.

* bpo-20155: Changed HTTP method names in failing tests in
  test_httpservers so that packet filtering software (specifically
  Windows Base Filtering Engine) does not interfere with the
  transaction semantics expected by the tests.

* bpo-19493: Refactored the ctypes test package to skip tests
  explicitly rather than silently.

* bpo-18492: All resources are now allowed when tests are not run by
  regrtest.py.

* bpo-21634: Fix pystone micro-benchmark: use floor division instead
  of true division to benchmark integers instead of floating point
  numbers. Set pystone version to 1.2. Patch written by Lennart
  Regebro.

* bpo-21605: Added tests for Tkinter images.

* bpo-21493: Added test for ntpath.expanduser().  Original patch by
  Claudiu Popa.

* bpo-19925: Added tests for the spwd module. Original patch by
  Vajrasky Kok.

* bpo-21522: Added Tkinter tests for Listbox.itemconfigure(),
  PanedWindow.paneconfigure(), and Menu.entryconfigure().


Documentation
-------------

* bpo-21777: The binary sequence methods on bytes and bytearray are
  now documented explicitly, rather than assuming users will be able
  to derive the expected behaviour from the behaviour of the
  corresponding str methods.


Windows
-------

* bpo-21671: The bundled version of OpenSSL has been updated to
  1.0.1i. (See also: bpo-22160, CVE-2014-0224)

* bpo-10747: Use versioned labels in the Windows start menu. Patch
  by Olive Kilburn.


Tools/Demos
-----------

* bpo-22201: Command-line interface of the zipfile module now
  correctly extracts ZIP files with directory entries.  Patch by Ryan
  Wilson.

* bpo-21906: Make Tools/scripts/md5sum.py work in Python 3. Patch by
  Zachary Ware.

* bpo-21629: Fix Argument Clinic's "--converters" feature.


Python 3.4.1 final
==================

*Release date: 2014-05-18*


Core and Builtins
-----------------

* bpo-21418: Fix a crash in the builtin function super() when called
  without argument and without current frame (ex: embedded Python).

* bpo-21425: Fix flushing of standard streams in the interactive
  interpreter.

* bpo-21435: In rare cases, when running finalizers on objects in
  cyclic trash a bad pointer dereference could occur due to a subtle
  flaw in internal iteration logic.


Library
-------

* bpo-10744: Fix PEP 3118 format strings on ctypes objects with a
  nontrivial shape.

* bpo-20998: Fixed re.fullmatch() of repeated single character
  pattern with ignore case. Original patch by Matthew Barnett.

* bpo-21075: fileinput.FileInput now reads bytes from standard
  stream if binary mode is specified.  Patch by Sam Kimbrel.

* bpo-21396: Fix TextIOWrapper(..., write_through=True) to not force
  a flush() on the underlying binary stream.  Patch by akira.

* bpo-21470: Do a better job seeding the random number generator by
  using enough bytes to span the full state space of the Mersenne
  Twister.

* bpo-21398: Fix an unicode error in the pydoc pager when the
  documentation contains characters not encodable to the stdout
  encoding.


Tests
-----

* bpo-17756: Fix test_code test when run from the installed
  location.

* bpo-17752: Fix distutils tests when run from the installed
  location.


IDLE
----

* bpo-18104: Add idlelib/idle_test/htest.py with a few sample tests
  to begin consolidating and improving human-validated tests of Idle.
  Change other files as needed to work with htest.  Running the module
  as __main__ runs all tests.


Python 3.4.1 release candidate 1
================================

*Release date: 2014-05-05*


Core and Builtins
-----------------

* bpo-21274: Define PATH_MAX for GNU/Hurd in Python/pythonrun.c.

* bpo-21209: Fix sending tuples to custom generator objects with the
  yield from syntax.

* bpo-21134: Fix segfault when str is called on an uninitialized
  UnicodeEncodeError, UnicodeDecodeError, or UnicodeTranslateError
  object.

* bpo-19537: Fix PyUnicode_DATA() alignment under m68k.  Patch by
  Andreas Schwab.

* bpo-20929: Add a type cast to avoid shifting a negative number.

* bpo-20731: Properly position in source code files even if they are
  opened in text mode. Patch by Serhiy Storchaka.

* bpo-20637: Key-sharing now also works for instance dictionaries of
  subclasses.  Patch by Peter Ingebretson.

* bpo-12546: Allow "\x00" to be used as a fill character when using
  str, int, float, and complex __format__ methods.

* bpo-13598: Modify string.Formatter to support auto-numbering of
  replacement fields. It now matches the behavior of str.format() in
  this regard. Patches by Phil Elson and Ramchandra Apte.


Library
-------

* bpo-21088: Bugfix for curses.window.addch() regression in 3.4.0.
  In porting to Argument Clinic, the first two arguments were
  reversed.

* bpo-21469: Reduced the risk of false positives in robotparser by
  checking to make sure that robots.txt has been read or does not
  exist prior to returning True in can_fetch().

* bpo-21321: itertools.islice() now releases the reference to the
  source iterator when the slice is exhausted.  Patch by Anton
  Afanasyev.

* bpo-9815: assertRaises now tries to clear references to local
  variables in the exception's traceback.

* bpo-13204: Calling sys.flags.__new__ would crash the interpreter,
  now it raises a TypeError.

* bpo-19385: Make operations on a closed dbm.dumb database always
  raise the same exception.

* bpo-21207: Detect when the os.urandom cached fd has been closed or
  replaced, and open it anew.

* bpo-21291: subprocess's Popen.wait() is now thread safe so that
  multiple threads may be calling wait() or poll() on a Popen instance
  at the same time without losing the Popen.returncode value.

* bpo-21127: Path objects can now be instantiated from str subclass
  instances (such as "numpy.str_").

* bpo-15002: urllib.response object to use _TemporaryFileWrapper
  (and _TemporaryFileCloser) facility. Provides a better way to handle
  file descriptor close. Patch contributed by Christian Theune.

* bpo-12220: mindom now raises a custom ValueError indicating it
  doesn't support spaces in URIs instead of letting a 'split'
  ValueError bubble up.

* bpo-21239: patch.stopall() didn't work deterministically when the
  same name was patched more than once.

* bpo-21222: Passing name keyword argument to mock.create_autospec
  now works.

* bpo-21197: Add lib64 -> lib symlink in venvs on 64-bit non-OS X
  POSIX.

* bpo-17498: Some SMTP servers disconnect after certain errors,
  violating strict RFC conformance.  Instead of losing the error code
  when we issue the subsequent RSET, smtplib now returns the error
  code and defers raising the SMTPServerDisconnected error until the
  next command is issued.

* bpo-17826: setting an iterable side_effect on a mock function
  created by create_autospec now works. Patch by Kushal Das.

* bpo-7776: Fix "Host:" header and reconnection when using
  http.client.HTTPConnection.set_tunnel(). Patch by Nikolaus Rath.

* bpo-20968: unittest.mock.MagicMock now supports division. Patch by
  Johannes Baiter.

* bpo-21529: Fix arbitrary memory access in JSONDecoder.raw_decode
  with a negative second parameter. Bug reported by Guido Vranken.
  (See also: CVE-2014-4616)

* bpo-21169: getpass now handles non-ascii characters that the input
  stream encoding cannot encode by re-encoding using the replace error
  handler.

* bpo-21171: Fixed undocumented filter API of the rot13 codec. Patch
  by Berker Peksag.

* bpo-21172: isinstance check relaxed from dict to
  collections.Mapping.

* bpo-21155: asyncio.EventLoop.create_unix_server() now raises a
  ValueError if path and sock are specified at the same time.

* bpo-21149: Improved thread-safety in logging cleanup during
  interpreter shutdown. Thanks to Devin Jeanpierre for the patch.

* bpo-20145: "assertRaisesRegex" and "assertWarnsRegex" now raise a
  TypeError if the second argument is not a string or compiled regex.

* bpo-21058: Fix a leak of file descriptor in
  "tempfile.NamedTemporaryFile()", close the file descriptor if
  "io.open()" fails

* bpo-21200: Return None from pkgutil.get_loader() when __spec__ is
  missing.

* bpo-21013: Enhance ssl.create_default_context() when used for
  server side sockets to provide better security by default.

* bpo-20633: Replace relative import by absolute import.

* bpo-20980: Stop wrapping exception when using ThreadPool.

* bpo-21082: In os.makedirs, do not set the process-wide umask. Note
  this changes behavior of makedirs when exist_ok=True.

* bpo-20990: Fix issues found by pyflakes for multiprocessing.

* bpo-21015: SSL contexts will now automatically select an elliptic
  curve for ECDH key exchange on OpenSSL 1.0.2 and later, and
  otherwise default to "prime256v1".

* bpo-20995: Enhance default ciphers used by the ssl module to
  enable better security an prioritize perfect forward secrecy.

* bpo-20884: Don't assume that __file__ is defined on
  importlib.__init__.

* bpo-21499: Ignore __builtins__ in several test_importlib.test_api
  tests.

* bpo-20879: Delay the initialization of encoding and decoding
  tables for base32, ascii85 and base85 codecs in the base64 module,
  and delay the initialization of the unquote_to_bytes() table of the
  urllib.parse module, to not waste memory if these modules are not
  used.

* bpo-19157: Include the broadcast address in the usuable hosts for
  IPv6 in ipaddress.

* bpo-11599: When an external command (e.g. compiler) fails,
  distutils now prints out the whole command line (instead of just the
  command name) if the environment variable DISTUTILS_DEBUG is set.

* bpo-4931: distutils should not produce unhelpful "error: None"
  messages anymore. distutils.util.grok_environment_error is kept but
  doc-deprecated.

* bpo-20875: Prevent possible gzip "'read' is not defined"
  NameError. Patch by Claudiu Popa.

* bpo-11558: "email.message.Message.attach" now returns a more
  useful error message if "attach" is called on a message for which
  "is_multipart" is False.

* bpo-20283: RE pattern methods now accept the string keyword
  parameters as documented. The pattern and source keyword parameters
  are left as deprecated aliases.

* bpo-20778: Fix modulefinder to work with bytecode-only modules.

* bpo-20791: copy.copy() now doesn't make a copy when the input is a
  bytes object. Initial patch by Peter Otten.

* bpo-19748: On AIX, time.mktime() now raises an OverflowError for
  year outsize range [1902; 2037].

* bpo-20816: Fix inspect.getcallargs() to raise correct TypeError
  for missing keyword- only arguments. Patch by Jeremiah Lowin.

* bpo-20817: Fix inspect.getcallargs() to fail correctly if more
  than 3 arguments are missing. Patch by Jeremiah Lowin.

* bpo-6676: Ensure a meaningful exception is raised when attempting
  to parse more than one XML document per pyexpat xmlparser instance.
  (Original patches by Hirokazu Yamamoto and Amaury Forgeot d'Arc,
  with suggested wording by David Gutteridge)

* bpo-21117: Fix inspect.signature to better support
  functools.partial. Due to the specifics of functools.partial
  implementation, positional-or-keyword arguments passed as keyword
  arguments become keyword-only.

* bpo-21209: Fix asyncio.tasks.CoroWrapper to workaround a bug in
  yield-from implementation in CPythons prior to 3.4.1.

* asyncio: Add gi_{frame,running,code} properties to CoroWrapper
  (upstream issue #163).

* bpo-21311: Avoid exception in _osx_support with non-standard
  compiler configurations. Patch by John Szakmeister.

* bpo-11571: Ensure that the turtle window becomes the topmost
  window when launched on OS X.

* bpo-21276: posixmodule: Don't define USE_XATTRS on KFreeBSD and
  the Hurd.

* bpo-21226: Set up modules properly in
  PyImport_ExecCodeModuleObject (and friends).


IDLE
----

* bpo-21139: Change default paragraph width to 72, the PEP 8
  recommendation.

* bpo-21284: Paragraph reformat test passes after user changes
  reformat width.

* bpo-17654: Ensure IDLE menus are customized properly on OS X for
  non-framework builds and for all variants of Tk.


Build
-----

* The Windows build now includes OpenSSL 1.0.1g

* bpo-21285: Refactor and fix curses configure check to always
  search in a ncursesw directory.

* bpo-15234: For BerkelyDB and Sqlite, only add the found library
  and include directories if they aren't already being searched. This
  avoids an explicit runtime library dependency.

* bpo-20644: OS X installer build support for documentation build
  changes in 3.4.1: assume externally supplied sphinx-build is
  available in /usr/bin.


C API
-----

* bpo-20942: PyImport_ImportFrozenModuleObject() no longer sets
  __file__ to match what importlib does; this affects
  _frozen_importlib as well as any module loaded using
  imp.init_frozen().


Documentation
-------------

* bpo-17386: Expanded functionality of the "Doc/make.bat" script to
  make it much more comparable to "Doc/Makefile".

* bpo-21043: Remove the recommendation for specific CA organizations
  and to mention the ability to load the OS certificates.

* bpo-20765: Add missing documentation for PurePath.with_name() and
  PurePath.with_suffix().

* bpo-19407: New package installation and distribution guides based
  on the Python Packaging Authority tools. Existing guides have been
  retained as legacy links from the distutils docs, as they still
  contain some required reference material for tool developers that
  isn't recorded anywhere else.

* bpo-19697: Document cases where __main__.__spec__ is None.


Tests
-----

* bpo-18604: Consolidated checks for GUI availability.  All
  platforms now at least check whether Tk can be instantiated when the
  GUI resource is requested.

* bpo-21275: Fix a socket test on KFreeBSD.

* bpo-21223: Pass test_site/test_startup_imports when some of the
  extensions are built as builtins.

* bpo-20635: Added tests for Tk geometry managers.

* Add test case for freeze.

* bpo-20743: Fix a reference leak in test_tcl.

* bpo-21097: Move test_namespace_pkgs into test_importlib.

* bpo-20939: Avoid various network test failures due to new redirect
  of http://www.python.org/ to https://www.python.org: use
  http://www.example.com instead.

* bpo-20668: asyncio tests no longer rely on tests.txt file. (Patch
  by Vajrasky Kok)

* bpo-21093: Prevent failures of ctypes test_macholib on OS X if a
  copy of libz exists in $HOME/lib or /usr/local/lib.


Tools/Demos
-----------

* Add support for "yield from" to 2to3.

* Add support for the PEP 465 matrix multiplication operator to
  2to3.

* bpo-16047: Fix module exception list and __file__ handling in
  freeze. Patch by Meador Inge.

* bpo-11824: Consider ABI tags in freeze. Patch by Meador Inge.

* bpo-20535: PYTHONWARNING no longer affects the run_tests.py
  script. Patch by Arfrever Frehtes Taifersar Arahesis.


Python 3.4.0 final
==================

*Release date: 2014-03-16*


Library
-------

* bpo-20939: Fix test_geturl failure in test_urllibnet due to new
  redirect of http://www.python.org/ to https://www.python.org.


Documentation
-------------

* Merge in all documentation changes since branching 3.4.0rc1.


Python 3.4.0 release candidate 3
================================

*Release date: 2014-03-09*


Core and Builtins
-----------------

* bpo-20786: Fix signatures for dict.__delitem__ and
  property.__delete__ builtins.


Library
-------

* bpo-20839: Don't trigger a DeprecationWarning in the still
  supported pkgutil.get_loader() API when __loader__ isn't set on a
  module (nor when pkgutil.find_loader() is called directly).


Build
-----

* bpo-14512: Launch pydoc -b instead of pydocgui.pyw on Windows.

* bpo-20748: Uninstalling pip does not leave behind the pyc of the
  uninstaller anymore.

* bpo-20568: The Windows installer now installs the unversioned
  "pip" command in addition to the versioned "pip3" and "pip3.4"
  commands.

* bpo-20757: The ensurepip helper for the Windows uninstaller now
  skips uninstalling pip (rather than failing) if the user has updated
  pip to a different version from the one bundled with ensurepip.

* bpo-20465: Update OS X and Windows installer builds to use SQLite
  3.8.3.1.


Python 3.4.0 release candidate 2
================================

*Release date: 2014-02-23*


Core and Builtins
-----------------

* bpo-20625: Parameter names in __annotations__ were not mangled
  properly. Discovered by Jonas Wielicki, patch by Yury Selivanov.

* bpo-20261: In pickle, lookup __getnewargs__ and __getnewargs_ex__
  on the type of the object.

* bpo-20619: Give the AST nodes of keyword-only arguments a column
  and line number.

* bpo-20526: Revert changes of issue #19466 which introduces a
  regression: don't clear anymore the state of Python threads early
  during the Python shutdown.


Library
-------

* bpo-20710: The pydoc summary line no longer displays the "self"
  parameter for bound methods.

* bpo-20566: Change asyncio.as_completed() to use a Queue, to avoid
  O(N**2) behavior.

* bpo-20704: Implement new debug API in asyncio. Add new methods
  BaseEventLoop.set_debug() and BaseEventLoop.get_debug(). Add support
  for setting 'asyncio.tasks._DEBUG' variable with
  'PYTHONASYNCIODEBUG' environment variable.

* asyncio: Refactoring and fixes: BaseEventLoop.sock_connect()
  raises an error if the address is not resolved; use __slots__ in
  Handle and TimerHandle; as_completed() and wait() raise TypeError if
  the passed list of Futures is a single Future; call_soon() and other
  'call_*()' functions raise TypeError if the passed callback is a
  coroutine function; _ProactorBasePipeTransport uses
  _FlowControlMixin; WriteTransport.set_write_buffer_size() calls
  _maybe_pause_protocol() to consider pausing receiving if the
  watermark limits have changed; fix _check_resolved_address() for
  IPv6 address; and other minor improvements, along with multiple
  documentation updates.

* bpo-20684: Fix inspect.getfullargspec() to not to follow
  __wrapped__ chains. Make its behaviour consistent with bound methods
  first argument. Patch by Nick Coghlan and Yury Selivanov.

* bpo-20681: Add new error handling API in asyncio. New APIs:
  loop.set_exception_handler(), loop.default_exception_handler(), and
  loop.call_exception_handler().

* bpo-20673: Implement support for UNIX Domain Sockets in asyncio.
  New APIs: loop.create_unix_connection(), loop.create_unix_server(),
  streams.open_unix_connection(), and streams.start_unix_server().

* bpo-20616: Add a format() method to tracemalloc.Traceback.

* bpo-19744: the ensurepip installation step now just prints a
  warning to stderr rather than failing outright if SSL/TLS is
  unavailable. This allows local installation of POSIX builds without
  SSL/TLS support.

* bpo-20594: Avoid name clash with the libc function posix_close.


Build
-----

* bpo-20641: Run MSI custom actions (pip installation, pyc
  compilation) with the NoImpersonate flag, to support elevated
  execution (UAC).

* bpo-20221: Removed conflicting (or circular) hypot definition when
  compiled with VS 2010 or above.  Initial patch by Tabrez Mohammed.

* bpo-20609: Restored the ability to build 64-bit Windows binaries
  on 32-bit Windows, which was broken by the change in issue #19788.


Python 3.4.0 release candidate 1
================================

*Release date: 2014-02-10*


Core and Builtins
-----------------

* bpo-19255: The builtins module is restored to initial value before
  cleaning other modules.  The sys and builtins modules are cleaned
  last.

* bpo-20588: Make Python-ast.c C89 compliant.

* bpo-20437: Fixed 22 potential bugs when deleting objects
  references.

* bpo-20500: Displaying an exception at interpreter shutdown no
  longer risks triggering an assertion failure in PyObject_Str.

* bpo-20538: UTF-7 incremental decoder produced inconsistent string
  when input was truncated in BASE64 section.

* bpo-20404: io.TextIOWrapper (and hence the open() builtin) now
  uses the internal codec marking system added for issue #19619 to
  throw LookupError for known non- text encodings at stream
  construction time. The existing output type checks remain in place
  to deal with unmarked third party codecs.

* bpo-17162: Add PyType_GetSlot.

* bpo-20162: Fix an alignment issue in the siphash24() hash function
  which caused a crash on PowerPC 64-bit (ppc64).


Library
-------

* bpo-20530: The signatures for slot builtins have been updated to
  reflect the fact that they only accept positional-only arguments.

* bpo-20517: Functions in the os module that accept two filenames
  now register both filenames in the exception on failure.

* bpo-20563: The ipaddress module API is now considered stable.

* bpo-14983: email.generator now always adds a line end after each
  MIME boundary marker, instead of doing so only when there is an
  epilogue.  This fixes an RFC compliance bug and solves an issue with
  signed MIME parts.

* bpo-20540: Fix a performance regression (vs. Python 3.2) when
  layering a multiprocessing Connection over a TCP socket.  For small
  payloads, Nagle's algorithm would introduce idle delays before the
  entire transmission of a message.

* bpo-16983: the new email header parsing code will now decode
  encoded words that are (incorrectly) surrounded by quotes, and
  register a defect.

* bpo-19772: email.generator no longer mutates the message object
  when doing a down- transform from 8bit to 7bit CTEs.

* bpo-20536: the statistics module now correctly handle Decimal
  instances with positive exponents

* bpo-18805: the netmask/hostmask parsing in ipaddress now more
  reliably filters out illegal values and correctly allows any valid
  prefix length.

* bpo-20481: For at least Python 3.4, the statistics module will
  require that all inputs for a single operation be of a single
  consistent type, or else a mixed of ints and a single other
  consistent type. This avoids some interoperability issues that arose
  with the previous approach of coercing to a suitable common type.

* bpo-20478: the statistics module now treats collections.Counter
  inputs like any other iterable.

* bpo-17369: get_filename was raising an exception if the filename
  parameter's RFC2231 encoding was broken in certain ways.  This was a
  regression relative to python2.

* bpo-20013: Some imap servers disconnect if the current mailbox is
  deleted, and imaplib did not handle that case gracefully.  Now it
  handles the 'bye' correctly.

* bpo-20531: Revert 3.4 version of fix for #19063, and apply the 3.3
  version.  That is, do *not* raise an error if unicode is passed to
  email.message.Message.set_payload.

* bpo-20476: If a non-compat32 policy is used with any of the email
  parsers, EmailMessage is now used as the factory class.  The factory
  class should really come from the policy; that will get fixed in
  3.5.

* bpo-19920: TarFile.list() no longer fails when outputs a listing
  containing non- encodable characters.  Based on patch by Vajrasky
  Kok.

* bpo-20515: Fix NULL pointer dereference introduced by issue
  #20368.

* bpo-19186: Restore namespacing of expat symbols inside the pyexpat
  module.

* bpo-20053: ensurepip (and hence venv) are no longer affected by
  the settings in the default pip configuration file.

* bpo-20426: When passing the re.DEBUG flag, re.compile() displays
  the debug output every time it is called, regardless of the
  compilation cache.

* bpo-20368: The null character now correctly passed from Tcl to
  Python. Improved error handling in variables-related commands.

* bpo-20435: Fix _pyio.StringIO.getvalue() to take into account
  newline translation settings.

* tracemalloc: Fix slicing traces and fix slicing a traceback.

* bpo-20354: Fix an alignment issue in the tracemalloc module on
  64-bit platforms. Bug seen on 64-bit Linux when using "make profile-
  opt".

* bpo-17159: inspect.signature now accepts duck types of functions,
  which adds support for Cython functions. Initial patch by Stefan
  Behnel.

* bpo-18801: Fix inspect.classify_class_attrs to correctly classify
  object.__new__ and object.__init__.

* Fixed cmath.isinf's name in its argument parsing code.

* bpo-20311: poll and epoll now round the timeout away from zero,
  instead of rounding towards zero, in select and selectors modules:
  select.epoll.poll(), selectors.PollSelector.poll() and
  selectors.EpollSelector.poll(). For example, a timeout of one
  microsecond (1e-6) is now rounded to one millisecondi (1e-3),
  instead of being rounded to zero.  However, the granularity property
  and asyncio's resolution feature were removed again. (See also:
  bpo-20452)

* asyncio: Some refactoring; various fixes; add write flow control
  to unix pipes; Future.set_exception() instantiates the exception
  argument if it is a class; improved proactor pipe transport; support
  wait_for(f, None); don't log broken/disconnected pipes; use
  ValueError instead of assert for forbidden subprocess_{shell,exec}
  arguments; added a convenience API for subprocess management; added
  StreamReader.at_eof(); properly handle duplicate coroutines/futures
  in gather(), wait(), as_completed(); use a bytearray for buffering
  in StreamReader; and more.

* bpo-20288: fix handling of invalid numeric charrefs in HTMLParser.

* bpo-20424: Python implementation of io.StringIO now supports lone
  surrogates.

* bpo-20308: inspect.signature now works on classes without user-
  defined __init__ or __new__ methods.

* bpo-20372: inspect.getfile (and a bunch of other inspect functions
  that use it) doesn't crash with unexpected AttributeError on classes
  defined in C without __module__.

* bpo-20356: inspect.signature formatting uses '/' to separate
  positional-only parameters from others.

* bpo-20223: inspect.signature now supports methods defined with
  functools.partialmethods.

* bpo-19456: ntpath.join() now joins relative paths correctly when a
  drive is present.

* bpo-19077: tempfile.TemporaryDirectory cleanup no longer fails
  when called during shutdown.  Emitting resource warning in __del__
  no longer fails. Original patch by Antoine Pitrou.

* bpo-20394: Silence Coverity warning in audioop module.

* bpo-20367: Fix behavior of concurrent.futures.as_completed() for
  duplicate arguments. Patch by Glenn Langford.

* bpo-8260: The read(), readline() and readlines() methods of
  codecs.StreamReader returned incomplete data when were called after
  readline() or read(size). Based on patch by Amaury Forgeot d'Arc.

* bpo-20105: the codec exception chaining now correctly sets the
  traceback of the original exception as its __traceback__ attribute.

* bpo-17481: inspect.getfullargspec() now uses inspect.signature()
  API.

* bpo-15304: concurrent.futures.wait() can block forever even if
  Futures have completed. Patch by Glenn Langford.

* bpo-14455: plistlib: fix serializing integers in the range of an
  unsigned long long but outside of the range of signed long long for
  binary plist files.


IDLE
----

* bpo-20406: Use Python application icons for Idle window title
  bars. Patch mostly by Serhiy Storchaka.

* Update the python.gif icon for the Idle classbrowser and
  pathbowser from the old green snake to the new blue and yellow
  snakes.

* bpo-17721: Remove non-functional configuration dialog help button
  until we make it actually gives some help when clicked. Patch by
  Guilherme Simões.


Tests
-----

* bpo-20532: Tests which use _testcapi now are marked as CPython
  only.

* bpo-19920: Added tests for TarFile.list().  Based on patch by
  Vajrasky Kok.

* bpo-19990: Added tests for the imghdr module.  Based on patch by
  Claudiu Popa.

* bpo-20474: Fix test_socket "unexpected success" failures on OS X
  10.7+.


Tools/Demos
-----------

* bpo-20530: Argument Clinic's signature format has been revised
  again. The new syntax is highly human readable while still
  preventing false positives.  The syntax also extends Python syntax
  to denote "self" and positional-only parameters, allowing
  inspect.Signature objects to be totally accurate for all supported
  builtins in Python 3.4.

* bpo-20456: Argument Clinic now observes the C preprocessor
  conditional compilation statements of the C files it parses.  When a
  Clinic block is inside a conditional code, it adjusts its output to
  match, including automatically generating an empty methoddef macro.

* bpo-20456: Cloned functions in Argument Clinic now use the correct
  name, not the name of the function they were cloned from, for text
  strings inside generated code.

* bpo-20456: Fixed Argument Clinic's test suite and "--converters"
  feature.

* bpo-20456: Argument Clinic now allows specifying different names
  for a parameter in Python and C, using "as" on the parameter line.

* bpo-20326: Argument Clinic now uses a simple, unique signature to
  annotate text signatures in docstrings, resulting in fewer false
  positives.  "self" parameters are also explicitly marked, allowing
  inspect.Signature() to authoritatively detect (and skip) said
  parameters.

* bpo-20326: Argument Clinic now generates separate checksums for
  the input and output sections of the block, allowing external tools
  to verify that the input has not changed (and thus the output is not
  out-of-date).


Build
-----

* bpo-20465: Update SQLite shipped with OS X installer to 3.8.3.


C API
-----

* bpo-20517: Added new functions allowing OSError exceptions to
  reference two filenames instead of one:
  PyErr_SetFromErrnoWithFilenameObjects() and
  PyErr_SetExcFromWindowsErrWithFilenameObjects().


Documentation
-------------

* bpo-20488: Change wording to say importlib is *the* implementation
  of import instead of just *an* implementation.

* bpo-6386: Clarify in the tutorial that specifying a symlink to
  execute means the directory containing the executed script and not
  the symlink is added to sys.path.


Python 3.4.0 beta 3
===================

*Release date: 2014-01-26*


Core and Builtins
-----------------

* bpo-20189: Four additional builtin types (PyTypeObject,
  PyMethodDescr_Type, _PyMethodWrapper_Type, and PyWrapperDescr_Type)
  have been modified to provide introspection information for
  builtins.

* bpo-17825: Cursor "^" is correctly positioned for SyntaxError and
  IndentationError.

* bpo-2382: SyntaxError cursor "^" is now written at correct
  position in most cases when multibyte characters are in line (before
  "^"). This still not works correctly with wide East Asian
  characters.

* bpo-18960: The first line of Python script could be executed twice
  when the source encoding was specified on the second line.  Now the
  source encoding declaration on the second line isn't effective if
  the first line contains anything except a comment.  'python -x'
  works now again with files with the source encoding declarations,
  and can be used to make Python batch files on Windows.


Library
-------

* asyncio: Various improvements and small changes not all covered by
  issues listed below.  E.g. wait_for() now cancels the inner task if
  the timeout occcurs; tweaked the set of exported symbols; renamed
  Empty/Full to QueueEmpty/QueueFull; "with (yield from lock)" now
  uses a separate context manager; readexactly() raises if not enough
  data was read; PTY support tweaks.

* bpo-20311: asyncio: Add a granularity attribute to BaseEventLoop:
  maximum between the resolution of the BaseEventLoop.time() method
  and the resolution of the selector. The granuarility is used in the
  scheduler to round time and deadline.

* bpo-20311: selectors: Add a resolution attribute to BaseSelector.

* bpo-20189: unittest.mock now no longer assumes that any object for
  which it could get an inspect.Signature is a callable written in
  Python. Fix courtesy of Michael Foord.

* bpo-20317: ExitStack.__exit__ could create a self-referential loop
  if an exception raised by a cleanup operation already had its
  context set correctly (for example, by the @contextmanager
  decorator). The infinite loop this caused is now avoided by checking
  if the expected context is already set before trying to fix it.

* bpo-20374: Fix build with GNU readline >= 6.3.

* bpo-20262: Warnings are raised now when duplicate names are added
  in the ZIP file or too long ZIP file comment is truncated.

* bpo-20165: The unittest module no longer considers tests marked
  with @expectedFailure successful if they pass.

* bpo-18574: Added missing newline in 100-Continue reply from
  http.server.BaseHTTPRequestHandler. Patch by Nikolaus Rath.

* bpo-20270: urllib.urlparse now supports empty ports.

* bpo-20243: TarFile no longer raise ReadError when opened in write
  mode.

* bpo-20238: TarFile opened with external fileobj and "w:gz" mode
  didn't write complete output on close.

* bpo-20245: The open functions in the tarfile module now correctly
  handle empty mode.

* bpo-20242: Fixed basicConfig() format strings for the alternative
  formatting styles. Thanks to kespindler for the bug report and
  patch.

* bpo-20246: Fix buffer overflow in socket.recvfrom_into.

* bpo-20206: Fix edge case in email.quoprimime.encode where it
  truncated lines ending in a character needing encoding but no
  newline by using a more efficient algorithm that doesn't have the
  bug. (See also: bpo-5803)

* bpo-19082: Working xmlrpc.server and xmlrpc.client examples. Both
  in modules and in documentation. Initial patch contributed by
  Vajrasky Kok.

* bpo-20138: The wsgiref.application_uri() and wsgiref.request_uri()
  functions now conform to PEP 3333 when handle non-ASCII URLs.

* bpo-19097: Raise the correct Exception when cgi.FieldStorage is
  given an invalid fileobj.

* bpo-20152: Ported Python/import.c over to Argument Clinic.

* bpo-13107: argparse and optparse no longer raises an exception
  when output a help on environment with too small COLUMNS.  Based on
  patch by Elazar Gershuni.

* bpo-20207: Always disable SSLv2 except when PROTOCOL_SSLv2 is
  explicitly asked for.

* bpo-18960: The tokenize module now ignore the source encoding
  declaration on the second line if the first line contains anything
  except a comment.

* bpo-20078: Reading malformed zipfiles no longer hangs with 100%
  CPU consumption.

* bpo-20113: os.readv() and os.writev() now raise an OSError
  exception on error instead of returning -1.

* bpo-19719: Make importlib.abc.MetaPathFinder.find_module(),
  PathEntryFinder.find_loader(), and Loader.load_module() use PEP 451
  APIs to help with backwards-compatibility.

* bpo-20144: inspect.Signature now supports parsing simple symbolic
  constants as parameter default values in __text_signature__.

* bpo-20072: Fixed multiple errors in tkinter with wantobjects is
  False.

* bpo-20229: Avoid plistlib deprecation warning in
  platform.mac_ver().

* bpo-14455: Fix some problems with the new binary plist support in
  plistlib.


IDLE
----

* bpo-17390: Add Python version to Idle editor window title bar.
  Original patches by Edmond Burnett and Kent Johnson.

* bpo-18960: IDLE now ignores the source encoding declaration on the
  second line if the first line contains anything except a comment.


Tests
-----

* bpo-20358: Tests for curses.window.overlay and
  curses.window.overwrite no longer specify min{row,col} >
  max{row,col}.

* bpo-19804: The test_find_mac test in test_uuid is now skipped if
  the ifconfig executable is not available.

* bpo-19886: Use better estimated memory requirements for bigmem
  tests.


Tools/Demos
-----------

* bpo-20390: Argument Clinic's "file" output preset now defaults to
  "{dirname}/clinic/{basename}.h".

* bpo-20390: Argument Clinic's "class" directive syntax has been
  extended with two new required arguments: "typedef" and
  "type_object".

* bpo-20390: Argument Clinic: If __new__ or __init__ functions
  didn't use kwargs (or args), the PyArg_NoKeywords (or
  PyArg_NoPositional) calls generated are only run when the type
  object is an exact match.

* bpo-20390: Argument Clinic now fails if you have required
  parameters after optional parameters.

* bpo-20390: Argument Clinic converters now have a new template they
  can inject code into: "modifiers".  Code put there is run in the
  parsing function after argument parsing but before the call to the
  impl.

* bpo-20376: Argument Clinic now escapes backslashes in docstrings.

* bpo-20381: Argument Clinic now sanity checks the default argument
  when c_default is also specified, providing a nice failure message
  for disallowed values.

* bpo-20189: Argument Clinic now ensures that parser functions for
  __new__ are always of type newfunc, the type of the tp_new slot.
  Similarly, parser functions for __init__ are now always of type
  initproc, the type of tp_init.

* bpo-20189: Argument Clinic now suppresses the docstring for
  __new__ and __init__ functions if no docstring is provided in the
  input.

* bpo-20189: Argument Clinic now suppresses the "self" parameter in
  the impl for @staticmethod functions.

* bpo-20294: Argument Clinic now supports argument parsing for
  __new__ and __init__ functions.

* bpo-20299: Argument Clinic custom converters may now change the
  default value of c_default and py_default with a class member.

* bpo-20287: Argument Clinic's output is now configurable, allowing
  delaying its output or even redirecting it to a separate file.

* bpo-20226: Argument Clinic now permits simple expressions (e.g.
  "sys.maxsize - 1") as default values for parameters.

* bpo-19936: Added executable bits or shebang lines to Python
  scripts which requires them.  Disable executable bits and shebang
  lines in test and benchmark files in order to prevent using a random
  system python, and in source files of modules which don't provide
  command line interface.  Fixed shebang lines in the unittestgui and
  checkpip scripts.

* bpo-20268: Argument Clinic now supports cloning the parameters and
  return converter of existing functions.

* bpo-20228: Argument Clinic now has special support for class
  special methods.

* bpo-20214: Fixed a number of small issues and documentation errors
  in Argument Clinic (see issue for details).

* bpo-20196: Fixed a bug where Argument Clinic did not generate
  correct parsing code for functions with positional-only parameters
  where all arguments are optional.

* bpo-18960: 2to3 and the findnocoding.py script now ignore the
  source encoding declaration on the second line if the first line
  contains anything except a comment.

* bpo-19723: The marker comments Argument Clinic uses have been
  changed to improve readability.

* bpo-20157: When Argument Clinic renames a parameter because its
  name collides with a C keyword, it no longer exposes that rename to
  PyArg_Parse.

* bpo-20141: Improved Argument Clinic's support for the PyArg_Parse
  "O!" format unit.

* bpo-20144: Argument Clinic now supports simple symbolic constants
  as parameter default values.

* bpo-20143: The line numbers reported in Argument Clinic errors are
  now more accurate.

* bpo-20142: Py_buffer variables generated by Argument Clinic are
  now initialized with a default value.


Build
-----

* bpo-12837: Silence a tautological comparison warning on OS X under
  Clang in socketmodule.c.


Python 3.4.0 beta 2
===================

*Release date: 2014-01-05*


Core and Builtins
-----------------

* bpo-17432: Drop UCS2 from names of Unicode functions in
  python3.def.

* bpo-19526: Exclude all new API from the stable ABI. Exceptions can
  be made if a need is demonstrated.

* bpo-19969: PyBytes_FromFormatV() now raises an OverflowError if
  "%c" argument is not in range [0; 255].

* bpo-19995: %c, %o, %x, and %X now issue a DeprecationWarning on
  non- integer input; reworded docs to clarify that an integer type
  should define both __int__ and __index__.

* bpo-19787: PyThread_set_key_value() now always set the value. In
  Python 3.3, the function did nothing if the key already exists (if
  the current value is a non-NULL pointer).

* bpo-14432: Remove the thread state field from the frame structure.
  Fix a crash when a generator is created in a C thread that is
  destroyed while the generator is still used. The issue was that a
  generator contains a frame, and the frame kept a reference to the
  Python state of the destroyed C thread. The crash occurs when a
  trace function is setup.

* bpo-19576: PyGILState_Ensure() now initializes threads. At
  startup, Python has no concrete GIL. If PyGILState_Ensure() is
  called from a new thread for the first time and PyEval_InitThreads()
  was not called yet, a GIL needs to be created.

* bpo-17576: Deprecation warning emitted now when __int__() or
  __index__() return not int instance.

* bpo-19932: Fix typo in import.h, missing whitespaces in function
  prototypes.

* bpo-19736: Add module-level statvfs constants defined for
  GNU/glibc based systems.

* bpo-20097: Fix bad use of "self" in importlib's
  WindowsRegistryFinder.

* bpo-19729: In str.format(), fix recursive expansion in format
  spec.

* bpo-19638: Fix possible crash / undefined behaviour from huge
  (more than 2 billion characters) input strings in _Py_dg_strtod.


Library
-------

* bpo-20154: Deadlock in asyncio.StreamReader.readexactly().

* bpo-16113: Remove sha3 module again.

* bpo-20111: pathlib.Path.with_suffix() now sanity checks the given
  suffix.

* Fix breakage in TestSuite.countTestCases() introduced by issue
  #11798.

* bpo-20108: Avoid parameter name clash in inspect.getcallargs().

* bpo-19918: Fix PurePath.relative_to() under Windows.

* bpo-19422: Explicitly disallow non-SOCK_STREAM sockets in the ssl
  module, rather than silently let them emit clear text data.

* bpo-20046: Locale alias table no longer contains entities which
  can be calculated. Generalized support of the euro modifier.

* bpo-20027: Fixed locale aliases for devanagari locales.

* bpo-20067: Tkinter variables now work when wantobjects is false.

* bpo-19020: Tkinter now uses splitlist() instead of split() in
  configure methods.

* bpo-19744: ensurepip now provides a better error message when
  Python is built without SSL/TLS support (pip currently requires that
  support to run, even if only operating with local wheel files)

* bpo-19734: ensurepip now ignores all pip environment variables to
  avoid odd behaviour based on user configuration settings

* Fix TypeError on "setup.py upload --show-response".

* bpo-20045: Fix "setup.py register --list-classifiers".

* bpo-18879: When a method is looked up on a temporary file, avoid
  closing the file before the method is possibly called.

* bpo-20037: Avoid crashes when opening a text file late at
  interpreter shutdown.

* bpo-19967: Thanks to the PEP 442, asyncio.Future now uses a
  destructor to log uncaught exceptions, instead of the dedicated
  _TracebackLogger class.

* Added a Task.current_task() class method to asyncio.

* bpo-19850: Set SA_RESTART in asyncio when registering a signal
  handler to limit EINTR occurrences.

* Implemented write flow control in asyncio for proactor event loop
  (Windows).

* Change write buffer in asyncio use to avoid O(N**2) behavior.
  Make write()/sendto() accept bytearray/memoryview.

* bpo-20034: Updated alias mapping to most recent locale.alias file
  from X.org distribution using makelocalealias.py.

* bpo-5815: Fixed support for locales with modifiers.  Fixed support
  for locale encodings with hyphens.

* bpo-20026: Fix the sqlite module to handle correctly invalid
  isolation level (wrong type).

* bpo-18829: csv.Dialect() now checks type for delimiter, escapechar
  and quotechar fields.  Original patch by Vajrasky Kok.

* bpo-19855: uuid.getnode() on Unix now looks on the PATH for the
  executables used to find the mac address, with /sbin and /usr/sbin
  as fallbacks.

* bpo-20007: HTTPResponse.read(0) no more prematurely closes
  connection. Original patch by Simon Sapin.

* bpo-19946: multiprocessing now uses runpy to initialize __main__
  in child processes when necessary, allowing it to correctly handle
  scripts without suffixes and submodules that use explicit relative
  imports or otherwise rely on parent modules being correctly imported
  prior to execution.

* bpo-19921: When Path.mkdir() is called with parents=True, any
  missing parent is created with the default permissions, ignoring the
  mode argument (mimicking the POSIX "mkdir -p" command).

* bpo-19887: Improve the Path.resolve() algorithm to support certain
  symlink chains.

* bpo-19912: Fixed numerous bugs in ntpath.splitunc().

* bpo-19911: ntpath.splitdrive() now correctly processes the 'İ'
  character (U+0130, LATIN CAPITAL LETTER I WITH DOT ABOVE).

* bpo-19532: python -m compileall with no filename/directory
  arguments now respects the -f and -q flags instead of ignoring them.

* bpo-19623: Fixed writing to unseekable files in the aifc module.

* bpo-19946: multiprocessing.spawn now raises ImportError when the
  module to be used as the main module cannot be imported.

* bpo-17919: select.poll.register() again works with poll.POLLNVAL
  on AIX. Fixed integer overflow in the eventmask parameter.

* bpo-19063: if a Charset's body_encoding was set to None, the email
  package would generate a message claiming the Content-Transfer-
  Encoding was 7bit, and produce garbage output for the content.  This
  now works. A couple of other set_payload mishandlings of non-ASCII
  are also fixed. In addition, calling set_payload with a string
  argument without specifying a charset now raises an error (this is a
  new error in 3.4).

* bpo-15475: Add __sizeof__ implementations for itertools objects.

* bpo-19944: Fix importlib.find_spec() so it imports parents as
  needed and move the function to importlib.util.

* bpo-19880: Fix a reference leak in unittest.TestCase. Explicitly
  break reference cycles between frames and the _Outcome instance.

* bpo-17429: platform.linux_distribution() now decodes files from
  the UTF-8 encoding with the surrogateescape error handler, instead
  of decoding from the locale encoding in strict mode. It fixes the
  function on Fedora 19 which is probably the first major distribution
  release with a non-ASCII name. Patch written by Toshio Kuratomi.

* bpo-19343: Expose FreeBSD-specific APIs in resource module.
  Original patch by Koobs.

* bpo-19929: Call os.read with 32768 within
  subprocess.Popen.communicate rather than 4096 for efficiency.  A
  microbenchmark shows Linux and OS X both using ~50% less cpu time
  this way.

* bpo-19506: Use a memoryview to avoid a data copy when piping data
  to stdin within subprocess.Popen.communicate.  5-10% less cpu usage.

* bpo-19876: selectors unregister() no longer raises ValueError or
  OSError if the FD is closed (as long as it was registered).

* bpo-19908: pathlib now joins relative Windows paths correctly when
  a drive is present. Original patch by Antoine Pitrou.

* bpo-19296: Silence compiler warning in dbm_open

* bpo-6784: Strings from Python 2 can now be unpickled as bytes
  objects by setting the encoding argument of Unpickler to be 'bytes'.
  Initial patch by Merlijn van Deen.

* bpo-19839: Fix regression in bz2 module's handling of non-bzip2
  data at EOF, and analogous bug in lzma module.

* bpo-19881: Fix pickling bug where cpickle would emit bad pickle
  data for large bytes string (i.e., with size greater than 2**32-1).

* bpo-19138: doctest's IGNORE_EXCEPTION_DETAIL now allows a match
  when no exception detail exists (no colon following the exception's
  name, or a colon does follow but no text follows the colon).

* bpo-19927: Add __eq__ to path-based loaders in importlib.

* bpo-19827: On UNIX, setblocking() and settimeout() methods of
  socket.socket can now avoid a second syscall if the ioctl() function
  can be used, or if the non- blocking flag of the socket is
  unchanged.

* bpo-19785: smtplib now supports SSLContext.check_hostname and
  server name indication for TLS/SSL connections.

* bpo-19784: poplib now supports SSLContext.check_hostname and
  server name indication for TLS/SSL connections.

* bpo-19783: nntplib now supports SSLContext.check_hostname and
  server name indication for TLS/SSL connections.

* bpo-19782: imaplib now supports SSLContext.check_hostname and
  server name indication for TLS/SSL connections.

* bpo-20123: Fix pydoc.synopsis() for "binary" modules.

* bpo-19834: Support unpickling of exceptions pickled by Python 2.

* bpo-19781: ftplib now supports SSLContext.check_hostname and
  server name indication for TLS/SSL connections.

* bpo-19509: Add SSLContext.check_hostname to match the peer's
  certificate with server_hostname on handshake.

* bpo-15798: Fixed subprocess.Popen() to no longer fail if file
  descriptor 0, 1 or 2 is closed.

* bpo-17897: Optimized unpickle prefetching.

* bpo-3693: Make the error message more helpful when the
  array.array() constructor is given a str. Move the array module
  typecode documentation to the docstring of the constructor.

* bpo-19088: Fixed incorrect caching of the copyreg module in
  object.__reduce__() and object.__reduce_ex__().

* bpo-19698: Removed exec_module() methods from
  importlib.machinery.BuiltinImporter and ExtensionFileLoader.

* bpo-18864: Added a setter for ModuleSpec.has_location.

* Fixed _pickle.Unpickler to not fail when loading empty strings as
  persistent IDs.

* bpo-11480: Fixed copy.copy to work with classes with custom
  metaclasses. Patch by Daniel Urban.

* bpo-6477: Added support for pickling the types of built-in
  singletons (i.e., Ellipsis, NotImplemented, None).

* bpo-19713: Add remaining PEP 451-related deprecations and move
  away from using find_module/find_loaer/load_module.

* bpo-19708: Update pkgutil to use the new importer APIs.

* bpo-19703: Update pydoc to use the new importer APIs.

* bpo-19851: Fixed a regression in reloading sub-modules.

* ssl.create_default_context() sets OP_NO_COMPRESSION to prevent
  CRIME.

* bpo-19802: Add socket.SO_PRIORITY.

* bpo-11508: Fixed uuid.getnode() and uuid.uuid1() on environment
  with virtual interface. Original patch by Kent Frazier.

* bpo-11489: JSON decoder now accepts lone surrogates.

* bpo-19545: Avoid chained exceptions while passing stray % to
  time.strptime().  Initial patch by Claudiu Popa.


IDLE
----

* bpo-20058: sys.stdin.readline() in IDLE now always returns only
  one line.

* bpo-19481: print() of string subclass instance in IDLE no longer
  hangs.

* bpo-18270: Prevent possible IDLE AttributeError on OS X when no
  initial shell window is present.


Tests
-----

* bpo-20055: Fix test_shutil under Windows with symlink privileges
  held. Patch by Vajrasky Kok.

* bpo-20070: Don't run test_urllib2net when network resources are
  not enabled.

* bpo-19938: Re-enabled test_bug_1333982 in test_dis, which had been
  disabled since 3.0 due to the changes in listcomp handling.

* bpo-19320: test_tcl no longer fails when wantobjects is false.

* bpo-19919: Fix flaky SSL test. connect_ex() sometimes returns
  EWOULDBLOCK on Windows or VMs hosted on Windows.

* bpo-19912: Added tests for ntpath.splitunc().

* bpo-19828: Fixed test_site when the whole suite is run with -S.

* bpo-19928: Implemented a test for repr() of cell objects.

* bpo-19535: Fixed test_docxmlrpc, test_functools, test_inspect, and
  test_statistics when python is run with -OO.

* bpo-19926: Removed unneeded test_main from test_abstract_numbers.
  Patch by Vajrasky Kok.

* bpo-19572: More skipped tests explicitly marked as skipped.

* bpo-19595: Re-enabled a long-disabled test in test_winsound. (See
  also: bpo-19987)

* bpo-19588: Fixed tests in test_random that were silently skipped
  most of the time. Patch by Julian Gindi.


Build
-----

* bpo-19728: Enable pip installation by default on Windows.

* bpo-16136: Remove VMS support

* bpo-18215: Add script Tools/ssl/test_multiple_versions.py to
  compile and run Python's unit tests with multiple versions of
  OpenSSL.

* bpo-19922: define _INCLUDE__STDC_A1_SOURCE in HP-UX to include
  mbstate_t for mbrtowc().

* bpo-19788: kill_python(_d).exe is now run as a PreBuildEvent on
  the pythoncore sub- project.  This should prevent build errors due a
  previous build's python(_d).exe still running.


Documentation
-------------

* bpo-20265: Updated some parts of the Using Windows document.

* bpo-20266: Updated some parts of the Windows FAQ.

* bpo-20255: Updated the about and bugs pages.

* bpo-20253: Fixed a typo in the ipaddress docs that advertised an
  illegal attribute name.  Found by INADA Naoki.

* bpo-18840: Introduce the json module in the tutorial, and de-
  emphasize the pickle module.

* bpo-19845: Updated the Compiling Python on Windows section.

* bpo-19795: Improved markup of True/False constants.


Tools/Demos
-----------

* bpo-19659: Added documentation for Argument Clinic.

* bpo-19976: Argument Clinic METH_NOARGS functions now always take
  two parameters.


Python 3.4.0 beta 1
===================

*Release date: 2013-11-24*


Core and Builtins
-----------------

* Use the repr of a module name in more places in import, especially
  exceptions.

* bpo-19619: str.encode, bytes.decode and bytearray.decode now use
  an internal API to throw LookupError for known non-text encodings,
  rather than attempting the encoding or decoding operation and then
  throwing a TypeError for an unexpected output type. (The latter
  mechanism remains in place for third party non-text encodings)

* bpo-19183: Implement PEP 456 'secure and interchangeable hash
  algorithm'. Python now uses SipHash24 on all major platforms.

* bpo-12892: The utf-16* and utf-32* encoders no longer allow
  surrogate code points (U+D800-U+DFFF) to be encoded.  The utf-32*
  decoders no longer decode byte sequences that correspond to
  surrogate code points.  The surrogatepass error handler now works
  with the utf-16* and utf-32* codecs. Based on patches by Victor
  Stinner and Kang-Hao (Kenny) Lu.

* bpo-17806: Added keyword-argument support for "tabsize" to
  str/bytes.expandtabs().

* bpo-17828: Output type errors in str.encode(), bytes.decode() and
  bytearray.decode() now direct users to codecs.encode() or
  codecs.decode() as appropriate.

* bpo-17828: The interpreter now attempts to chain errors that occur
  in codec processing with a replacement exception of the same type
  that includes the codec name in the error message. It ensures it
  only does this when the creation of the replacement exception won't
  lose any information.

* bpo-19466: Clear the frames of daemon threads earlier during the
  Python shutdown to call objects destructors. So "unclosed file"
  resource warnings are now corretly emitted for daemon threads.

* bpo-19514: Deduplicate some _Py_IDENTIFIER declarations. Patch by
  Andrei Dorian Duma.

* bpo-17936: Fix O(n**2) behaviour when adding or removing many
  subclasses of a given type.

* bpo-19428: zipimport now handles errors when reading truncated or
  invalid ZIP archive.

* bpo-18408: Add a new PyFrame_FastToLocalsWithError() function to
  handle exceptions when merging fast locals into f_locals of a frame.
  PyEval_GetLocals() now raises an exception and return NULL on
  failure.

* bpo-19369: Optimized the usage of __length_hint__().

* bpo-18603: Ensure that PyOS_mystricmp and PyOS_mystrnicmp are in
  the Python executable and not removed by the linker's optimizer.

* bpo-19306: Add extra hints to the faulthandler module's stack
  dumps that these are "upside down".


Library
-------

* bpo-3158: doctest can now find doctests in functions and methods
  written in C.

* bpo-13477: Added command line interface to the tarfile module.
  Original patch by Berker Peksag.

* bpo-19674: inspect.signature() now produces a correct signature
  for some builtins.

* bpo-19722: Added opcode.stack_effect(), which computes the stack
  effect of bytecode instructions.

* bpo-19735: Implement private function ssl._create_stdlib_context()
  to create SSLContext objects in Python's stdlib module. It provides
  a single configuration point and makes use of
  SSLContext.load_default_certs().

* bpo-16203: Add re.fullmatch() function and regex.fullmatch()
  method, which anchor the pattern at both ends of the string to
  match. Original patch by Matthew Barnett.

* bpo-13592: Improved the repr for regular expression pattern
  objects. Based on patch by Hugo Lopes Tavares.

* bpo-19641: Added the audioop.byteswap() function to convert big-
  endian samples to little-endian and vice versa.

* bpo-15204: Deprecated the 'U' mode in file-like objects.

* bpo-17810: Implement PEP 3154, pickle protocol 4.

* bpo-19668: Added support for the cp1125 encoding.

* bpo-19689: Add ssl.create_default_context() factory function. It
  creates a new SSLContext object with secure default settings.

* bpo-19727: os.utime(..., None) is now potentially more precise
  under Windows.

* bpo-17201: ZIP64 extensions now are enabled by default.  Patch by
  William Mallard.

* bpo-19292: Add SSLContext.load_default_certs() to load default
  root CA certificates from default stores or system stores. By
  default the method loads CA certs for authentication of server
  certs.

* bpo-19673: Add pathlib to the stdlib as a provisional module (PEP
  428).

* bpo-16596: pdb in a generator now properly skips over yield and
  yield from rather than stepping out of the generator into its
  caller.  (This is essential for stepping through asyncio
  coroutines.)

* bpo-17916: Added dis.Bytecode.from_traceback() and
  dis.Bytecode.current_offset to easily display "current instruction"
  markers in the new disassembly API (Patch by Claudiu Popa).

* bpo-19552: venv now supports bootstrapping pip into virtual
  environments

* bpo-17134: Finalize interface to Windows' certificate store. Cert
  and CRL enumeration are now two functions. enum_certificates() also
  returns purpose flags as set of OIDs.

* bpo-19555: Restore sysconfig.get_config_var('SO'), (and the
  distutils equivalent) with a DeprecationWarning pointing people at
  $EXT_SUFFIX.

* bpo-8813: Add SSLContext.verify_flags to change the verification
  flags of the context in order to enable certification revocation
  list (CRL) checks or strict X509 rules.

* bpo-18294: Fix the zlib module to make it 64-bit safe.

* bpo-19682: Fix compatibility issue with old version of OpenSSL
  that was introduced by Issue #18379.

* bpo-14455: plistlib now supports binary plists and has an updated
  API.

* bpo-19633: Fixed writing not compressed 16- and 32-bit wave files
  on big-endian platforms.

* bpo-18379: SSLSocket.getpeercert() returns CA issuer AIA fields,
  OCSP and CRL distribution points.

* bpo-18138: Implement cadata argument of
  SSLContext.load_verify_location() to load CA certificates and CRL
  from memory. It supports PEM and DER encoded strings.

* bpo-18775: Add name and block_size attribute to HMAC object. They
  now provide the same API elements as non-keyed cryptographic hash
  functions.

* bpo-17276: MD5 as default digestmod for HMAC is deprecated. The
  HMAC module supports digestmod names, e.g. hmac.HMAC('sha1').

* bpo-19449: in csv's writerow, handle non-string keys when
  generating the error message that certain keys are not in the
  'fieldnames' list.

* bpo-13633: Added a new convert_charrefs keyword arg to HTMLParser
  that, when True, automatically converts all character references.

* bpo-2927: Added the unescape() function to the html module.

* bpo-8402: Added the escape() function to the glob module.

* bpo-17618: Add Base85 and Ascii85 encoding/decoding to the base64
  module.

* bpo-19634: time.strftime("%y") now raises a ValueError on AIX when
  given a year before 1900.

* Fix test.support.bind_port() to not cause an error when Python was
  compiled on a system with SO_REUSEPORT defined in the headers but
  run on a system with an OS kernel that does not support that
  reasonably new socket option.

* Fix compilation error under gcc of the ctypes module bundled
  libffi for arm.

* bpo-19448: Add private API to SSL module to lookup ASN.1 objects
  by OID, NID, short name and long name.

* bpo-19282: dbm.open now supports the context management protocol.
  (Inital patch by Claudiu Popa)

* bpo-8311: Added support for writing any bytes-like objects in the
  aifc, sunau, and wave modules.

* bpo-5202: Added support for unseekable files in the wave module.

* bpo-19544: Restore global option to ignore ~/.pydistutils.cfg in
  Distutils, accidentally removed in backout of distutils2 changes.
  (See also: bpo-1180)

* bpo-19523: Closed FileHandler leak which occurred when delay was
  set.

* bpo-19544: Restore support for --user and --group parameters to
  sdist command accidentally rolled back as part of the distutils2
  rollback. (See also: bpo-6516)

* bpo-13674: Prevented time.strftime from crashing on Windows when
  given a year before 1900 and a format of %y.

* bpo-19406: implementation of the ensurepip module (part of PEP
  453). Patch by Donald Stufft and Nick Coghlan.

* bpo-19544: Restore use of urllib over http allowing use of
  http_proxy for Distutils upload command, a feature accidentally lost
  in the rollback of distutils2. (See also: bpo-6286)

* bpo-19544: Restore the read_pkg_file method to
  distutils.dist.DistributionMetadata accidentally removed in the undo
  of distutils2. (See also: bpo-7457)

* bpo-16685: Added support for any bytes-like objects in the audioop
  module. Removed support for strings.

* bpo-7171: Add Windows implementation of "inet_ntop" and
  "inet_pton" to socket module. Patch by Atsuo Ishimoto.

* bpo-19261: Added support for writing 24-bit samples in the sunau
  module.

* bpo-1097797: Added CP273 encoding, used on IBM mainframes in
  Germany and Austria. Mapping provided by Michael Bierenfeld.

* bpo-1575020: Fixed support of 24-bit wave files on big-endian
  platforms.

* bpo-19378: Fixed a number of cases in the dis module where the new
  "file" parameter was not being honoured correctly

* bpo-19378: Removed the "dis.Bytecode.show_info" method

* bpo-19378: Renamed the "dis.Bytecode.display_code" method to
  "dis.Bytecode.dis" and converted it to returning a string rather
  than printing output.

* bpo-19378: the "line_offset" parameter in the new
  "dis.get_instructions" API has been renamed to "first_line" (and the
  default value and usage changed accordingly). This should reduce
  confusion with the more common use of "offset" in the dis docs to
  refer to bytecode offsets.

* bpo-18678: Corrected spwd struct member names in spwd module:
  sp_nam->sp_namp, and sp_pwd->sp_pwdp.  The old names are kept as
  extra structseq members, for backward compatibility.

* bpo-6157: Fixed tkinter.Text.debug().  tkinter.Text.bbox() now
  raises TypeError instead of TclError on wrong number of arguments.
  Original patch by Guilherme Polo.

* bpo-10197: Rework subprocess.get[status]output to use subprocess
  functionality and thus to work on Windows. Patch by Nick Coghlan

* bpo-6160: The bbox() method of tkinter.Spinbox now returns a tuple
  of integers instead of a string.  Based on patch by Guilherme Polo.

* bpo-19403: contextlib.redirect_stdout is now reentrant

* bpo-19286: Directories in "package_data" are no longer added to
  the filelist, preventing failure outlined in the ticket.

* bpo-19480: HTMLParser now accepts all valid start-tag names as
  defined by the HTML5 standard.

* bpo-15114: The html.parser module now raises a DeprecationWarning
  when the strict argument of HTMLParser or the HTMLParser.error
  method are used.

* bpo-19410: Undo the special-casing removal of '' for
  importlib.machinery.FileFinder.

* bpo-19424: Fix the warnings module to accept filename containing
  surrogate characters.

* bpo-19435: Fix directory traversal attack on
  CGIHttpRequestHandler.

* bpo-19227: Remove pthread_atfork() handler. The handler was added
  to solve #18747 but has caused issues.

* bpo-19420: Fix reference leak in module initalization code of
  _hashopenssl.c

* bpo-19329: Optimized compiling charsets in regular expressions.

* bpo-19227: Try to fix deadlocks caused by re-seeding then OpenSSL
  pseudo-random number generator on fork().

* bpo-16037: HTTPMessage.readheaders() raises an HTTPException when
  more than 100 headers are read.  Adapted from patch by Jyrki
  Pulliainen.

* bpo-16040: CVE-2013-1752: nntplib: Limit maximum line lengths to
  2048 to prevent readline() calls from consuming too much memory.
  Patch by Jyrki Pulliainen.

* bpo-16041: CVE-2013-1752: poplib: Limit maximum line lengths to
  2048 to prevent readline() calls from consuming too much memory.
  Patch by Jyrki Pulliainen.

* bpo-17997: Change behavior of "ssl.match_hostname()" to follow RFC
  6125, for security reasons.  It now doesn't match multiple wildcards
  nor wildcards inside IDN fragments.

* bpo-16039: CVE-2013-1752: Change use of readline in imaplib module
  to limit line length.  Patch by Emil Lind.

* bpo-19330: the unnecessary wrapper functions have been removed
  from the implementations of the new contextlib.redirect_stdout and
  contextlib.suppress context managers, which also ensures they
  provide reasonable help() output on instances

* bpo-19393: Fix symtable.symtable function to not be confused when
  there are functions or classes named "top".

* bpo-18685: Restore re performance to pre-PEP 393 levels.

* bpo-19339: telnetlib module is now using time.monotonic() when
  available to compute timeout.

* bpo-19399: fix sporadic test_subprocess failure.

* bpo-13234: Fix os.listdir to work with extended paths on Windows.
  Patch by Santoso Wijaya.

* bpo-19375: The site module adding a "site-python" directory to
  sys.path, if it exists, is now deprecated.

* bpo-19379: Lazily import linecache in the warnings module, to make
  startup with warnings faster until a warning gets printed.

* bpo-19288: Fixed the "in" operator of dbm.gnu databases for string
  argument.  Original patch by Arfrever Frehtes Taifersar Arahesis.

* bpo-19287: Fixed the "in" operator of dbm.ndbm databases for
  string argument.  Original patch by Arfrever Frehtes Taifersar
  Arahesis.

* bpo-19327: Fixed the working of regular expressions with too big
  charset.

* bpo-17400: New 'is_global' attribute for ipaddress to tell if an
  address is allocated by IANA for global or private networks.

* bpo-19350: Increasing the test coverage of macurl2path. Patch by
  Colin Williams.

* bpo-19365: Optimized the parsing of long replacement string in
  re.sub*() functions.

* bpo-19352: Fix unittest discovery when a module can be reached
  through several paths (e.g. under Debian/Ubuntu with virtualenv).

* bpo-15207: Fix mimetypes to read from correct part of Windows
  registry Original patch by Dave Chambers

* bpo-16595: Add prlimit() to resource module.

* bpo-19324: Expose Linux-specific constants in resource module.

* Load SSL's error strings in hashlib.

* bpo-18527: Upgrade internal copy of zlib to 1.2.8.

* bpo-19274: Add a filterfunc parameter to PyZipFile.writepy.

* bpo-8964: fix platform._sys_version to handle IronPython 2.6+.
  Patch by Martin Matusiak.

* bpo-19413: Restore pre-3.3 reload() semantics of re-finding
  modules.

* bpo-18958: Improve error message for json.load(s) while passing a
  string that starts with a UTF-8 BOM.

* bpo-19307: Improve error message for json.load(s) while passing
  objects of the wrong type.

* bpo-16038: CVE-2013-1752: ftplib: Limit amount of data read by
  limiting the call to readline().  Original patch by Michał
  Jastrzębski and Giampaolo Rodola.

* bpo-17087: Improved the repr for regular expression match objects.


Tests
-----

* bpo-19664: test_userdict's repr test no longer depends on the
  order of dict elements.

* bpo-19440: Clean up test_capi by removing an unnecessary
  __future__ import, converting from test_main to unittest.main, and
  running the _testcapi module tests as subTests of a unittest
  TestCase method.

* bpo-19378: the main dis module tests are now run with both stdout
  redirection *and* passing an explicit file parameter

* bpo-19378: removed the not-actually-helpful
  assertInstructionMatches and assertBytecodeExactlyMatches helpers
  from bytecode_helper

* bpo-18702: All skipped tests now reported as skipped.

* bpo-19439: interpreter embedding tests are now executed on Windows
  (Patch by Zachary Ware)

* bpo-19085: Added basic tests for all tkinter widget options.

* bpo-19384: Fix test_py_compile for root user, patch by Claudiu
  Popa.


Documentation
-------------

* bpo-18326: Clarify that list.sort's arguments are keyword-only.
  Also, attempt to reduce confusion in the glossary by not saying
  there are different "types" of arguments and parameters.


Build
-----

* bpo-19358: "make clinic" now runs the Argument Clinic preprocessor
  over all CPython source files.

* Update SQLite to 3.8.1, xz to 5.0.5, and Tcl/Tk to 8.6.1 on
  Windows.

* bpo-16632: Enable DEP and ASLR on Windows.

* bpo-17791: Drop PREFIX and EXEC_PREFIX definitions from
  PC/pyconfig.h

* Add workaround for VS 2010 nmake clean issue. VS 2010 doesn't set
  up PATH for nmake.exe correctly.

* bpo-19550: Implement Windows installer changes of PEP 453
  (ensurepip).

* bpo-19520: Fix compiler warning in the _sha3 module on 32bit
  Windows.

* bpo-19356: Avoid using a C variabled named "_self", it's a
  reserved word in some C compilers.

* bpo-15792: Correct build options on Win64. Patch by Jeremy Kloth.

* bpo-19373: Apply upstream change to Tk 8.5.15 fixing OS X 10.9
  screen refresh problem for OS X installer build.

* bpo-19649: On OS X, the same set of file names are now installed
  in bin directories for all configurations: non-framework vs
  framework, and single arch vs universal builds.  pythonx.y-32 is now
  always installed for 64-bit/32-bit universal builds.  The obsolete
  and undocumented pythonw* symlinks are no longer installed anywhere.

* bpo-19553: PEP 453 - "make install" and "make altinstall" now
  install or upgrade pip by default, using the bundled pip provided by
  the new ensurepip module.  A new configure option, --with-
  ensurepip[=upgrade|install|no], is available to override the default
  ensurepip "--upgrade" option.  The option can also be set with "make
  [alt]install ENSUREPIP=[upgrade|install|no]".

* bpo-19551: PEP 453 - the OS X installer now installs pip by
  default.

* Update third-party libraries for OS X installers: xz 5.0.3 ->
  5.0.5, SQLite 3.7.13 -> 3.8.1

* bpo-15663: Revert OS X installer built-in Tcl/Tk support for
  3.4.0b1. Some third-party projects, such as Matplotlib and
  PIL/Pillow, depended on being able to build with Tcl and Tk
  frameworks in /Library/Frameworks.


Tools/Demos
-----------

* bpo-19730: Argument Clinic now supports all the existing PyArg
  "format units" as legacy converters, as well as two new features:
  "self converters" and the "version" directive.

* bpo-19552: pyvenv now bootstraps pip into virtual environments by
  default (pass --without-pip to request the old behaviour)

* bpo-19390: Argument Clinic no longer accepts malformed Python and
  C ids.


Python 3.4.0 alpha 4
====================

*Release date: 2013-10-20*


Core and Builtins
-----------------

* bpo-19301: Give classes and functions that are explicitly marked
  global a global qualname.

* bpo-19279: UTF-7 decoder no longer produces illegal strings.

* bpo-16612: Add "Argument Clinic", a compile-time preprocessor for
  C files to generate argument parsing code.  (See PEP 436.)

* bpo-18810: Shift stat calls in importlib.machinery.FileFinder such
  that the code is optimistic that if something exists in a directory
  named exactly like the possible package being searched for that it's
  in actuality a directory.

* bpo-18416: importlib.machinery.PathFinder now treats '' as the cwd
  and importlib.machinery.FileFinder no longer special-cases '' to
  '.'. This leads to modules imported from cwd to now possess an
  absolute file path for __file__ (this does not affect modules
  specified by path on the CLI but it does affect -m/runpy). It also
  allows FileFinder to be more consistent by not having an edge case.

* bpo-4555: All exported C symbols are now prefixed with either "Py"
  or "_Py".

* bpo-19219: Speed up marshal.loads(), and make pyc files slightly
  (5% to 10%) smaller.

* bpo-19221: Upgrade Unicode database to version 6.3.0.

* bpo-16742: The result of the C callback
  PyOS_ReadlineFunctionPointer must now be a string allocated by
  PyMem_RawMalloc() or PyMem_RawRealloc() (or NULL if an error
  occurred), instead of a string allocated by PyMem_Malloc() or
  PyMem_Realloc().

* bpo-19199: Remove "PyThreadState.tick_counter" field

* Fix macro expansion of _PyErr_OCCURRED(), and make sure to use it
  in at least one place so as to avoid regressions.

* bpo-19087: Improve bytearray allocation in order to allow cheap
  popping of data at the front (slice deletion).

* bpo-19014: memoryview.cast() is now allowed on zero-length views.

* bpo-18690: memoryview is now automatically registered with
  collections.abc.Sequence

* bpo-19078: memoryview now correctly supports the reversed builtin
  (Patch by Claudiu Popa)


Library
-------

* bpo-17457: unittest test discovery now works with namespace
  packages. Patch by Claudiu Popa.

* bpo-18235: Fix the sysconfig variables LDSHARED and BLDSHARED
  under AIX. Patch by David Edelsohn.

* bpo-18606: Add the new "statistics" module (PEP 450).  Contributed
  by Steven D'Aprano.

* bpo-12866: The audioop module now supports 24-bit samples.

* bpo-19254: Provide an optimized Python implementation of
  pbkdf2_hmac.

* bpo-19201: Add "x" mode (exclusive creation) in opening file to
  bz2, gzip and lzma modules. Patches by Tim Heaney and Vajrasky Kok.
  (See also: bpo-19222, bpo-19223)

* Fix a reference count leak in _sre.

* bpo-19262: Initial check in of the 'asyncio' package (a.k.a.
  Tulip, a.k.a. PEP 3156). There are no docs yet, and the PEP is
  slightly out of date with the code. This module will have
  *provisional* status in Python 3.4.

* bpo-19276: Fixed the wave module on 64-bit big-endian platforms.

* bpo-19266: Rename the new-in-3.4 "contextlib.ignore" context
  manager to "contextlib.suppress" in order to be more consistent with
  existing descriptions of that operation elsewhere in the language
  and standard library documentation (Patch by Zero Piraeus).

* bpo-18891: Completed the new email package (provisional) API
  additions by adding new classes EmailMessage, MIMEPart, and
  ContentManager.

* bpo-18281: Unused stat constants removed from "tarfile".

* bpo-18999: Multiprocessing now supports 'contexts' with the same
  API as the module, but bound to specified start methods.

* bpo-18468: The re.split, re.findall, and re.sub functions and the
  group() and groups() methods of match object now always return a
  string or a bytes object.

* bpo-18725: The textwrap module now supports truncating multiline
  text.

* bpo-18776: atexit callbacks now display their full traceback when
  they raise an exception.

* bpo-17827: Add the missing documentation for "codecs.encode" and
  "codecs.decode".

* bpo-19218: Rename collections.abc to _collections_abc in order to
  speed up interpreter start.

* bpo-18582: Add 'pbkdf2_hmac' to the hashlib module. It implements
  PKCS#5 password-based key derivation functions with HMAC as
  pseudorandom function.

* bpo-19131: The aifc module now correctly reads and writes
  sampwidth of compressed streams.

* bpo-19209: Remove import of copyreg from the os module to speed up
  interpreter startup. stat_result and statvfs_result are now hard-
  coded to reside in the os module.

* bpo-19205: Don't import the 're' module in site and sysconfig
  module to speed up interpreter start.

* bpo-9548: Add a minimal "_bootlocale" module that is imported by
  the _io module instead of the full locale module.

* bpo-18764: Remove the 'print' alias for the PDB 'p' command so
  that it no longer shadows the print function.

* bpo-19158: A rare race in BoundedSemaphore could allow .release()
  too often.

* bpo-15805: Add contextlib.redirect_stdout().

* bpo-18716: Deprecate the formatter module.

* bpo-10712: 2to3 has a new "asserts" fixer that replaces deprecated
  names of unittest methods (e.g. failUnlessEqual -> assertEqual).

* bpo-18037: 2to3 now escapes "'\u'" and "'\U'" in native strings.

* bpo-17839: base64.decodebytes and base64.encodebytes now accept
  any object that exports a 1 dimensional array of bytes (this means
  the same is now also true for base64_codec)

* bpo-19132: The pprint module now supports compact mode.

* bpo-19137: The pprint module now correctly formats instances of
  set and frozenset subclasses.

* bpo-10042: functools.total_ordering now correctly handles
  NotImplemented being returned by the underlying comparison function
  (Patch by Katie Miller)

* bpo-19092: contextlib.ExitStack now correctly reraises exceptions
  from the __exit__ callbacks of inner context managers (Patch by
  Hrvoje Nikšić)

* bpo-12641: Avoid passing "-mno-cygwin" to the mingw32 compiler,
  except when necessary. Patch by Oscar Benjamin.

* bpo-5845: In site.py, only load readline history from
  ~/.python_history if no history has been read already.  This avoids
  double writes to the history file at shutdown.

* Properly initialize all fields of a SSL object after allocation.

* bpo-19095: SSLSocket.getpeercert() now raises ValueError when the
  SSL handshake hasn't been done.

* bpo-4366: Fix building extensions on all platforms when --enable-
  shared is used.

* bpo-19030: Fixed "inspect.getmembers" and
  "inspect.classify_class_attrs" to attempt activating descriptors
  before falling back to a __dict__ search for faulty descriptors.
  "inspect.classify_class_attrs" no longer returns Attributes whose
  home class is None.


C API
-----

* bpo-1772673: The type of "char*" arguments now changed to "const
  char*".

* bpo-16129: Added a "Py_SetStandardStreamEncoding" pre-
  initialization API to allow embedding applications like Blender to
  force a particular encoding and error handler for the standard IO
  streams (initial patch by Bastien Montagne)


Tests
-----

* bpo-19275: Fix test_site on AMD64 Snow Leopard

* bpo-14407: Fix unittest test discovery in test_concurrent_futures.

* bpo-18919: Unified and extended tests for audio modules: aifc,
  sunau and wave.

* bpo-18714: Added tests for "pdb.find_function()".


Documentation
-------------

* bpo-18758: Fixed and improved cross-references.

* bpo-18972: Modernize email examples and use the argparse module in
  them.


Build
-----

* bpo-19130: Correct PCbuild/readme.txt, Python 3.3 and 3.4 require
  VS 2010.

* bpo-15663: Update OS X 10.6+ installer to use Tcl/Tk 8.5.15.

* bpo-14499: Fix several problems with OS X universal build support:
  1. ppc arch detection for extension module builds broke with Xcode 5
  2. ppc arch detection in configure did not work on OS X 10.4   3.
  -sysroot and -arch flags were unnecessarily duplicated   4. there
  was no obvious way to configure an intel-32 only build.

* bpo-19019: Change the OS X installer build script to use CFLAGS
  instead of OPT for special build options.  By setting OPT, some
  compiler-specific options like -fwrapv were overridden and thus not
  used, which could result in broken interpreters when building with
  clang.


Python 3.4.0 alpha 3
====================

*Release date: 2013-09-29*


Core and Builtins
-----------------

* bpo-18818: The "encodingname" part of PYTHONIOENCODING is now
  optional.

* bpo-19098: Prevent overflow in the compiler when the recursion
  limit is set absurdly high.


Library
-------

* bpo-18929: "inspect.classify_class_attrs()" now correctly finds
  class attributes returned by "dir()" that are located in the
  metaclass.

* bpo-18950: Fix miscellaneous bugs in the sunau module.
  Au_read.readframes() now updates current file position and reads
  correct number of frames from multichannel stream.
  Au_write.writeframesraw() now correctly updates current file
  position.  Au_read.getnframes() now returns an integer (as in Python
  2). Au_read and Au_write now correctly works with file object if
  start file position is not a zero.

* bpo-18594: The fast path for collections.Counter() was never taken
  due to an over- restrictive type check.

* bpo-19053: ZipExtFile.read1() with non-zero argument no more
  returns empty bytes until end of data.

* logging: added support for Unix domain sockets to SocketHandler
  and DatagramHandler.

* bpo-18996: TestCase.assertEqual() now more cleverly shorten
  differing strings in error report.

* bpo-19034: repr() for tkinter.Tcl_Obj now exposes string
  reperesentation.

* bpo-18978: "urllib.request.Request" now allows the method to be
  indicated on the class and no longer sets it to None in "__init__".

* bpo-18626: the inspect module now offers a basic command line
  introspection interface (Initial patch by Claudiu Popa)

* bpo-3015: Fixed tkinter with wantobject=False.  Any Tcl command
  call returned empty string.

* bpo-19037: The mailbox module now makes all changes to maildir
  files before moving them into place, to avoid race conditions with
  other programs that may be accessing the maildir directory.

* bpo-14984: On POSIX systems, when netrc is called without a
  filename argument (and therefore is reading the user's $HOME/.netrc
  file), it now enforces the same security rules as typical ftp
  clients: the .netrc file must be owned by the user that owns the
  process and must not be readable by any other user.

* bpo-18873: The tokenize module now detects Python source code
  encoding only in comment lines.

* bpo-17764: Enable http.server to bind to a user specified network
  interface.  Patch contributed by Malte Swart.

* bpo-18937: Add an assertLogs() context manager to
  unittest.TestCase to ensure that a block of code emits a message
  using the logging module.

* bpo-17324: Fix http.server's request handling case on trailing
  '/'. Patch contributed by Vajrasky Kok.

* bpo-19018: The heapq.merge() function no longer suppresses
  IndexError in the underlying iterables.

* bpo-18784: The uuid module no longer attempts to load libc via
  ctypes.CDLL if all the necessary functions have already been found
  in libuuid.  Patch by Evgeny Sologubov.

* The "PYTHONFAULTHANDLER" environment variable now only enables the
  faulthandler module if the variable is non-empty. Same behaviour
  than other variables like "PYTHONDONTWRITEBYTECODE".

* bpo-1565525: New function "traceback.clear_frames" will clear the
  local variables of all the stack frames referenced by a traceback
  object.


Tests
-----

* bpo-18952: Fix regression in support data downloads introduced
  when test.support was converted to a package. Regression noticed by
  Zachary Ware.


IDLE
----

* bpo-18873: IDLE now detects Python source code encoding only in
  comment lines.

* bpo-18988: The "Tab" key now works when a word is already
  autocompleted.


Documentation
-------------

* bpo-17003: Unified the size argument names in the io module with
  common practice.


Build
-----

* bpo-18596: Support the use of address sanity checking in recent
  versions of clang and GCC by appropriately marking known false
  alarms in the small object allocator. Patch contributed by Dhiru
  Kholia.


Tools/Demos
-----------

* bpo-18873: 2to3 and the findnocoding.py script now detect Python
  source code encoding only in comment lines.


Python 3.4.0 alpha 2
====================

*Release date: 2013-09-09*


Core and Builtins
-----------------

* bpo-18942: sys._debugmallocstats() output was damaged on Windows.

* bpo-18571: Implementation of the PEP 446: file descriptors and
  file handles are now created non-inheritable; add functions
  os.get/set_inheritable(), os.get/set_handle_inheritable() and
  socket.socket.get/set_inheritable().

* bpo-11619: The parser and the import machinery do not encode
  Unicode filenames anymore on Windows.

* bpo-18808: Non-daemon threads are now automatically joined when a
  sub-interpreter is shutdown (it would previously dump a fatal
  error).

* Remove support for compiling on systems without getcwd().

* bpo-18774: Remove last bits of GNU PTH thread code and
  thread_pth.h.

* bpo-18771: Add optimization to set object lookups to reduce the
  cost of hash collisions.  The core idea is to inspect a second
  key/hash pair for each cache line retrieved.

* bpo-16105: When a signal handler fails to write to the file
  descriptor registered with "signal.set_wakeup_fd()", report an
  exception instead of ignoring the error.

* bpo-18722: Remove uses of the "register" keyword in C code.

* bpo-18667: Add missing "HAVE_FCHOWNAT" symbol to
  posix._have_functions.

* bpo-16499: Add command line option for isolated mode.

* bpo-15301: Parsing fd, uid, and gid parameters for builtins in
  Modules/posixmodule.c is now far more robust.

* bpo-18368: PyOS_StdioReadline() no longer leaks memory when
  realloc() fail.

* bpo-17934: Add a clear() method to frame objects, to help clean up
  expensive details (local variables) and break reference cycles.

* bpo-18780: %-formatting codes %d, %i, and %u now treat int-
  subclasses as int (displays value of int-subclass instead of str
  (int-subclass) ).


Library
-------

* bpo-18808: Thread.join() now waits for the underlying thread state
  to be destroyed before returning.  This prevents unpredictable
  aborts in Py_EndInterpreter() when some non-daemon threads are still
  running.

* bpo-18458: Prevent crashes with newer versions of libedit.  Its
  readline emulation has changed from 0-based indexing to 1-based like
  gnu readline.

* bpo-18852: Handle case of "readline.__doc__" being "None" in the
  new readline activation code in "site.py".

* bpo-18672: Fixed format specifiers for Py_ssize_t in debugging
  output in the _sre module.

* bpo-18830: inspect.getclasstree() no longer produces duplicate
  entries even when input list contains duplicates.

* bpo-18878: sunau.open now supports the context management
  protocol. Based on patches by Claudiu Popa and R. David Murray.

* bpo-18909: Fix _tkinter.tkapp.interpaddr() on Windows 64-bit,
  don't cast 64-bit pointer to long (32 bits).

* bpo-18876: The FileIO.mode attribute now better reflects the
  actual mode under which the file was opened.  Patch by Erik Bray.

* bpo-16853: Add new selectors module.

* bpo-18882: Add threading.main_thread() function.

* bpo-18901: The sunau getparams method now returns a namedtuple
  rather than a plain tuple.  Patch by Claudiu Popa.

* bpo-17487: The result of the wave getparams method now is
  pickleable again. Patch by Claudiu Popa.

* bpo-18756: os.urandom() now uses a lazily-opened persistent file
  descriptor, so as to avoid using many file descriptors when run in
  parallel from multiple threads.

* bpo-18418: After fork(), reinit all threads states, not only
  active ones. Patch by A. Jesse Jiryu Davis.

* bpo-17974: Switch unittest from using getopt to using argparse.

* bpo-11798: TestSuite now drops references to own tests after
  execution.

* bpo-16611: http.cookie now correctly parses the 'secure' and
  'httponly' cookie flags.

* bpo-11973: Fix a problem in kevent. The flags and fflags fields
  are now properly handled as unsigned.

* bpo-18807: "pyvenv" now takes a --copies argument allowing copies
  instead of symlinks even where symlinks are available and the
  default.

* bpo-18538: "python -m dis" now uses argparse for argument
  processing. Patch by Michele Orrù.

* bpo-18394: Close cgi.FieldStorage's optional file.

* bpo-17702: On error, os.environb now suppresses the exception
  context when raising a new KeyError with the original key.

* bpo-16809: Fixed some tkinter incompabilities with Tcl/Tk 8.6.

* bpo-16809: Tkinter's splitlist() and split() methods now accept
  Tcl_Obj argument.

* bpo-18324: set_payload now correctly handles binary input.  This
  also supersedes the previous fixes for #14360, #1717, and #16564.

* bpo-18794: Add a fileno() method and a closed attribute to
  select.devpoll objects.

* bpo-17119: Fixed integer overflows when processing large strings
  and tuples in the tkinter module.

* bpo-18747: Re-seed OpenSSL's pseudo-random number generator after
  fork. A pthread_atfork() parent handler is used to seed the PRNG
  with pid, time and some stack data.

* bpo-8865: Concurrent invocation of select.poll.poll() now raises a
  RuntimeError exception.  Patch by Christian Schubert.

* bpo-18777: The ssl module now uses the new CRYPTO_THREADID API of
  OpenSSL 1.0.0+ instead of the deprecated CRYPTO id callback
  function.

* bpo-18768: Correct doc string of RAND_edg(). Patch by Vajrasky
  Kok.

* bpo-18178: Fix ctypes on BSD. dlmalloc.c was compiled twice which
  broke malloc weak symbols.

* bpo-18709: Fix CVE-2013-4238. The SSL module now handles NULL
  bytes inside subjectAltName correctly. Formerly the module has used
  OpenSSL's GENERAL_NAME_print() function to get the string
  represention of ASN.1 strings for "rfc822Name" (email), "dNSName"
  (DNS) and "uniformResourceIdentifier" (URI).

* bpo-18701: Remove support of old CPython versions (<3.0) from C
  code.

* bpo-18756: Improve error reporting in os.urandom() when the
  failure is due to something else than /dev/urandom not existing (for
  example, exhausting the file descriptor limit).

* bpo-18673: Add O_TMPFILE to os module. O_TMPFILE requires Linux
  kernel 3.11 or newer. It's only defined on system with 3.11 uapi
  headers, too.

* bpo-18532: Change the builtin hash algorithms' names to lower case
  names as promised by hashlib's documentation.

* bpo-8713: add new spwan and forkserver start methods, and new
  functions get_all_start_methods, get_start_method, and
  set_start_method, to multiprocessing.

* bpo-18405: Improve the entropy of crypt.mksalt().

* bpo-12015: The tempfile module now uses a suffix of 8 random
  characters instead of 6, to reduce the risk of filename collision.
  The entropy was reduced when uppercase letters were removed from the
  charset used to generate random characters.

* bpo-18585: Add "textwrap.shorten()" to collapse and truncate a
  piece of text to a given length.

* bpo-18598: Tweak exception message for importlib.import_module()
  to include the module name when a key argument is missing.

* bpo-19151: Fix docstring and use of _get_supported_file_loaders()
  to reflect 2-tuples.

* bpo-19152: Add ExtensionFileLoader.get_filename().

* bpo-18676: Change 'positive' to 'non-negative' in queue.py put and
  get docstrings and ValueError messages. Patch by Zhongyue Luo

* Fix refcounting issue with extension types in tkinter.

* bpo-8112: xlmrpc.server's DocXMLRPCServer server no longer raises
  an error if methods have annotations; it now correctly displays the
  annotations.

* bpo-18600: Added policy argument to
  email.message.Message.as_string, and as_bytes and __bytes__ methods
  to Message.

* bpo-18671: Output more information when logging exceptions occur.

* bpo-18621: Prevent the site module's patched builtins from keeping
  too many references alive for too long.

* bpo-4885: Add weakref support to mmap objects.  Patch by Valerie
  Lambert.

* bpo-8860: Fixed rounding in timedelta constructor.

* bpo-18849: Fixed a Windows-specific tempfile bug where collision
  with an existing directory caused mkstemp and related APIs to fail
  instead of retrying. Report and fix by Vlad Shcherbina.

* bpo-18920: argparse's default destination for the version action
  (-v, --version) has also been changed to stdout, to match the Python
  executable.


Tests
-----

* bpo-18623: Factor out the _SuppressCoreFiles context manager into
  test.support.  Patch by Valerie Lambert.

* bpo-12037: Fix test_email for desktop Windows.

* bpo-15507: test_subprocess's test_send_signal could fail if the
  test runner were run in an environment where the process inherited
  an ignore setting for SIGINT. Restore the SIGINT handler to the
  desired KeyboardInterrupt raising one during that test.

* bpo-16799: Switched from getopt to argparse style in regrtest's
  argument parsing. Added more tests for regrtest's argument parsing.

* bpo-18792: Use "127.0.0.1" or "::1" instead of "localhost" as much
  as possible, since "localhost" goes through a DNS lookup under
  recent Windows versions.


IDLE
----

* bpo-18489: Add tests for SearchEngine. Original patch by Phil
  Webster.


Documentation
-------------

* bpo-18743: Fix references to non-existant "StringIO" module.

* bpo-18783: Removed existing mentions of Python long type in
  docstrings, error messages and comments.


Build
-----

* bpo-1584: Provide configure options to override default search
  paths for Tcl and Tk when building _tkinter.

* bpo-15663: Tcl/Tk 8.5.14 is now included with the OS X 10.6+
  64-/32-bit installer.  It is no longer necessary to install a third-
  party version of Tcl/Tk 8.5 to work around the problems in the
  Apple-supplied Tcl/Tk 8.5 shipped in OS X 10.6 and later releases.


Tools/Demos
-----------

* bpo-18922: Now The Lib/smtpd.py and Tools/i18n/msgfmt.py scripts
  write their version strings to stdout, and not to sderr.


Python 3.4.0 alpha 1
====================

*Release date: 2013-08-03*


Core and Builtins
-----------------

* bpo-16741: Fix an error reporting in int().

* bpo-17899: Fix rare file descriptor leak in os.listdir().

* bpo-10241: Clear extension module dict copies at interpreter
  shutdown. Patch by Neil Schemenauer, minimally modified.

* bpo-9035: ismount now recognises volumes mounted below a drive
  root on Windows. Original patch by Atsuo Ishimoto.

* bpo-18214: Improve finalization of Python modules to avoid setting
  their globals to None, in most cases.

* bpo-18112: PEP 442 implementation (safe object finalization).

* bpo-18552: Check return value of PyArena_AddPyObject() in
  obj2ast_object().

* bpo-18560: Fix potential NULL pointer dereference in sum().

* bpo-18520: Add a new PyStructSequence_InitType2() function, same
  than PyStructSequence_InitType() except that it has a return value
  (0 on success, -1 on error).

* bpo-15905: Fix theoretical buffer overflow in handling of
  sys.argv[0], prefix and exec_prefix if the operation system does not
  obey MAXPATHLEN.

* bpo-18408: Fix many various bugs in code handling errors,
  especially on memory allocation failure (MemoryError).

* bpo-18344: Fix potential ref-leaks in _bufferedreader_read_all().

* bpo-18342: Use the repr of a module name when an import fails when
  using "from ... import ...".

* bpo-17872: Fix a segfault in marshal.load() when input stream
  returns more bytes than requested.

* bpo-18338: "python --version" now prints version string to stdout,
  and not to stderr. Patch by Berker Peksag and Michael Dickens.

* bpo-18426: Fix NULL pointer dereference in C extension import when
  PyModule_GetDef() returns an error.

* bpo-17206: On Windows, increase the stack size from 2 MB to 4.2 MB
  to fix a stack overflow in the marshal module (fix a crash in
  test_marshal). Patch written by Jeremy Kloth.

* bpo-3329: Implement the PEP 445: Add new APIs to customize Python
  memory allocators.

* bpo-18328: Reorder ops in PyThreadState_Delete*() functions. Now
  the tstate is first removed from TLS and then deallocated.

* bpo-13483: Use VirtualAlloc in obmalloc on Windows.

* bpo-18184: PyUnicode_FromFormat() and PyUnicode_FromFormatV() now
  raise OverflowError when an argument of %c format is out of range.

* bpo-18111: The min() and max() functions now support a default
  argument to be returned instead of raising a ValueError on an empty
  sequence. (Contributed by Julian Berman.)

* bpo-18137: Detect integer overflow on precision in
  float.__format__() and complex.__format__().

* bpo-18183: Fix various unicode operations on strings with large
  unicode codepoints.

* bpo-18180: Fix ref leak in _PyImport_GetDynLoadWindows().

* bpo-18038: SyntaxError raised during compilation sources with
  illegal encoding now always contains an encoding name.

* bpo-17931: Resolve confusion on Windows between pids and process
  handles.

* Tweak the exception message when the magic number or size value in
  a bytecode file is truncated.

* bpo-17932: Fix an integer overflow issue on Windows 64-bit in
  iterators: change the C type of seqiterobject.it_index from long to
  Py_ssize_t.

* bpo-18065: Don't set __path__ to the package name for frozen
  packages.

* bpo-18088: When reloading a module, unconditionally reset all
  relevant attributes on the module (e.g. __name__, __loader__,
  __package__, __file__, __cached__).

* bpo-17937: Try harder to collect cyclic garbage at shutdown.

* bpo-12370: Prevent class bodies from interfering with the
  __class__ closure.

* bpo-17644: Fix a crash in str.format when curly braces are used in
  square brackets.

* bpo-17237: Fix crash in the ASCII decoder on m68k.

* bpo-17927: Frame objects kept arguments alive if they had been
  copied into a cell, even if the cell was cleared.

* bpo-1545463: At shutdown, defer finalization of codec modules so
  that stderr remains usable.

* bpo-7330: Implement width and precision (ex: "%5.3s") for the
  format string of PyUnicode_FromFormat() function, original patch
  written by Ysj Ray.

* bpo-1545463: Global variables caught in reference cycles are now
  garbage-collected at shutdown.

* bpo-17094: Clear stale thread states after fork().  Note that this
  is a potentially disruptive change since it may release some system
  resources which would otherwise remain perpetually alive (e.g.
  database connections kept in thread-local storage).

* bpo-17408: Avoid using an obsolete instance of the copyreg module
  when the interpreter is shutdown and then started again.

* bpo-5845: Enable tab-completion in the interactive interpreter by
  default, thanks to a new sys.__interactivehook__.

* bpo-17115: Module initialization now includes setting __package__
  and __loader__ attributes to None. (See also: bpo-17116)

* bpo-17853: Ensure locals of a class that shadow free variables
  always win over the closures.

* bpo-17863: In the interactive console, don't loop forever if the
  encoding can't be fetched from stdin.

* bpo-17867: Raise an ImportError if __import__ is not found in
  __builtins__.

* bpo-18698: Ensure importlib.reload() returns the module out of
  sys.modules.

* bpo-17857: Prevent build failures with pre-3.5.0 versions of
  sqlite3, such as was shipped with Centos 5 and Mac OS X 10.4.

* bpo-17413: sys.settrace callbacks were being passed a string
  instead of an exception instance for the 'value' element of the arg
  tuple if the exception originated from C code; now an exception
  instance is always provided.

* bpo-17782: Fix undefined behaviour on platforms where "struct
  timespec"'s "tv_nsec" member is not a C long.

* bpo-17722: When looking up __round__, resolve descriptors.

* bpo-16061: Speed up str.replace() for replacing 1-character
  strings.

* bpo-17715: Fix segmentation fault from raising an exception in a
  __trunc__ method.

* bpo-17643: Add __callback__ attribute to weakref.ref.

* bpo-16447: Fixed potential segmentation fault when setting
  __name__ on a class.

* bpo-17669: Fix crash involving finalization of generators using
  yield from.

* bpo-14439: Python now prints the traceback on runpy failure at
  startup.

* bpo-17469: Fix _Py_GetAllocatedBlocks() and
  sys.getallocatedblocks() when running on valgrind.

* bpo-17619: Make input() check for Ctrl-C correctly on Windows.

* bpo-17357: Add missing verbosity messages for -v/-vv that were
  lost during the importlib transition.

* bpo-17610: Don't rely on non-standard behavior of the C qsort()
  function.

* bpo-17323: The "[X refs, Y blocks]" printed by debug builds has
  been disabled by default.  It can be re-enabled with the "-X
  showrefcount" option.

* bpo-17328: Fix possible refleak in dict.setdefault.

* bpo-17275: Corrected class name in init error messages of the C
  version of BufferedWriter and BufferedRandom.

* bpo-7963: Fixed misleading error message that issued when object
  is called without arguments.

* bpo-8745: Small speed up zipimport on Windows. Patch by Catalin
  Iacob.

* bpo-5308: Raise ValueError when marshalling too large object (a
  sequence with size >= 2**31), instead of producing illegal marshal
  data.

* bpo-12983: Bytes literals with invalid "\x" escape now raise a
  SyntaxError and a full traceback including line number.

* bpo-16967: In function definition, evaluate positional defaults
  before keyword-only defaults.

* bpo-17173: Remove uses of locale-dependent C functions (isalpha()
  etc.) in the interpreter.

* bpo-17137: When an Unicode string is resized, the internal wide
  character string (wstr) format is now cleared.

* bpo-17043: The unicode-internal decoder no longer read past the
  end of input buffer.

* bpo-17098: All modules now have __loader__ set even if they pre-
  exist the bootstrapping of importlib.

* bpo-16979: Fix error handling bugs in the unicode-escape-decode
  decoder.

* bpo-16772: The base argument to the int constructor no longer
  accepts floats, or other non-integer objects with an __int__ method.
  Objects with an __index__ method are now accepted.

* bpo-10156: In the interpreter's initialization phase, unicode
  globals are now initialized dynamically as needed.

* bpo-16980: Fix processing of escaped non-ascii bytes in the
  unicode- escape-decode decoder.

* bpo-16975: Fix error handling bug in the escape-decode bytes
  decoder.

* bpo-14850: Now a charmap decoder treats U+FFFE as "undefined
  mapping" in any mapping, not only in a string.

* bpo-16613: Add *m* argument to "collections.Chainmap.new_child" to
  allow the new child map to be specified explicitly.

* bpo-16730: importlib.machinery.FileFinder now no longers raises an
  exception when trying to populate its cache and it finds out the
  directory is unreadable or has turned into a file. Reported and
  diagnosed by David Pritchard.

* bpo-16906: Fix a logic error that prevented most static strings
  from being cleared.

* bpo-11461: Fix the incremental UTF-16 decoder. Original patch by
  Amaury Forgeot d'Arc.

* bpo-16856: Fix a segmentation fault from calling repr() on a dict
  with a key whose repr raise an exception.

* bpo-16367: Fix FileIO.readall() on Windows for files larger than 2
  GB.

* bpo-16761: Calling int() with base argument only now raises
  TypeError.

* bpo-16759: Support the full DWORD (unsigned long) range in Reg2Py
  when retrieving a REG_DWORD value. This corrects functions like
  winreg.QueryValueEx that may have been returning truncated values.

* bpo-14420: Support the full DWORD (unsigned long) range in Py2Reg
  when passed a REG_DWORD value. Fixes OverflowError in
  winreg.SetValueEx.

* bpo-11939: Set the st_dev attribute of stat_result to allow
  Windows to take advantage of the
  os.path.samefile/sameopenfile/samestat implementations used by other
  platforms.

* bpo-16772: The int() constructor's second argument (base) no
  longer accepts non integer values.  Consistent with the behavior in
  Python 2.

* bpo-14470: Remove w9xpopen support per PEP 11.

* bpo-9856: Replace deprecation warning with raising TypeError in
  object.__format__. Patch by Florent Xicluna.

* bpo-16597: In buffered and text IO, call close() on the underlying
  stream if invoking flush() fails.

* bpo-16722: In the bytes() constructor, try to call __bytes__ on
  the argument before __index__.

* bpo-16421: loading multiple modules from one shared object is now
  handled correctly (previously, the first module loaded from that
  file was silently returned). Patch by Václav Šmilauer.

* bpo-16602: When a weakref's target was part of a long deallocation
  chain, the object could remain reachable through its weakref even
  though its refcount had dropped to zero.

* bpo-16495: Remove extraneous NULL encoding check from
  bytes_decode().

* bpo-16619: Create NameConstant AST class to represent None, True,
  and False literals. As a result, these constants are never loaded at
  runtime from builtins.

* bpo-16455: On FreeBSD and Solaris, if the locale is C, the
  ASCII/surrogateescape codec is now used (instead of the locale
  encoding) to decode the command line arguments. This change fixes
  inconsistencies with os.fsencode() and os.fsdecode(), because these
  operating systems announce an ASCII locale encoding, but actually
  use the ISO-8859-1 encoding in practice.

* bpo-16562: Optimize dict equality testing.  Patch by Serhiy
  Storchaka.

* bpo-16588: Silence unused-but-set warnings in
  Python/thread_pthread

* bpo-16592: stringlib_bytes_join doesn't raise MemoryError on
  allocation failure.

* bpo-16546: Fix: ast.YieldFrom argument is now mandatory.

* bpo-16514: Fix regression causing a traceback when sys.path[0] is
  None (actually, any non-string or non-bytes type).

* bpo-16306: Fix multiple error messages when unknown command line
  parameters where passed to the interpreter.  Patch by Hieu Nguyen.

* bpo-16215: Fix potential double memory free in str.replace().
  Patch by Serhiy Storchaka.

* bpo-16290: A float return value from the __complex__ special
  method is no longer accepted in the complex() constructor.

* bpo-16416: On Mac OS X, operating system data are now always
  encoded/decoded to/from UTF-8/surrogateescape, instead of the locale
  encoding (which may be ASCII if no locale environment variable is
  set), to avoid inconsistencies with os.fsencode() and os.fsdecode()
  functions which are already using UTF-8/surrogateescape.

* bpo-16453: Fix equality testing of dead weakref objects.

* bpo-9535: Fix pending signals that have been received but not yet
  handled by Python to not persist after os.fork() in the child
  process.

* bpo-14794: Fix slice.indices to return correct results for huge
  values, rather than raising OverflowError.

* bpo-15001: fix segfault on "del sys.modules['__main__']". Patch by
  Victor Stinner.

* bpo-8271: the utf-8 decoder now outputs the correct number of
  U+FFFD characters when used with the 'replace' error handler on
  invalid utf-8 sequences.  Patch by Serhiy Storchaka, tests by Ezio
  Melotti.

* bpo-5765: Apply a hard recursion limit in the compiler instead of
  blowing the stack and segfaulting. Initial patch by Andrea Griffini.

* bpo-16402: When slicing a range, fix shadowing of exceptions from
  __index__.

* bpo-16336: fix input checking in the surrogatepass error handler.
  Patch by Serhiy Storchaka.

* bpo-8401: assigning an int to a bytearray slice (e.g. b[3:4] = 5)
  now raises an error.

* bpo-7317: Display full tracebacks when an error occurs
  asynchronously. Patch by Alon Horev with update by Alexey Kachayev.

* bpo-16309: Make PYTHONPATH="" behavior the same as if PYTHONPATH
  not set at all.

* bpo-10189: Improve the error reporting of SyntaxErrors related to
  global and nonlocal statements.

* Fix segfaults on setting __qualname__ on builtin types and
  attempting to delete it on any type.

* bpo-14625: Rewrite the UTF-32 decoder. It is now 3x to 4x faster.
  Patch written by Serhiy Storchaka.

* bpo-16345: Fix an infinite loop when "fromkeys" on a dict subclass
  received a nonempty dict from the constructor.

* bpo-16271: Fix strange bugs that resulted from __qualname__
  appearing in a class's __dict__ and on type.

* bpo-12805: Make bytes.join and bytearray.join faster when the
  separator is empty. Patch by Serhiy Storchaka.

* bpo-6074: Ensure cached bytecode files can always be updated by
  the user that created them, even when the source file is read-only.

* bpo-15958: bytes.join and bytearray.join now accept arbitrary
  buffer objects.

* bpo-14783: Improve int() docstring and switch docstrings for
  str(), range(), and slice() to use multi-line signatures.

* bpo-16160: Subclass support now works for types.SimpleNamespace.

* bpo-16148: Implement PEP 424, adding operator.length_hint and
  PyObject_LengthHint.

* Upgrade Unicode data (UCD) to version 6.2.

* bpo-15379: Fix passing of non-BMP characters as integers for the
  charmap decoder (already working as unicode strings).  Patch by
  Serhiy Storchaka.

* bpo-15144: Fix possible integer overflow when handling pointers as
  integer values, by using "Py_uintptr_t" instead of "size_t".  Patch
  by Serhiy Storchaka.

* bpo-15965: Explicitly cast "AT_FDCWD" as (int).  Required on
  Solaris 10 (which defines "AT_FDCWD" as "0xffd19553"), harmless on
  other platforms.

* bpo-15839: Convert SystemErrors in "super()" to RuntimeErrors.

* bpo-15448: Buffered IO now frees the buffer when closed, instead
  of when deallocating.

* bpo-15846: Fix SystemError which happened when using "ast.parse()"
  in an exception handler on code with syntax errors.

* bpo-15897: zipimport.c doesn't check return value of fseek().
  Patch by Felipe Cruz.

* bpo-15801: Make sure mappings passed to '%' formatting are
  actually subscriptable.

* bpo-15111: __import__ should propagate ImportError when raised as
  a side-effect of a module triggered from using fromlist.

* bpo-15022: Add pickle and comparison support to
  types.SimpleNamespace.


Library
-------

* bpo-4331: Added functools.partialmethod (Initial patch by Alon
  Horev)

* bpo-13461: Fix a crash in the TextIOWrapper.tell method on 64-bit
  platforms.  Patch by Yogesh Chaudhari.

* bpo-18681: Fix a NameError in importlib.reload() (noticed by
  Weizhao Li).

* bpo-14323: Expanded the number of digits in the coefficients for
  the RGB -- YIQ conversions so that they match the FCC NTSC versions.

* bpo-17998: Fix an internal error in regular expression engine.

* bpo-17557: Fix os.getgroups() to work with the modified behavior
  of getgroups(2) on OS X 10.8.  Original patch by Mateusz Lenik.

* bpo-18608: Avoid keeping a strong reference to the locale module
  inside the _io module.

* bpo-18619: Fix atexit leaking callbacks registered from sub-
  interpreters, and make it GC-aware.

* bpo-15699: The readline module now uses PEP 3121-style module
  initialization, so as to reclaim allocated resources (Python
  callbacks) at shutdown.  Original patch by Robin Schreiber.

* bpo-17616: wave.open now supports the context management protocol.

* bpo-18599: Fix name attribute of _sha1.sha1() object. It now
  returns 'SHA1' instead of 'SHA'.

* bpo-13266: Added inspect.unwrap to easily unravel __wrapped__
  chains (initial patch by Daniel Urban and Aaron Iles)

* bpo-18561: Skip name in ctypes' _build_callargs() if name is NULL.

* bpo-18559: Fix NULL pointer dereference error in _pickle module

* bpo-18556: Check the return type of PyUnicode_AsWideChar() in
  ctype's U_set().

* bpo-17818: aifc.getparams now returns a namedtuple.

* bpo-18549: Eliminate dead code in socket_ntohl()

* bpo-18530: Remove additional stat call from posixpath.ismount.
  Patch by Alex Gaynor.

* bpo-18514: Fix unreachable Py_DECREF() call in
  PyCData_FromBaseObj()

* bpo-9177: Calling read() or write() now raises ValueError, not
  AttributeError, on a closed SSL socket.  Patch by Senko Rasic.

* bpo-18513: Fix behaviour of cmath.rect w.r.t. signed zeros on OS X
  10.8 + gcc.

* bpo-18479: Changed venv Activate.ps1 to make deactivate a
  function, and removed Deactivate.ps1.

* bpo-18480: Add missing call to PyType_Ready to the _elementtree
  extension.

* bpo-17778: Fix test discovery for test_multiprocessing. (Patch by
  Zachary Ware.)

* bpo-18393: The private module _gestalt and private functions
  platform._mac_ver_gestalt, platform._mac_ver_lookup and
  platform._bcd2str have been removed. This does not affect the public
  interface of the platform module.

* bpo-17482: functools.update_wrapper (and functools.wraps) now set
  the __wrapped__ attribute correctly even if the underlying function
  has a __wrapped__ attribute set.

* bpo-18431: The new email header parser now decodes RFC2047 encoded
  words in structured headers.

* bpo-18432: The sched module's queue method was incorrectly
  returning an iterator instead of a list.

* bpo-18044: The new email header parser was mis-parsing encoded
  words where an encoded character immediately followed the '?' that
  follows the CTE character, resulting in a decoding failure.  They
  are now decoded correctly.

* bpo-18101: Tcl.split() now process strings nested in a tuple as it
  do with byte strings.

* bpo-18116: getpass was always getting an error when testing
  /dev/tty, and thus was always falling back to stdin, and would then
  raise an exception if stdin could not be used (such as /dev/null).
  It also leaked an open file. All of these issues are now fixed.

* bpo-17198: Fix a NameError in the dbm module.  Patch by Valentina
  Mukhamedzhanova.

* bpo-18013: Fix cgi.FieldStorage to parse the W3C sample form.

* bpo-18020: improve html.escape speed by an order of magnitude.
  Patch by Matt Bryant.

* bpo-18347: ElementTree's html serializer now preserves the case of
  closing tags.

* bpo-17261: Ensure multiprocessing's proxies use proper address.

* bpo-18343: faulthandler.register() now keeps the previous signal
  handler when the function is called twice, so
  faulthandler.unregister() restores correctly the original signal
  handler.

* bpo-17097: Make multiprocessing ignore EINTR.

* bpo-18339: Negative ints keys in unpickler.memo dict no longer
  cause a segfault inside the _pickle C extension.

* bpo-18240: The HMAC module is no longer restricted to bytes and
  accepts any bytes-like object, e.g. memoryview. Original patch by
  Jonas Borgström.

* bpo-18224: Removed pydoc script from created venv, as it causes
  problems on Windows and adds no value over and above python -m pydoc
  ...

* bpo-18155: The csv module now correctly handles csv files that use
  a delimter character that has a special meaning in regexes, instead
  of throwing an exception.

* bpo-14360: encode_quopri can now be successfully used as an
  encoder when constructing a MIMEApplication object.

* bpo-11390: Add -o and -f command line options to the doctest CLI
  to specify doctest options (and convert it to using argparse).

* bpo-18135: ssl.SSLSocket.write() now raises an OverflowError if
  the input string in longer than 2 gigabytes, and
  ssl.SSLContext.load_cert_chain() raises a ValueError if the password
  is longer than 2 gigabytes. The ssl module does not support partial
  write.

* bpo-11016: Add C implementation of the stat module as _stat.

* bpo-18248: Fix libffi build on AIX.

* bpo-18259: Declare sethostname in socketmodule.c for AIX

* bpo-18147: Add diagnostic functions to ssl.SSLContext().
  get_ca_list() lists all loaded CA certificates and
  cert_store_stats() returns amount of loaded X.509 certs, X.509 CA
  certs and CRLs.

* bpo-18167: cgi.FieldStorage no longer fails to handle multipart
  /form-data when "\r\n" appears at end of 65535 bytes without other
  newlines.

* bpo-18076: Introduce importlib.util.decode_source().

* bpo-18357: add tests for dictview set difference. Patch by Fraser
  Tweedale.

* importlib.abc.SourceLoader.get_source() no longer changes
  SyntaxError or UnicodeDecodeError into ImportError.

* bpo-18058: Make the namespace package loader meet the
  importlib.abc.InspectLoader ABC, allowing for namespace packages to
  work with runpy. (See also: bpo-18057)

* bpo-17177: The imp module is pending deprecation.

* subprocess: Prevent a possible double close of parent pipe fds
  when the subprocess exec runs into an error.  Prevent a regular
  multi- close of the /dev/null fd when any of stdin, stdout and
  stderr was set to DEVNULL.

* bpo-18194: Introduce importlib.util.cache_from_source() and
  source_from_cache() while documenting the equivalent functions in
  imp as deprecated.

* bpo-17907: Document imp.new_module() as deprecated in favour of
  types.ModuleType.

* bpo-18192: Introduce importlib.util.MAGIC_NUMBER and document as
  deprecated imp.get_magic().

* bpo-18149: Add filecmp.clear_cache() to manually clear the filecmp
  cache. Patch by Mark Levitt

* bpo-18193: Add importlib.reload().

* bpo-18157: Stop using imp.load_module() in pydoc.

* bpo-16102: Make uuid._netbios_getnode() work again on Python 3.

* bpo-17134: Add ssl.enum_cert_store() as interface to Windows' cert
  store.

* bpo-18143: Implement ssl.get_default_verify_paths() in order to
  debug the default locations for cafile and capath.

* bpo-17314: Move multiprocessing.forking over to importlib.

* bpo-11959: SMTPServer and SMTPChannel now take an optional map,
  use of which avoids affecting global state.

* bpo-18109: os.uname() now decodes fields from the locale encoding,
  and socket.gethostname() now decodes the hostname from the locale
  encoding, instead of using the UTF-8 encoding in strict mode.

* bpo-18089: Implement importlib.abc.InspectLoader.load_module.

* bpo-18088: Introduce importlib.abc.Loader.init_module_attrs for
  setting module attributes. Leads to the pending deprecation of
  importlib.util.module_for_loader.

* bpo-17403: urllib.parse.robotparser normalizes the urls before
  adding to ruleline. This helps in handling certain types invalid
  urls in a conservative manner. Patch contributed by Mher Movsisyan.

* bpo-18070: Have importlib.util.module_for_loader() set attributes
  unconditionally in order to properly support reloading.

* Added importlib.util.module_to_load to return a context manager to
  provide the proper module object to load.

* bpo-18025: Fixed a segfault in io.BufferedIOBase.readinto() when
  raw stream's read() returns more bytes than requested.

* bpo-18011: As was originally intended, base64.b32decode() now
  raises a binascii.Error if there are non-b32-alphabet characters
  present in the input string, instead of a TypeError.

* bpo-18072: Implement importlib.abc.InspectLoader.get_code() and
  importlib.abc.ExecutionLoader.get_code().

* bpo-8240: Set the SSL_MODE_ACCEPT_MOVING_WRITE_BUFFER flag on SSL
  sockets.

* bpo-17269: Workaround for socket.getaddrinfo crash on MacOS X with
  port None or "0" and flags AI_NUMERICSERV.

* bpo-16986: ElementTree now correctly works with string input when
  the internal XML encoding is not UTF-8 or US-ASCII.

* bpo-17996: socket module now exposes AF_LINK constant on BSD and
  OSX.

* bpo-17900: Allowed pickling of recursive OrderedDicts.  Decreased
  pickled size and pickling time.

* bpo-17914: Add os.cpu_count(). Patch by Yogesh Chaudhari, based on
  an initial patch by Trent Nelson.

* bpo-17812: Fixed quadratic complexity of base64.b32encode().
  Optimize base64.b32encode() and base64.b32decode() (speed up to 3x).

* bpo-17980: Fix possible abuse of ssl.match_hostname() for denial
  of service using certificates with many wildcards (CVE-2013-2099).

* bpo-15758: Fix FileIO.readall() so it no longer has O(n**2)
  complexity.

* bpo-14596: The struct.Struct() objects now use a more compact
  implementation.

* bpo-17981: logging's SysLogHandler now closes the socket when it
  catches socket OSErrors.

* bpo-17964: Fix os.sysconf(): the return type of the C sysconf()
  function is long, not int.

* Fix typos in the multiprocessing module.

* bpo-17754: Make ctypes.util.find_library() independent of the
  locale.

* bpo-17968: Fix memory leak in os.listxattr().

* bpo-17606: Fixed support of encoded byte strings in the
  XMLGenerator characters() and ignorableWhitespace() methods.
  Original patch by Sebastian Ortiz Vasquez.

* bpo-17732: Ignore distutils.cfg options pertaining to install
  paths if a virtual environment is active.

* bpo-17915: Fix interoperability of xml.sax with file objects
  returned by codecs.open().

* bpo-16601: Restarting iteration over tarfile really restarts
  rather than continuing from where it left off.  Patch by Michael
  Birtwell.

* bpo-17289: The readline module now plays nicer with external
  modules or applications changing the
  rl_completer_word_break_characters global variable.  Initial patch
  by Bradley Froehle.

* bpo-12181: select module: Fix struct kevent definition on OpenBSD
  64-bit platforms. Patch by Federico Schwindt.

* bpo-11816: multiple improvements to the dis module:
  get_instructions generator, ability to redirect output to a file,
  Bytecode and Instruction abstractions. Patch by Nick Coghlan, Ryan
  Kelly and Thomas Kluyver.

* bpo-13831: Embed stringification of remote traceback in local
  traceback raised when pool task raises an exception.

* bpo-15528: Add weakref.finalize to support finalization using
  weakref callbacks.

* bpo-14173: Avoid crashing when reading a signal handler during
  interpreter shutdown.

* bpo-15902: Fix imp.load_module() accepting None as a file when
  loading an extension module.

* bpo-13721: SSLSocket.getpeercert() and SSLSocket.do_handshake()
  now raise an OSError with ENOTCONN, instead of an AttributeError,
  when the SSLSocket is not connected.

* bpo-14679: add an __all__ (that contains only HTMLParser) to
  html.parser.

* bpo-17802: Fix an UnboundLocalError in html.parser.  Initial tests
  by Thomas Barlow.

* bpo-17358: Modules loaded by imp.load_source() and load_compiled()
  (and by extention load_module()) now have a better chance of working
  when reloaded.

* bpo-17804: New function "struct.iter_unpack" allows for streaming
  struct unpacking.

* bpo-17830: When keyword.py is used to update a keyword file, it
  now preserves the line endings of the original file.

* bpo-17272: Making the urllib.request's Request.full_url a
  descriptor. Fixes bugs with assignment to full_url. Patch by Demian
  Brecht.

* bpo-17353: Plistlib emitted empty data tags with deeply nested
  datastructures

* bpo-11714: Use 'with' statements to assure a Semaphore releases a
  condition variable. Original patch by Thomas Rachel.

* bpo-16624: "subprocess.check_output" now accepts an "input"
  argument, allowing the subprocess's stdin to be provided as a (byte)
  string. Patch by Zack Weinberg.

* bpo-17795: Reverted backwards-incompatible change in SysLogHandler
  with Unix domain sockets.

* bpo-16694: Add a pure Python implementation of the operator
  module. Patch by Zachary Ware.

* bpo-11182: remove the unused and undocumented pydoc.Scanner class.
  Patch by Martin Morrison.

* bpo-17741: Add ElementTree.XMLPullParser, an event-driven parser
  for non-blocking applications.

* bpo-17555: Fix ForkAwareThreadLock so that size of after fork
  registry does not grow exponentially with generation of process.

* bpo-17707: fix regression in multiprocessing.Queue's get() method
  where it did not block for short timeouts.

* bpo-17720: Fix the Python implementation of pickle.Unpickler to
  correctly process the APPENDS opcode when it is used on non-list
  objects.

* bpo-17012: shutil.which() no longer falls back to the PATH
  environment variable if an empty path argument is specified.  Patch
  by Serhiy Storchaka.

* bpo-17710: Fix pickle raising a SystemError on bogus input.

* bpo-17341: Include the invalid name in the error messages from re
  about invalid group names.

* bpo-17702: os.environ now raises KeyError with the original
  environment variable name (str on UNIX), instead of using the
  encoded name (bytes on UNIX).

* bpo-16163: Make the importlib based version of
  pkgutil.iter_importers work for submodules. Initial patch by Berker
  Peksag.

* bpo-16804: Fix a bug in the 'site' module that caused running
  'python -S -m site' to incorrectly throw an exception.

* bpo-15480: Remove the deprecated and unused TYPE_INT64 code from
  marshal. Initial patch by Daniel Riti.

* bpo-2118: SMTPException is now a subclass of OSError.

* bpo-17016: Get rid of possible pointer wraparounds and integer
  overflows in the re module.  Patch by Nickolai Zeldovich.

* bpo-16658: add missing return to HTTPConnection.send(). Patch by
  Jeff Knupp.

* bpo-9556: the logging package now allows specifying a time-of-day
  for a TimedRotatingFileHandler to rotate.

* bpo-14971: unittest test discovery no longer gets confused when a
  function has a different __name__ than its name in the TestCase
  class dictionary.

* bpo-17487: The wave getparams method now returns a namedtuple
  rather than a plain tuple.

* bpo-17675: socket repr() provides local and remote addresses (if
  any). Patch by Giampaolo Rodola'

* bpo-17093: Make the ABCs in importlib.abc provide default values
  or raise reasonable exceptions for their methods to make them more
  amenable to super() calls.

* bpo-17566: Make importlib.abc.Loader.module_repr() optional
  instead of an abstractmethod; now it raises NotImplementedError so
  as to be ignored by default.

* bpo-17678: Remove the use of deprecated method in
  http/cookiejar.py by changing the call to get_origin_req_host() to
  origin_req_host.

* bpo-17666: Fix reading gzip files with an extra field.

* bpo-16475: Support object instancing, recursion and interned
  strings in marshal

* bpo-17502: Process DEFAULT values in mock side_effect that returns
  iterator.

* bpo-16795: On the ast.arguments object, unify vararg with
  varargannotation and kwarg and kwargannotation. Change the column
  offset of ast.Attribute to be at the attribute name.

* bpo-17434: Properly raise a SyntaxError when a string occurs
  between future imports.

* bpo-17117: Import and @importlib.util.set_loader now set
  __loader__ when it has a value of None or the attribute doesn't
  exist.

* bpo-17032: The "global" in the "NameError: global name 'x' is not
  defined" error message has been removed.  Patch by Ram Rachum.

* bpo-18080: When building a C extension module on OS X, if the
  compiler is overriden with the CC environment variable, use the new
  compiler as the default for linking if LDSHARED is not also
  overriden.  This restores Distutils behavior introduced in 3.2.3 and
  inadvertently dropped in 3.3.0.

* bpo-18113: Fixed a refcount leak in the curses.panel module's
  set_userptr() method. Reported by Atsuo Ishimoto.

* Implement PEP 443 "Single-dispatch generic functions".

* Implement PEP 435 "Adding an Enum type to the Python standard
  library".

* bpo-15596: Faster pickling of unicode strings.

* bpo-17572: Avoid chained exceptions when passing bad directives to
  time.strptime(). Initial patch by Claudiu Popa.

* bpo-17435: threading.Timer's __init__ method no longer uses
  mutable default values for the args and kwargs parameters.

* bpo-17526: fix an IndexError raised while passing code without
  filename to inspect.findsource().  Initial patch by Tyler Doyle.

* bpo-17540: Added style parameter to logging formatter
  configuration by dict.

* bpo-16692: The ssl module now supports TLS 1.1 and TLS 1.2.
  Initial patch by Michele Orrù.

* bpo-17025: multiprocessing: Reduce Queue and SimpleQueue
  contention.

* bpo-17536: Add to webbrowser's browser list: www-browser, x-www-
  browser, iceweasel, iceape.

* bpo-17150: pprint now uses line continuations to wrap long string
  literals.

* bpo-17488: Change the subprocess.Popen bufsize parameter default
  value from unbuffered (0) to buffering (-1) to match the behavior
  existing code expects and match the behavior of the subprocess
  module in Python 2 to avoid introducing hard to track down bugs.

* bpo-17521: Corrected non-enabling of logger following two calls to
  fileConfig().

* bpo-17508: Corrected logging MemoryHandler configuration in
  dictConfig() where the target handler wasn't configured first.

* bpo-17209: curses.window.get_wch() now correctly handles
  KeyboardInterrupt (CTRL+c).

* bpo-5713: smtplib now handles 421 (closing connection) error codes
  when sending mail by closing the socket and reporting the 421 error
  code via the exception appropriate to the command that received the
  error response.

* bpo-16997: unittest.TestCase now provides a subTest() context
  manager to procedurally generate, in an easy way, small test
  instances.

* bpo-17485: Also delete the Request Content-Length header if the
  data attribute is deleted.  (Follow on to issue Issue #16464).

* bpo-15927: CVS now correctly parses escaped newlines and carriage
  when parsing with quoting turned off.

* bpo-17467: add readline and readlines support to mock_open in
  unittest.mock.

* bpo-13248: removed deprecated and undocumented difflib.isbjunk,
  isbpopular.

* bpo-17192: Update the ctypes module's libffi to v3.0.13.  This
  specifically addresses a stack misalignment issue on x86 and issues
  on some more recent platforms.

* bpo-8862: Fixed curses cleanup when getkey is interrputed by a
  signal.

* bpo-17443: imaplib.IMAP4_stream was using the default unbuffered
  IO in subprocess, but the imap code assumes buffered IO.  In Python2
  this worked by accident. IMAP4_stream now explicitly uses buffered
  IO.

* bpo-17476: Fixed regression relative to Python2 in undocumented
  pydoc 'allmethods'; it was missing unbound methods on the class.

* bpo-17474: Remove the deprecated methods of Request class.

* bpo-16709: unittest discover order is no-longer filesystem
  specific. Patch by Jeff Ramnani.

* Use the HTTPS PyPI url for upload, overriding any plain HTTP URL
  in pypirc.

* bpo-5024: sndhdr.whichhdr now returns the frame count for WAV
  files rather than -1.

* bpo-17460: Remove the strict argument of HTTPConnection and
  removing the DeprecationWarning being issued from 3.2 onwards.

* bpo-16880: Do not assume _imp.load_dynamic() is defined in the imp
  module.

* bpo-16389: Fixed a performance regression relative to Python 3.1
  in the caching of compiled regular expressions.

* Added missing FeedParser and BytesFeedParser to
  email.parser.__all__.

* bpo-17431: Fix missing import of BytesFeedParser in email.parser.

* bpo-12921: http.server's send_error takes an explain argument to
  send more information in response. Patch contributed by Karl.

* bpo-17414: Add timeit, repeat, and default_timer to
  timeit.__all__.

* bpo-1285086: Get rid of the refcounting hack and speed up
  urllib.parse.unquote() and urllib.parse.unquote_to_bytes().

* bpo-17099: Have importlib.find_loader() raise ValueError when
  __loader__ is not set, harmonizing with what happens when the
  attribute is set to None.

* Expose the O_PATH constant in the os module if it is available.

* bpo-17368: Fix an off-by-one error in the Python JSON decoder that
  caused a failure while decoding empty object literals when
  object_pairs_hook was specified.

* bpo-17385: Fix quadratic behavior in threading.Condition.  The
  FIFO queue now uses a deque instead of a list.

* bpo-15806: Add contextlib.ignore().  This creates a context
  manager to ignore specified exceptions, replacing the "except
  SomeException: pass" idiom.

* bpo-14645: The email generator classes now produce output using
  the specified linesep throughout.  Previously if the prolog, epilog,
  or body were stored with a different linesep, that linesep was used.
  This fix corrects an RFC non- compliance issue with
  smtplib.send_message.

* bpo-17278: Fix a crash in heapq.heappush() and heapq.heappop()
  when the list is being resized concurrently.

* bpo-16962: Use getdents64 instead of the obsolete getdents syscall
  in the subprocess module on Linux.

* bpo-16935: unittest now counts the module as skipped if it raises
  SkipTest, instead of counting it as an error.  Patch by Zachary
  Ware.

* bpo-17018: Make Process.join() retry if os.waitpid() fails with
  EINTR.

* bpo-17223: array module: Fix a crasher when converting an array
  containing invalid characters (outside range [U+0000; U+10ffff]) to
  Unicode: repr(array), str(array) and array.tounicode(). Patch
  written by Manuel Jacob.

* bpo-17197: profile/cProfile modules refactored so that code of
  run() and runctx() utility functions is not duplicated in both
  modules.

* bpo-14720: sqlite3: Convert datetime microseconds correctly. Patch
  by Lowe Thiderman.

* bpo-15132: Allow a list for the defaultTest argument of
  unittest.TestProgram. Patch by Jyrki Pulliainen.

* bpo-17225: JSON decoder now counts columns in the first line
  starting with 1, as in other lines.

* bpo-6623: Added explicit DeprecationWarning for ftplib.netrc,
  which has been deprecated and undocumented for a long time.

* bpo-13700: Fix byte/string handling in imaplib authentication when
  an authobject is specified.

* bpo-13153: Tkinter functions now raise TclError instead of
  ValueError when a string argument contains non-BMP character.

* bpo-9669: Protect re against infinite loops on zero-width matching
  in non-greedy repeat.  Patch by Matthew Barnett.

* bpo-13169: The maximal repetition number in a regular expression
  has been increased from 65534 to 2147483647 (on 32-bit platform) or
  4294967294 (on 64-bit).

* bpo-17143: Fix a missing import in the trace module.  Initial
  patch by Berker Peksag.

* bpo-15220: email.feedparser's line splitting algorithm is now
  simpler and faster.

* bpo-16743: Fix mmap overflow check on 32 bit Windows.

* bpo-16996: webbrowser module now uses shutil.which() to find a
  web- browser on the executable search path.

* bpo-16800: tempfile.gettempdir() no longer left temporary files
  when the disk is full. Original patch by Amir Szekely.

* bpo-17192: Import libffi-3.0.12.

* bpo-16564: Fixed regression relative to Python2 in the operation
  of email.encoders.encode_7or8bit when used with binary data.

* bpo-17052: unittest discovery should use self.testLoader.

* bpo-4591: Uid and gid values larger than 2**31 are supported now.

* bpo-17141: random.vonmisesvariate() no longer hangs for large
  kappas.

* bpo-17149: Fix random.vonmisesvariate to always return results in
  [0, 2*math.pi].

* bpo-1470548: XMLGenerator now works with binary output streams.

* bpo-6975: os.path.realpath() now correctly resolves multiple
  nested symlinks on POSIX platforms.

* bpo-13773: sqlite3.connect() gets a new "uri" parameter to pass
  the filename as a URI, allowing to pass custom options.

* bpo-16564: Fixed regression relative to Python2 in the operation
  of email.encoders.encode_noop when used with binary data.

* bpo-10355: The mode, name, encoding and newlines properties now
  work on SpooledTemporaryFile objects even when they have not yet
  rolled over. Obsolete method xreadline (which has never worked in
  Python 3) has been removed.

* bpo-16686: Fixed a lot of bugs in audioop module.  Fixed crashes
  in avgpp(), maxpp() and ratecv().  Fixed an integer overflow in
  add(), bias(), and ratecv(). reverse(), lin2lin() and ratecv() no
  more lose precision for 32-bit samples. max() and rms() no more
  returns a negative result and various other functions now work
  correctly with 32-bit sample -0x80000000.

* bpo-17073: Fix some integer overflows in sqlite3 module.

* bpo-16723: httplib.HTTPResponse no longer marked closed when the
  connection is automatically closed.

* bpo-15359: Add CAN_BCM protocol support to the socket module.
  Patch by Brian Thorne.

* bpo-16948: Fix quoted printable body encoding for non-latin1
  character sets in the email package.

* bpo-16811: Fix folding of headers with no value in the provisional
  email policies.

* bpo-17132: Update symbol for "yield from" grammar changes.

* bpo-17076: Make copying of xattrs more tolerant of missing FS
  support. Patch by Thomas Wouters.

* bpo-17089: Expat parser now correctly works with string input when
  the internal XML encoding is not UTF-8 or US-ASCII.  It also now
  accepts bytes and strings larger than 2 GiB.

* bpo-6083: Fix multiple segmentation faults occured when
  PyArg_ParseTuple parses nested mutating sequence.

* bpo-5289: Fix ctypes.util.find_library on Solaris.

* bpo-17106: Fix a segmentation fault in io.TextIOWrapper when an
  underlying stream or a decoder produces data of an unexpected type
  (i.e. when io.TextIOWrapper initialized with text stream or use
  bytes-to-bytes codec).

* bpo-17015: When it has a spec, a Mock object now inspects its
  signature when matching calls, so that arguments can be matched
  positionally or by name.

* bpo-15633: httplib.HTTPResponse is now mark closed when the server
  sends less than the advertised Content-Length.

* bpo-12268: The io module file object write methods no longer abort
  early when one of its write system calls is interrupted (EINTR).

* bpo-6972: The zipfile module no longer overwrites files outside of
  its destination path when extracting malicious zip files.

* bpo-4844: ZipFile now raises BadZipFile when opens a ZIP file with
  an incomplete "End of Central Directory" record.  Original patch by
  Guilherme Polo and Alan McIntyre.

* bpo-17071: Signature.bind() now works when one of the keyword
  arguments is named "self".

* bpo-12004: Fix an internal error in PyZipFile when writing an
  invalid Python file. Patch by Ben Morgan.

* Have py_compile use importlib as much as possible to avoid code
  duplication. Code now raises FileExistsError if the file path to be
  used for the byte- compiled file is a symlink or non-regular file as
  a warning that import will not keep the file path type if it writes
  to that path.

* bpo-16972: Have site.addpackage() consider already known paths
  even when none are explicitly passed in. Bug report and fix by
  Kirill.

* bpo-1602133: on Mac OS X a shared library build ("--enable-
  shared") now fills the "os.environ" variable correctly.

* bpo-15505: "unittest.installHandler" no longer assumes SIGINT
  handler is set to a callable object.

* bpo-13454: Fix a crash when deleting an iterator created by
  itertools.tee() if all other iterators were very advanced before.

* bpo-12411: Fix to cgi.parse_multipart to correctly use bytes
  boundaries and bytes data. Patch by Jonas Wagner.

* bpo-16957: shutil.which() no longer searches a bare file name in
  the current directory on Unix and no longer searches a relative file
  path with a directory part in PATH directories.  Patch by Thomas
  Kluyver.

* bpo-1159051: GzipFile now raises EOFError when reading a corrupted
  file with truncated header or footer.

* bpo-16993: shutil.which() now preserves the case of the path and
  extension on Windows.

* bpo-16992: On Windows in signal.set_wakeup_fd, validate the file
  descriptor argument.

* bpo-16422: For compatibility with the Python version, the C
  version of decimal now uses strings instead of integers for rounding
  mode constants.

* bpo-15861: tkinter now correctly works with lists and tuples
  containing strings with whitespaces, backslashes or unbalanced
  braces.

* bpo-9720: zipfile now writes correct local headers for files
  larger than 4 GiB.

* bpo-16955: Fix the poll() method for multiprocessing's socket
  connections on Windows.

* SSLContext.load_dh_params() now properly closes the input file.

* bpo-15031: Refactor some .pyc management code to cut down on code
  duplication. Thanks to Ronan Lamy for the report and taking an
  initial stab at the problem.

* bpo-16398: Optimize deque.rotate() so that it only moves pointers
  and doesn't touch the underlying data with increfs and decrefs.

* bpo-16900: Issue a ResourceWarning when an ssl socket is left
  unclosed.

* bpo-13899: "\A", "\Z", and "\B" now correctly match the A, Z, and
  B literals when used inside character classes (e.g. "'[\A]'"). Patch
  by Matthew Barnett.

* bpo-15545: Fix regression in sqlite3's iterdump method where it
  was failing if the connection used a row factory (such as
  sqlite3.Row) that produced unsortable objects. (Regression was
  introduced by fix for 9750).

* fcntl: add F_DUPFD_CLOEXEC constant, available on Linux 2.6.24+.

* bpo-15972: Fix error messages when os functions expecting a file
  name or file descriptor receive the incorrect type.

* bpo-8109: The ssl module now has support for server-side SNI,
  thanks to a "SSLContext.set_servername_callback()" method.  Patch by
  Daniel Black.

* bpo-16860: In tempfile, use O_CLOEXEC when available to set the
  close-on-exec flag atomically.

* bpo-16674: random.getrandbits() is now 20-40% faster for small
  integers.

* bpo-16009: JSON error messages now provide more information.

* bpo-16828: Fix error incorrectly raised by bz2.compress(b'') and
  bz2.BZ2Compressor.compress(b''). Initial patch by Martin Packman.

* bpo-16833: In http.client.HTTPConnection, do not concatenate the
  request headers and body when the payload exceeds 16 KB, since it
  can consume more memory for no benefit.  Patch by Benno Leslie.

* bpo-16541: tk_setPalette() now works with keyword arguments.

* bpo-16820: In configparser, "parser.popitem()" no longer raises
  ValueError. This makes "parser.clean()" work correctly.

* bpo-16820: In configparser, "parser['section'] = {}" now preserves
  section order within the parser. This makes "parser.update()"
  preserve section order as well.

* bpo-16820: In configparser, "parser['DEFAULT'] = {}" now correctly
  clears previous values stored in the default section. Same goes for
  "parser.update({'DEFAULT': {}})".

* bpo-9586: Redefine SEM_FAILED on MacOSX to keep compiler happy.

* bpo-16787: Increase asyncore and asynchat default output buffers
  size, to decrease CPU usage and increase throughput.

* bpo-10527: make multiprocessing use poll() instead of select() if
  available.

* bpo-16688: Now regexes contained backreferences correctly work
  with non-ASCII strings. Patch by Matthew Barnett.

* bpo-16486: Make aifc files act as context managers.

* bpo-16485: Now file descriptors are closed if file header patching
  failed on closing an aifc file.

* bpo-16640: Run less code under a lock in sched module.

* bpo-16165: sched.scheduler.run() no longer blocks a scheduler for
  other threads.

* bpo-16641: Default values of sched.scheduler.enter() are no longer
  modifiable.

* bpo-16618: Make glob.glob match consistently across strings and
  bytes regarding leading dots.  Patch by Serhiy Storchaka.

* bpo-16788: Add samestat to Lib/ntpath.py

* bpo-16713: Parsing of 'tel' urls using urlparse separates params
  from path.

* bpo-16443: Add docstrings to regular expression match objects.
  Patch by Anton Kasyanov.

* bpo-15701: Fix HTTPError info method call to return the headers
  information.

* bpo-16752: Add a missing import to modulefinder. Patch by Berker
  Peksag.

* bpo-16646: ftplib.FTP.makeport() might lose socket error details.
  (patch by Serhiy Storchaka)

* bpo-16626: Fix infinite recursion in glob.glob() on Windows when
  the pattern contains a wildcard in the drive or UNC path.  Patch by
  Serhiy Storchaka.

* bpo-15783: Except for the number methods, the C version of decimal
  now supports all None default values present in decimal.py. These
  values were largely undocumented.

* bpo-11175: argparse.FileType now accepts encoding and errors
  arguments. Patch by Lucas Maystre.

* bpo-16488: epoll() objects now support the "with" statement.
  Patch by Serhiy Storchaka.

* bpo-16298: In HTTPResponse.read(), close the socket when there is
  no Content-Length and the incoming stream is finished.  Patch by
  Eran Rundstein.

* bpo-16049: Add abc.ABC class to enable the use of inheritance to
  create ABCs, rather than the more cumbersome metaclass=ABCMeta.
  Patch by Bruno Dupuis.

* Expose the TCP_FASTOPEN and MSG_FASTOPEN flags in socket when
  they're available.

* bpo-15701: Add a .headers attribute to urllib.error.HTTPError.
  Patch contributed by Berker Peksag.

* bpo-15872: Fix 3.3 regression introduced by the new fd-based
  shutil.rmtree that caused it to not ignore certain errors when
  ignore_errors was set. Patch by Alessandro Moura and Serhiy
  Storchaka.

* bpo-16248: Disable code execution from the user's home directory
  by tkinter when the -E flag is passed to Python.  Patch by Zachary
  Ware.

* bpo-13390: New function "sys.getallocatedblocks()" returns the
  number of memory blocks currently allocated.

* bpo-16628: Fix a memory leak in ctypes.resize().

* bpo-13614: Fix setup.py register failure with invalid rst in
  description. Patch by Julien Courteau and Pierre Paul Lefebvre.

* bpo-13512: Create ~/.pypirc securely (CVE-2011-4944).  Initial
  patch by Philip Jenvey, tested by Mageia and Debian.

* bpo-7719: Make distutils ignore ".nfs*" files instead of choking
  later on.  Initial patch by SilentGhost and Jeff Ramnani.

* bpo-13120: Allow to call pdb.set_trace() from thread. Patch by
  Ilya Sandler.

* bpo-16585: Make CJK encoders support error handlers that return
  bytes per PEP 383.

* bpo-10182: The re module doesn't truncate indices to 32 bits
  anymore. Patch by Serhiy Storchaka.

* bpo-16333: use (",", ": ") as default separator in json when
  indent is specified, to avoid trailing whitespace.  Patch by Serhiy
  Storchaka.

* bpo-16573: In 2to3, treat enumerate() like a consuming call, so
  superfluous list() calls aren't added to filter(), map(), and zip()
  which are directly passed enumerate().

* bpo-16464: Reset the Content-Length header when a urllib Request
  is reused with new data.

* bpo-12848: The pure Python pickle implementation now treats object
  lengths as unsigned 32-bit integers, like the C implementation does.
  Patch by Serhiy Storchaka.

* bpo-16423: urllib.request now has support for "data:" URLs.  Patch
  by Mathias Panzenböck.

* bpo-4473: Add a POP3.stls() to switch a clear-text POP3 session
  into an encrypted POP3 session, on supported servers.  Patch by
  Lorenzo Catucci.

* bpo-4473: Add a POP3.capa() method to query the capabilities
  advertised by the POP3 server.  Patch by Lorenzo Catucci.

* bpo-4473: Ensure the socket is shutdown cleanly in POP3.close().
  Patch by Lorenzo Catucci.

* bpo-16522: added FAIL_FAST flag to doctest.

* bpo-15627: Add the importlib.abc.InspectLoader.source_to_code()
  method.

* bpo-16408: Fix file descriptors not being closed in error
  conditions in the zipfile module.  Patch by Serhiy Storchaka.

* bpo-14631: Add a new "weakref.WeakMethod" to simulate weak
  references to bound methods.

* bpo-16469: Fix exceptions from float -> Fraction and Decimal ->
  Fraction conversions for special values to be consistent with those
  for float -> int and Decimal -> int.  Patch by Alexey Kachayev.

* bpo-16481: multiprocessing no longer leaks process handles on
  Windows.

* bpo-12428: Add a pure Python implementation of
  functools.partial(). Patch by Brian Thorne.

* bpo-16140: The subprocess module no longer double closes its child
  subprocess.PIPE parent file descriptors on child error prior to
  exec().

* Remove a bare print to stdout from the subprocess module that
  could have happened if the child process wrote garbage to its pre-
  exec error pipe.

* The subprocess module now raises its own SubprocessError instead
  of a RuntimeError in various error situations which should not
  normally happen.

* bpo-16327: The subprocess module no longer leaks file descriptors
  used for stdin/stdout/stderr pipes to the child when fork() fails.

* bpo-14396: Handle the odd rare case of waitpid returning 0 when
  not expected in subprocess.Popen.wait().

* bpo-16411: Fix a bug where zlib.decompressobj().flush() might try
  to access previously- freed memory. Patch by Serhiy Storchaka.

* bpo-16357: fix calling accept() on a SSLSocket created through
  SSLContext.wrap_socket().  Original patch by Jeff McNeil.

* bpo-16409: The reporthook callback made by the legacy
  urllib.request.urlretrieve API now properly supplies a constant non-
  zero block_size as it did in Python 3.2 and 2.7.  This matches the
  behavior of urllib.request.URLopener.retrieve.

* bpo-16431: Use the type information when constructing a Decimal
  subtype from a Decimal argument.

* bpo-15641: Clean up deprecated classes from importlib. Patch by
  Taras Lyapun.

* bpo-16350: zlib.decompressobj().decompress() now accumulates data
  from successive calls after EOF in unused_data, instead of only
  saving the argument to the last call. decompressobj().flush() now
  correctly sets unused_data and unconsumed_tail. A bug in the
  handling of MemoryError when setting the unconsumed_tail attribute
  has also been fixed. Patch by Serhiy Storchaka.

* bpo-12759: sre_parse now raises a proper error when the name of
  the group is missing. Initial patch by Serhiy Storchaka.

* bpo-16152: fix tokenize to ignore whitespace at the end of the
  code when no newline is found.  Patch by Ned Batchelder.

* bpo-16284: Prevent keeping unnecessary references to worker
  functions in concurrent.futures ThreadPoolExecutor.

* bpo-16230: Fix a crash in select.select() when one the lists
  changes size while iterated on.  Patch by Serhiy Storchaka.

* bpo-16228: Fix a crash in the json module where a list changes
  size while it is being encoded.  Patch by Serhiy Storchaka.

* bpo-16351: New function gc.get_stats() returns per-generation
  collection statistics.

* bpo-14897: Enhance error messages of struct.pack and
  struct.pack_into. Patch by Matti Mäki.

* bpo-16316: mimetypes now recognizes the .xz and .txz (.tar.xz)
  extensions. Patch by Serhiy Storchaka.

* bpo-12890: cgitb no longer prints spurious <p> tags in text mode
  when the logdir option is specified.

* bpo-16307: Fix multiprocessing.Pool.map_async not calling its
  callbacks. Patch by Janne Karila.

* bpo-16305: Fix a segmentation fault occurring when interrupting
  math.factorial.

* bpo-16116: Fix include and library paths to be correct when
  building C extensions in venvs.

* bpo-16245: Fix the value of a few entities in html.entities.html5.

* bpo-16301: Fix the localhost verification in urllib/request.py for
  file:// urls.

* bpo-16250: Fix the invocations of URLError which had misplaced
  filename attribute for exception.

* bpo-10836: Fix exception raised when file not found in urlretrieve
  Initial patch by Ezio Melotti.

* bpo-14398: Fix size truncation and overflow bugs in the bz2
  module.

* bpo-12692: Fix resource leak in urllib.request when talking to an
  HTTP server that does not include a "Connection: close" header in
  its responses.

* bpo-12034: Fix bogus caching of result in
  check_GetFinalPathNameByHandle. Patch by Atsuo Ishimoto.

* Improve performance of "lzma.LZMAFile" (see also issue #16034).

* bpo-16220: wsgiref now always calls close() on an iterable
  response. Patch by Brent Tubbs.

* bpo-16270: urllib may hang when used for retrieving files via FTP
  by using a context manager.  Patch by Giampaolo Rodola'.

* bpo-16461: Wave library should be able to deal with 4GB wav files,
  and sample rate of 44100 Hz.

* bpo-16176: Properly identify Windows 8 via platform.platform()

* bpo-16088: BaseHTTPRequestHandler's send_error method includes a
  Content-Length header in it's response now. Patch by Antoine Pitrou.

* bpo-16114: The subprocess module no longer provides a misleading
  error message stating that args[0] did not exist when either the cwd
  or executable keyword arguments specified a path that did not exist.

* bpo-16169: Fix ctypes.WinError()'s confusion between errno and
  winerror.

* bpo-16110: logging.fileConfig now accepts a pre-initialised
  ConfigParser instance.

* bpo-1492704: shutil.copyfile() raises a distinct SameFileError now
  if source and destination are the same file. Patch by Atsuo
  Ishimoto.

* bpo-13896: Make shelf instances work with 'with' as context
  managers. Original patch by Filip Gruszczyński.

* bpo-15417: Add support for csh and fish in venv activation
  scripts.

* bpo-14377: ElementTree.write and some of the module-level
  functions have a new parameter - *short_empty_elements*. It controls
  how elements with no contents are emitted.

* bpo-16089: Allow ElementTree.TreeBuilder to work again with a non-
  Element element_factory (fixes a regression in SimpleTAL).

* bpo-9650: List commonly used format codes in time.strftime and
  time.strptime docsttings.  Original patch by Mike Hoy.

* bpo-15452: logging configuration socket listener now has a verify
  option that allows an application to apply a verification function
  to the received configuration data before it is acted upon.

* bpo-16034: Fix performance regressions in the new "bz2.BZ2File"
  implementation. Initial patch by Serhiy Storchaka.

* "pty.spawn()" now returns the child process status returned by
  "os.waitpid()".

* bpo-15756: "subprocess.poll()" now properly handles "errno.ECHILD"
  to return a returncode of 0 when the child has already exited or
  cannot be waited on.

* bpo-15323: Improve failure message of
  "Mock.assert_called_once_with()".

* bpo-16064: "unittest -m" claims executable is "python", not
  "python3".

* bpo-12376: Pass on parameters in "TextTestResult.__init__()" super
  call.

* bpo-15222: Insert blank line after each message in mbox mailboxes.

* bpo-16013: Fix "csv.Reader" parsing issue with ending quote
  characters. Patch by Serhiy Storchaka.

* bpo-15421: Fix an OverflowError in "Calendar.itermonthdates()"
  after "datetime.MAXYEAR".  Patch by Cédric Krier.

* bpo-16112: platform.architecture does not correctly escape
  argument to /usr/bin/file. Patch by David Benjamin.

* bpo-15970: "xml.etree.ElementTree" now serializes correctly the
  empty HTML elements 'meta' and 'param'.

* bpo-15842: The "SocketIO.{readable,writable,seekable}" methods now
  raise ValueError when the file-like object is closed.  Patch by
  Alessandro Moura.

* bpo-15876: Fix a refleak in the "curses" module: window.encoding.

* bpo-15881: Fix "atexit" hook in "multiprocessing".  Original patch
  by Chris McDonough.

* bpo-15841: The readable(), writable() and seekable() methods of
  "io.BytesIO" and "io.StringIO" objects now raise ValueError when the
  object has been closed. Patch by Alessandro Moura.

* bpo-15447: Use "subprocess.DEVNULL" in webbrowser, instead of
  opening "os.devnull" explicitly and leaving it open.

* bpo-15509: "webbrowser.UnixBrowser" no longer passes empty
  arguments to Popen when "%action" substitutions produce empty
  strings.

* bpo-12776: Call "argparse" type function (specified by
  add_argument) only once. Before, the type function was called twice
  in the case where the default was specified and the argument was
  given as well. This was especially problematic for the FileType
  type, as a default file would always be opened, even if a file
  argument was specified on the command line. (See also: bpo-11839)

* bpo-15906: Fix a regression in argparse caused by the preceding
  change, when "action='append'", "type='str'" and "default=[]".

* bpo-16113: Added sha3 module based on the Keccak reference
  implementation 3.2. The "hashlib" module has four additional hash
  algorithms: "sha3_224", "sha3_256", "sha3_384" and "sha3_512". As
  part of the patch some common code was moved from _hashopenssl.c to
  hashlib.h.

* ctypes.call_commethod was removed, since its only usage was in the
  defunct samples directory.

* bpo-16692: Added TLSv1.1 and TLSv1.2 support for the ssl modules.

* bpo-16832: add abc.get_cache_token() to expose cache validity
  checking support in ABCMeta.


IDLE
----

* bpo-18429: Format / Format Paragraph, now works when comment
  blocks are selected. As with text blocks, this works best when the
  selection only includes complete lines.

* bpo-18226: Add docstrings and unittests for FormatParagraph.py.
  Original patches by Todd Rovito and Phil Webster.

* bpo-18279: Format - Strip trailing whitespace no longer marks a
  file as changed when it has not been changed. This fix followed the
  addition of a test file originally written by Phil Webster (the
  issue's main goal).

* bpo-7136: In the Idle File menu, "New Window" is renamed "New
  File". Patch by Tal Einat, Roget Serwy, and Todd Rovito.

* Remove dead imports of imp.

* bpo-18196: Avoid displaying spurious SystemExit tracebacks.

* bpo-5492: Avoid traceback when exiting IDLE caused by a race
  condition.

* bpo-17511: Keep IDLE find dialog open after clicking "Find Next".
  Original patch by Sarah K.

* bpo-18055: Move IDLE off of imp and on to importlib.

* bpo-15392: Create a unittest framework for IDLE. Initial patch by
  Rajagopalasarma Jayakrishnan. See Lib/idlelib/idle_test/README.txt
  for how to run Idle tests.

* bpo-14146: Highlight source line while debugging on Windows.

* bpo-17838: Allow sys.stdin to be reassigned.

* bpo-13495: Avoid loading the color delegator twice in IDLE.

* bpo-17798: Allow IDLE to edit new files when specified on command
  line.

* bpo-14735: Update IDLE docs to omit "Control-z on Windows".

* bpo-17532: Always include Options menu for IDLE on OS X. Patch by
  Guilherme Simões.

* bpo-17585: Fixed IDLE regression. Now closes when using exit() or
  quit().

* bpo-17657: Show full Tk version in IDLE's about dialog. Patch by
  Todd Rovito.

* bpo-17613: Prevent traceback when removing syntax colorizer in
  IDLE.

* bpo-1207589: Backwards-compatibility patch for right-click menu in
  IDLE.

* bpo-16887: IDLE now accepts Cancel in tabify/untabify dialog box.

* bpo-17625: In IDLE, close the replace dialog after it is used.

* bpo-14254: IDLE now handles readline correctly across shell
  restarts.

* bpo-17614: IDLE no longer raises exception when quickly closing a
  file.

* bpo-6698: IDLE now opens just an editor window when configured to
  do so.

* bpo-8900: Using keyboard shortcuts in IDLE to open a file no
  longer raises an exception.

* bpo-6649: Fixed missing exit status in IDLE. Patch by Guilherme
  Polo.

* bpo-17114: IDLE now uses non-strict config parser.

* bpo-9290: In IDLE the sys.std* streams now implement io.TextIOBase
  interface and support all mandatory methods and properties.

* bpo-5066: Update IDLE docs. Patch by Todd Rovito.

* bpo-16829: IDLE printing no longer fails if there are spaces or
  other special characters in the file path.

* bpo-16491: IDLE now prints chained exception tracebacks.

* bpo-16819: IDLE method completion now correctly works for bytes
  literals.

* bpo-16504: IDLE now catches SyntaxErrors raised by tokenizer.
  Patch by Roger Serwy.

* bpo-16511: Use default IDLE width and height if config param is
  not valid. Patch Serhiy Storchaka.

* bpo-1207589: Add Cut/Copy/Paste items to IDLE right click Context
  Menu. Patch by Todd Rovito.

* bpo-16123: IDLE - deprecate running without a subprocess. Patch by
  Roger Serwy.


Tests
-----

* bpo-1666318: Add a test that shutil.copytree() retains directory
  permissions.  Patch by Catherine Devlin.

* bpo-18273: move the tests in Lib/test/json_tests to
  Lib/test/test_json and make them discoverable by unittest.  Patch by
  Zachary Ware.

* Fix a fcntl test case on KFreeBSD, Debian #708653 (Petr Salinger).

* bpo-18396: Fix spurious test failure in test_signal on Windows
  when faulthandler is enabled (Patch by Jeremy Kloth)

* bpo-17046: Fix broken test_executable_without_cwd in
  test_subprocess.

* bpo-15415: Add new temp_dir() and change_cwd() context managers to
  test.support, and refactor temp_cwd() to use them.  Patch by Chris
  Jerdonek.

* bpo-15494: test.support is now a package rather than a module
  (Initial patch by Indra Talip)

* bpo-17944: test_zipfile now discoverable and uses subclassing to
  generate tests for different compression types.  Fixed a bug with
  skipping some tests due to use of exhausted iterators.

* bpo-18266: test_largefile now works with unittest test discovery
  and supports running only selected tests.  Patch by Zachary Ware.

* bpo-17767: test_locale now works with unittest test discovery.
  Original patch by Zachary Ware.

* bpo-18375: Assume --randomize when --randseed is used for running
  the testsuite.

* bpo-11185: Fix test_wait4 under AIX.  Patch by Sébastien Sablé.

* bpo-18207: Fix test_ssl for some versions of OpenSSL that ignore
  seconds in ASN1_TIME fields.

* bpo-18094: test_uuid no longer reports skipped tests as passed.

* bpo-17992: Add timeouts to asyncore and asynchat tests so that
  they won't accidentally hang.

* bpo-17833: Fix test_gdb failures seen on machines where debug
  symbols for glibc are available (seen on PPC64 Linux).

* bpo-7855: Add tests for ctypes/winreg for issues found in
  IronPython. Initial patch by Dino Viehland.

* bpo-11078: test___all__ now checks for duplicates in __all__.
  Initial patch by R. David Murray.

* bpo-17712: Fix test_gdb failures on Ubuntu 13.04.

* bpo-17835: Fix test_io when the default OS pipe buffer size is
  larger than one million bytes.

* bpo-17065: Use process-unique key for winreg tests to avoid
  failures if test is run multiple times in parallel (eg: on a
  buildbot host).

* bpo-12820: add tests for the xml.dom.minicompat module. Patch by
  John Chandler and Phil Connell.

* bpo-17691: test_univnewlines now works with unittest test
  discovery. Patch by Zachary Ware.

* bpo-17790: test_set now works with unittest test discovery. Patch
  by Zachary Ware.

* bpo-17789: test_random now works with unittest test discovery.
  Patch by Zachary Ware.

* bpo-17779: test_osx_env now works with unittest test discovery.
  Patch by Zachary Ware.

* bpo-17766: test_iterlen now works with unittest test discovery.
  Patch by Zachary Ware.

* bpo-17690: test_time now works with unittest test discovery. Patch
  by Zachary Ware.

* bpo-17692: test_sqlite now works with unittest test discovery.
  Patch by Zachary Ware.

* bpo-11995: test_pydoc doesn't import all sys.path modules anymore.

* bpo-17448: test_sax now skips if there are no xml parsers
  available instead of raising an ImportError.

* bpo-11420: make test suite pass with -B/DONTWRITEBYTECODE set.
  Initial patch by Thomas Wouters.

* bpo-10652: make tcl/tk tests run after __all__ test, patch by
  Zachary Ware.

* bpo-11963: remove human verification from test_parser and
  test_subprocess.

* bpo-11732: add a new suppress_crash_popup() context manager to
  test.support that disables crash popups on Windows and use it in
  test_faulthandler and test_capi.

* bpo-13898: test_ssl no longer prints a spurious stack trace on
  Ubuntu.

* bpo-17283: Share code between "__main__.py" and "regrtest.py" in
  "Lib/test".

* bpo-17249: convert a test in test_capi to use unittest and reap
  threads.

* bpo-17107: Test client-side SNI support in urllib.request thanks
  to the new server-side SNI support in the ssl module.  Initial patch
  by Daniel Black.

* bpo-17041: Fix testing when Python is configured with the
  --without- doc-strings.

* bpo-16923: Fix ResourceWarnings in test_ssl.

* bpo-15539: Added regression tests for Tools/scripts/pindent.py.

* bpo-17479: test_io now works with unittest test discovery. Patch
  by Zachary Ware.

* bpo-17066: test_robotparser now works with unittest test
  discovery. Patch by Zachary Ware.

* bpo-17334: test_index now works with unittest test discovery.
  Patch by Zachary Ware.

* bpo-17333: test_imaplib now works with unittest test discovery.
  Patch by Zachary Ware.

* bpo-17082: test_dbm* now work with unittest test discovery. Patch
  by Zachary Ware.

* bpo-17079: test_ctypes now works with unittest test discovery.
  Patch by Zachary Ware.

* bpo-17304: test_hash now works with unittest test discovery. Patch
  by Zachary Ware.

* bpo-17303: test_future* now work with unittest test discovery.
  Patch by Zachary Ware.

* bpo-17163: test_file now works with unittest test discovery. Patch
  by Zachary Ware.

* bpo-16925: test_configparser now works with unittest test
  discovery. Patch by Zachary Ware.

* bpo-16918: test_codecs now works with unittest test discovery.
  Patch by Zachary Ware.

* bpo-16919: test_crypt now works with unittest test discovery.
  Patch by Zachary Ware.

* bpo-16910: test_bytes, test_unicode, and test_userstring now work
  with unittest test discovery.  Patch by Zachary Ware.

* bpo-16905: test_warnings now works with unittest test discovery.
  Initial patch by Berker Peksag.

* bpo-16898: test_bufio now works with unittest test discovery.
  Patch by Zachary Ware.

* bpo-16888: test_array now works with unittest test discovery.
  Patch by Zachary Ware.

* bpo-16896: test_asyncore now works with unittest test discovery.
  Patch by Zachary Ware.

* bpo-16897: test_bisect now works with unittest test discovery.
  Initial patch by Zachary Ware.

* bpo-16852: test_genericpath, test_posixpath, test_ntpath, and
  test_macpath now work with unittest test discovery.  Patch by
  Zachary Ware.

* bpo-16748: test_heapq now works with unittest test discovery.

* bpo-10646: Tests rearranged for os.samefile/samestat to check for
  not just symlinks but also hard links.

* bpo-15302: Switch regrtest from using getopt to using argparse.

* bpo-15324: Fix regrtest parsing of --fromfile, --match, and
  --randomize options.

* bpo-16702: test_urllib2_localnet tests now correctly ignores
  proxies for localhost tests.

* bpo-16664: Add regression tests for glob's behaviour concerning
  entries starting with a ".".  Patch by Sebastian Kreft.

* bpo-13390: The "-R" option to regrtest now also checks for memory
  allocation leaks, using "sys.getallocatedblocks()".

* bpo-16559: Add more tests for the json module, including some from
  the official test suite at json.org.  Patch by Serhiy Storchaka.

* bpo-16661: Fix the "os.getgrouplist()" test by not assuming that
  it gives the same output as **id -G**.

* bpo-16115: Add some tests for the executable argument to
  subprocess.Popen().  Initial patch by Kushal Das.

* bpo-16126: PyErr_Format format mismatch in _testcapimodule.c.
  Patch by Serhiy Storchaka.

* bpo-15304: Fix warning message when "os.chdir()" fails inside
  "test.support.temp_cwd()".  Patch by Chris Jerdonek.

* bpo-15802: Fix test logic in "TestMaildir.test_create_tmp()".
  Patch by Serhiy Storchaka.

* bpo-15557: Added a test suite for the webbrowser module, thanks to
  Anton Barkovsky.

* bpo-16698: Skip posix test_getgroups when built with OS X
  deployment target prior to 10.6.


Build
-----

* bpo-16067: Add description into MSI file to replace installer's
  temporary name.

* bpo-18257: Fix readlink usage in python-config.  Install the
  python version again on Darwin.

* bpo-18481: Add C coverage reporting with gcov and lcov. A new make
  target "coverage- report" creates an instrumented Python build, runs
  unit tests and creates a HTML. The report can be updated with "make
  coverage-lcov".

* bpo-17845: Clarified the message printed when some module are not
  built.

* bpo-18256: Compilation fix for recent AIX releases.  Patch by
  David Edelsohn.

* bpo-17547: In configure, explicitly pass -Wformat for the benefit
  for GCC 4.8.

* bpo-15172: Document NASM 2.10+ as requirement for building OpenSSL
  1.0.1 on Windows.

* bpo-17591: Use lowercase filenames when including Windows header
  files. Patch by Roumen Petrov.

* bpo-17550: Fix the --enable-profiling configure switch.

* bpo-17425: Build with openssl 1.0.1d on Windows.

* bpo-16754: Fix the incorrect shared library extension on linux.
  Introduce two makefile macros SHLIB_SUFFIX and EXT_SUFFIX. SO now
  has the value of SHLIB_SUFFIX again (as in 2.x and 3.1). The SO
  macro is removed in 3.4.

* bpo-5033: Fix building of the sqlite3 extension module when the
  SQLite library version has "beta" in it. Patch by Andreas Pelme.

* bpo-17228: Fix building without pymalloc.

* bpo-3718: Use AC_ARG_VAR to set MACHDEP in configure.ac.

* bpo-16235: Implement python-config as a shell script.

* bpo-16769: Remove outdated Visual Studio projects.

* bpo-17031: Fix running regen in cross builds.

* bpo-3754: fix typo in pthread AC_CACHE_VAL.

* bpo-15484: Fix _PYTHON_PROJECT_BASE for srcdir != builddir builds;
  use _PYTHON_PROJECT_BASE in distutils/sysconfig.py.

* Drop support for Windows 2000 (changeset e52df05b496a).

* bpo-17029: Let h2py search the multiarch system include directory.

* bpo-16953: Fix socket module compilation on platforms with
  HAVE_BROKEN_POLL. Patch by Jeffrey Armstrong.

* bpo-16320: Remove redundant Makefile dependencies for strings and
  bytes.

* Cross compiling needs host and build settings. configure no longer
  creates a broken PYTHON_FOR_BUILD variable when --build is missing.

* Fix cross compiling issue in setup.py, ensure that lib_dirs and
  inc_dirs are defined in cross compiling mode, too.

* bpo-16836: Enable IPv6 support even if IPv6 is disabled on the
  build host.

* bpo-16593: Have BSD 'make -s' do the right thing, thanks to Daniel
  Shahaf

* bpo-16262: fix out-of-src-tree builds, if mercurial is not
  installed.

* bpo-15298: ensure _sysconfigdata is generated in build directory,
  not source directory.

* bpo-15833: Fix a regression in 3.3 that resulted in exceptions
  being raised if importlib failed to write byte-compiled files.  This
  affected attempts to build Python out-of-tree from a read-only
  source directory.

* bpo-15923: Fix a mistake in "asdl_c.py" that resulted in a
  TypeError after 2801bf875a24 (see #15801).

* bpo-16135: Remove OS/2 support.

* bpo-15819: Make sure we can build Python out-of-tree from a read-
  only source directory. (Somewhat related to issue #9860.)

* bpo-15587: Enable Tk high-resolution text rendering on Macs with
  Retina displays. Applies to Tkinter apps, such as IDLE, on OS X
  framework builds linked with Cocoa Tk 8.5.

* bpo-17161: make install now also installs a python3 man page.


C API
-----

* bpo-18351: Fix various issues in a function in importlib provided
  to help PyImport_ExecCodeModuleWithPathnames() (and thus by
  extension PyImport_ExecCodeModule() and
  PyImport_ExecCodeModuleEx()).

* bpo-9369: The types of "char*" arguments of
  PyObject_CallFunction() and PyObject_CallMethod() now changed to
  "const char*".  Based on patches by Jörg Müller and Lars Buitinck.

* bpo-17206: Py_CLEAR(), Py_DECREF(), Py_XINCREF() and Py_XDECREF()
  now expand their arguments once instead of multiple times.  Patch
  written by Illia Polosukhin.

* bpo-17522: Add the PyGILState_Check() API.

* bpo-17327: Add PyDict_SetDefault.

* bpo-16881: Fix Py_ARRAY_LENGTH macro for GCC < 3.1.

* bpo-16505: Remove unused Py_TPFLAGS_INT_SUBCLASS.

* bpo-16086: PyTypeObject.tp_flags and PyType_Spec.flags are now
  unsigned (unsigned long and unsigned int) to avoid an undefined
  behaviour with Py_TPFLAGS_TYPE_SUBCLASS ((1 << 31).
  PyType_GetFlags() result type is now unsigned too (unsigned long,
  instead of long).

* bpo-16166: Add PY_LITTLE_ENDIAN and PY_BIG_ENDIAN macros and
  unified endianness detection and handling.


Documentation
-------------

* bpo-17701: Improving strftime documentation.

* bpo-18440: Clarify that "hash()" can truncate the value returned
  from an object's custom "__hash__()" method.

* bpo-17844: Add links to encoders and decoders for bytes-to-bytes
  codecs.

* bpo-14097: improve the "introduction" page of the tutorial.

* bpo-17977: The documentation for the cadefault argument's default
  value in urllib.request.urlopen() is fixed to match the code.

* bpo-6696: add documentation for the Profile objects, and improve
  profile/cProfile docs.  Patch by Tom Pinckney.

* bpo-15940: Specify effect of locale on time functions.

* bpo-17538: Document XML vulnerabilties

* bpo-16642: sched.scheduler timefunc initial default is
  time.monotonic. Patch by Ramchandra Apte

* bpo-17047: remove doubled words in docs and docstrings reported by
  Serhiy Storchaka and Matthew Barnett.

* bpo-15465: Document the versioning macros in the C API docs rather
  than the standard library docs. Patch by Kushal Das.

* bpo-16406: Combine the pages for uploading and registering to
  PyPI.

* bpo-16403: Document how distutils uses the maintainer field in
  PKG- INFO. Patch by Jyrki Pulliainen.

* bpo-16695: Document how glob handles filenames starting with a
  dot. Initial patch by Jyrki Pulliainen.

* bpo-8890: Stop advertising an insecure practice by replacing uses
  of the /tmp directory with better alternatives in the documentation.
  Patch by Geoff Wilson.

* bpo-17203: add long option names to unittest discovery docs.

* bpo-13094: add "Why do lambdas defined in a loop with different
  values all return the same result?" programming FAQ.

* bpo-14901: Update portions of the Windows FAQ. Patch by Ashish
  Nitin Patil.

* bpo-16267: Better document the 3.3+ approach to combining
  @abstractmethod with @staticmethod, @classmethod and @property

* bpo-15209: Clarify exception chaining description in exceptions
  module documentation

* bpo-15990: Improve argument/parameter documentation.

* bpo-16209: Move the documentation for the str built-in function to
  a new str class entry in the "Text Sequence Type" section.

* bpo-13538: Improve str() and object.__str__() documentation.

* bpo-16489: Make it clearer that importlib.find_loader() needs
  parent packages to be explicitly imported.

* bpo-16400: Update the description of which versions of a given
  package PyPI displays.

* bpo-15677: Document that zlib and gzip accept a compression level
  of 0 to mean 'no compression'. Patch by Brian Brazil.

* bpo-16197: Update winreg docstrings and documentation to match
  code. Patch by Zachary Ware.

* bpo-8040: added a version switcher to the documentation.  Patch by
  Yury Selivanov.

* bpo-16241: Document -X faulthandler command line option. Patch by
  Marek Šuppa.

* Additional comments and some style changes in the
  concurrent.futures URL retrieval example

* bpo-16115: Improve subprocess.Popen() documentation around args,
  shell, and executable arguments.

* bpo-13498: Clarify docs of os.makedirs()'s exist_ok argument.
  Done with great native- speaker help from R. David Murray.

* bpo-15533: Clarify docs and add tests for "subprocess.Popen()"'s
  cwd argument.

* bpo-15979: Improve timeit documentation.

* bpo-16036: Improve documentation of built-in "int()"'s signature
  and arguments.

* bpo-15935: Clarification of "argparse" docs, re: add_argument()
  type and default arguments.  Patch contributed by Chris Jerdonek.

* bpo-11964: Document a change in v3.2 to the behavior of the indent
  parameter of json encoding operations.

* bpo-15116: Remove references to appscript as it is no longer being
  supported.


Tools/Demos
-----------

* bpo-18817: Fix a resource warning in Lib/aifc.py demo.  Patch by
  Vajrasky Kok.

* bpo-18439: Make patchcheck work on Windows for ACKS, NEWS.

* bpo-18448: Fix a typo in Tools/demo/eiffel.py.

* bpo-18457: Fixed saving of formulas and complex numbers in
  Tools/demo/ss1.py.

* bpo-18449: Make Tools/demo/ss1.py work again on Python 3.  Patch
  by Févry Thibault.

* bpo-12990: The "Python Launcher" on OSX could not launch python
  scripts that have paths that include wide characters.

* bpo-15239: Make mkstringprep.py work again on Python 3.

* bpo-17028: Allowed Python arguments to be supplied to the Windows
  launcher.

* bpo-17156: pygettext.py now detects the encoding of source files
  and correctly writes and escapes non-ascii characters.

* bpo-15539: Fix a number of bugs in Tools/scripts/pindent.py.  Now
  pindent.py works with a "with" statement.  pindent.py no longer
  produces improper indentation. pindent.py now works with continued
  lines broken after "class" or "def" keywords and with continuations
  at the start of line.

* bpo-11797: Add a 2to3 fixer that maps reload() to imp.reload().

* bpo-10966: Remove the concept of unexpected skipped tests.

* bpo-9893: Removed the Misc/Vim directory.

* Removed the Misc/TextMate directory.

* bpo-16245: Add the Tools/scripts/parse_html5_entities.py script to
  parse the list of HTML5 entities and update the html.entities.html5
  dictionary.

* bpo-15378: Fix Tools/unicode/comparecodecs.py.  Patch by Serhiy
  Storchaka.

* bpo-16549: Make json.tool work again on Python 3 and add tests.
  Initial patch by Berker Peksag and Serhiy Storchaka.

* bpo-13301: use ast.literal_eval() instead of eval() in
  Tools/i18n/msgfmt.py. Patch by Serhiy Storchaka.


Windows
-------

* bpo-18569: The installer now adds .py to the PATHEXT variable when
  extensions are registered. Patch by Paul Moore.


Python 3.3.0 final
==================

*Release date: 29-Sep-2012*


Core and Builtins
-----------------

* bpo-16046: Fix loading sourceless legacy .pyo files.

* bpo-16060: Fix refcounting bug when "__trunc__()" returns an
  object whose "__int__()" gives a non-integer.  Patch by Serhiy
  Storchaka.


Library
-------

* bpo-16012: Fix a regression in pyexpat. The parser's
  "UseForeignDTD()" method doesn't require an argument again.


Python 3.3.0 release candidate 3
================================

*Release date: 23-Sep-2012*


Core and Builtins
-----------------

* bpo-15900: Fix reference leak in "PyUnicode_TranslateCharmap()".

* bpo-15926: Fix crash after multiple reinitializations of the
  interpreter.

* bpo-15895: Fix FILE pointer leak in one error branch of
  "PyRun_SimpleFileExFlags()" when filename points to a pyc/pyo file,
  closeit is false an and set_main_loader() fails.

* Fixes for a few crash and memory leak regressions found by
  Coverity.


Library
-------

* bpo-15882: Change "_decimal" to accept any coefficient tuple when
  constructing infinities. This is done for backwards compatibility
  with decimal.py: Infinity coefficients are undefined in _decimal (in
  accordance with the specification).

* bpo-15925: Fix a regression in "email.util" where the
  "parsedate()" and "parsedate_tz()" functions did not return None
  anymore when the argument could not be parsed.

* bpo-15973: Fix a segmentation fault when comparing datetime
  timezone objects.

* bpo-15977: Fix memory leak in Modules/_ssl.c when the function
  _set_npn_protocols() is called multiple times, thanks to Daniel
  Sommermann.

* bpo-15969: "faulthandler" module: rename dump_tracebacks_later()
  to dump_traceback_later() and cancel_dump_tracebacks_later() to
  cancel_dump_traceback_later().

* _decimal module: use only C 89 style comments.


Python 3.3.0 release candidate 2
================================

*Release date: 09-Sep-2012*


Core and Builtins
-----------------

* bpo-13992: The trashcan mechanism is now thread-safe.  This
  eliminates sporadic crashes in multi-thread programs when several
  long deallocator chains ran concurrently and involved subclasses of
  built-in container types.

* bpo-15784: Modify "OSError".__str__() to better distinguish
  between errno error numbers and Windows error numbers.

* bpo-15781: Fix two small race conditions in import's module
  locking.


Library
-------

* bpo-17158: Add 'symbols' to help() welcome message; clarify
  'modules spam' messages.

* bpo-15847: Fix a regression in argparse, which did not accept
  tuples as argument lists anymore.

* bpo-15828: Restore support for C extensions in
  "imp.load_module()".

* bpo-15340: Fix importing the random module when "/dev/urandom"
  cannot be opened. This was a regression caused by the hash
  randomization patch.

* bpo-10650: Deprecate the watchexp parameter of the
  "Decimal.quantize()" method.

* bpo-15785: Modify "window.get_wch()" API of the curses module:
  return a character for most keys, and an integer for special keys,
  instead of always returning an integer. So it is now possible to
  distinguish special keys like keypad keys.

* bpo-14223: Fix "window.addch()" of the curses module for special
  characters like curses.ACS_HLINE: the Python function addch(int) and
  addch(bytes) is now calling the C function waddch()/mvwaddch() (as
  it was done in Python 3.2), instead of wadd_wch()/mvwadd_wch(). The
  Python function addch(str) is still calling the C function
  wadd_wch()/mvwadd_wch() if the Python curses is linked to
  libncursesw.


Build
-----

* bpo-15822: Really ensure 2to3 grammar pickles are properly
  installed (replaces fixes for Issue #15645).


Documentation
-------------

* bpo-15814: The memoryview enhancements in 3.3.0 accidentally
  permitted the hashing of multi-dimensional memorviews and
  memoryviews with multi-byte item formats. The intended restrictions
  have now been documented - they will be correctly enforced in 3.3.1.


Python 3.3.0 release candidate 1
================================

*Release date: 25-Aug-2012*


Core and Builtins
-----------------

* bpo-15573: memoryview comparisons are now performed by value with
  full support for any valid struct module format definition.

* bpo-15316: When an item in the fromlist for "__import__()" doesn't
  exist, don't raise an error, but if an exception is raised as part
  of an import do let that propagate.

* bpo-15778: Ensure that "str(ImportError(msg))" returns a str even
  when msg isn't a str.

* bpo-2051: Source file permission bits are once again correctly
  copied to the cached bytecode file. (The migration to importlib
  reintroduced this problem because these was no regression test. A
  test has been added as part of this patch)

* bpo-15761: Fix crash when "PYTHONEXECUTABLE" is set on Mac OS X.

* bpo-15726: Fix incorrect bounds checking in PyState_FindModule.
  Patch by Robin Schreiber.

* bpo-15604: Update uses of "PyObject_IsTrue()" to check for and
  handle errors correctly. Patch by Serhiy Storchaka.

* bpo-14846: "importlib.FileFinder" now handles the case where the
  directory being searched is removed after a previous import attempt.


Library
-------

* bpo-13370: Ensure that ctypes works on Mac OS X when Python is
  compiled using the clang compiler.

* bpo-13072: The array module's 'u' format code is now deprecated
  and will be removed in Python 4.0.

* bpo-15544: Fix Decimal.__float__ to work with payload-carrying
  NaNs.

* bpo-15776: Allow pyvenv to work in existing directory with
  --clean.

* bpo-15249: email's BytesGenerator now correctly mangles From lines
  (when requested) even if the body contains undecodable bytes.

* bpo-15777: Fix a refleak in _posixsubprocess.

* bpo-665194: Update "email.utils.localtime" to use
  datetime.astimezone and correctly handle historic changes in UTC
  offsets.

* bpo-15199: Fix JavaScript's default MIME type to
  application/javascript. Patch by Bohuslav Kabrda.

* bpo-12643: "code.InteractiveConsole" now respects "sys.excepthook"
  when displaying exceptions.  Patch by Aaron Iles.

* bpo-13579: "string.Formatter" now understands the 'a' conversion
  specifier.

* bpo-15595: Fix "subprocess.Popen(universal_newlines=True)" for
  certain locales (utf-16 and utf-32 family). Patch by Chris Jerdonek.

* bpo-15477: In cmath and math modules, add workaround for platforms
  whose system- supplied log1p function doesn't respect signs of
  zeros.

* bpo-15715: "importlib.__import__()" will silence an ImportError
  when the use of fromlist leads to a failed import.

* bpo-14669: Fix pickling of connections and sockets on Mac OS X by
  sending/receiving an acknowledgment after file descriptor transfer.
  TestPicklingConnection has been reenabled for Mac OS X.

* bpo-11062: Fix adding a message from file to Babyl mailbox.

* bpo-15646: Prevent equivalent of a fork bomb when using
  "multiprocessing" on Windows without the "if __name__ == '__main__'"
  idiom.


IDLE
----

* bpo-15678: Fix IDLE menus when started from OS X command line
  (3.3.0b2 regression).


Documentation
-------------

* Touched up the Python 2 to 3 porting guide.

* bpo-14674: Add a discussion of the "json" module's standard
  compliance. Patch by Chris Rebert.

* Create a 'Concurrent Execution' section in the docs, and split up
  the 'Optional Operating System Services' section to use a more user-
  centric classification scheme (splitting them across the new CE
  section, IPC and text processing). Operating system limitations can
  be reflected with the Sphinx ":platform:" tag, it doesn't make sense
  as part of the Table of Contents.

* bpo-4966: Bring the sequence docs up to date for the Py3k
  transition and the many language enhancements since they were
  original written.

* The "path importer" misnomer has been replaced with Eric Snow's
  more- awkward-but-at-least-not-wrong suggestion of "path based
  finder" in the import system reference docs.

* bpo-15640: Document "importlib.abc.Finder" as deprecated.

* bpo-15630: Add an example for "continue" stmt in the tutorial.
  Patch by Daniel Ellis.


Tests
-----

* bpo-15747: ZFS always returns EOPNOTSUPP when attempting to set
  the UF_IMMUTABLE flag (via either chflags or lchflags); refactor
  affected tests in test_posix.py to account for this.

* bpo-15285: Refactor the approach for testing connect timeouts
  using two external hosts that have been configured specifically for
  this type of test.

* bpo-15743: Remove the deprecated method usage in "urllib" tests.
  Patch by Jeff Knupp.

* bpo-15615: Add some tests for the "json" module's handling of
  invalid input data. Patch by Kushal Das.


Build
-----

* Output lib files for PGO build into PGO directory.

* Pick up 32-bit launcher from PGO directory on 64-bit PGO build.

* Drop "PC\python_nt.h" as it's not used.  Add input dependency on
  custom build step.

* bpo-15511: Drop explicit dependency on pythonxy.lib from _decimal
  amd64 configuration.

* Add missing PGI/PGO configurations for pywlauncher.

* bpo-15645: Ensure 2to3 grammar pickles are properly installed.


Python 3.3.0 beta 2
===================

*Release date: 12-Aug-2012*


Core and Builtins
-----------------

* bpo-15568: Fix the return value of "yield from" when StopIteration
  is raised by a custom iterator.

* bpo-13119: "sys.stdout" and "sys.stderr" are now using "rn"
  newline on Windows, as Python 2.

* bpo-15534: Fix the fast-search function for non-ASCII Unicode
  strings.

* bpo-15508: Fix the docstring for "__import__()" to have the proper
  default value of 0 for 'level' and to not mention negative levels
  since they are not supported.

* bpo-15425: Eliminated traceback noise from more situations
  involving importlib.

* bpo-14578: Support modules registered in the Windows registry
  again.

* bpo-15466: Stop using TYPE_INT64 in marshal, to make importlib.h
  (and other byte code files) equal between 32-bit and 64-bit systems.

* bpo-1692335: Move initial exception args assignment to
  "BaseException.__new__()" to help pickling of naive subclasses.

* bpo-12834: Fix "PyBuffer_ToContiguous()" for non-contiguous
  arrays.

* bpo-15456: Fix code "__sizeof__()" after #12399 change.  Patch by
  Serhiy Storchaka.

* bpo-15404: Refleak in PyMethodObject repr.

* bpo-15394: An issue in "PyModule_Create()" that caused references
  to be leaked on some error paths has been fixed.  Patch by Julia
  Lawall.

* bpo-15368: An issue that caused bytecode generation to be non-
  deterministic has been fixed.

* bpo-15202: Consistently use the name "follow_symlinks" for new
  parameters in os and shutil functions.

* bpo-15314: "__main__.__loader__" is now set correctly during
  interpreter startup.

* bpo-15111: When a module imported using 'from import' has an
  ImportError inside itself, don't mask that fact behind a generic
  ImportError for the module itself.

* bpo-15293: Add GC support to the AST base node type.

* bpo-15291: Fix a memory leak where AST nodes where not properly
  deallocated.

* bpo-15110: Fix the tracebacks generated by "import xxx" to not
  show the importlib stack frames.

* bpo-16369: Global PyTypeObjects not initialized with
  PyType_Ready(...).

* bpo-15020: The program name used to search for Python's path is
  now "python3" under Unix, not "python".

* bpo-15897: zipimport.c doesn't check return value of fseek().
  Patch by Felipe Cruz.

* bpo-15033: Fix the exit status bug when modules invoked using -m
  switch, return the proper failure return value (1). Patch
  contributed by Jeff Knupp.

* bpo-15229: An "OSError" subclass whose __init__ doesn't call back
  OSError.__init__ could produce incomplete instances, leading to
  crashes when calling str() on them.

* bpo-15307: Virtual environments now use symlinks with framework
  builds on Mac OS X, like other POSIX builds.


Library
-------

* bpo-14590: configparser now correctly strips inline comments when
  delimiter occurs earlier without preceding space.

* bpo-15424: Add a "__sizeof__()" implementation for array objects.
  Patch by Ludwig Hähne.

* bpo-15576: Allow extension modules to act as a package's __init__
  module.

* bpo-15502: Have "importlib.invalidate_caches()" work on
  "sys.meta_path" instead of "sys.path_importer_cache".

* bpo-15163: Pydoc shouldn't list __loader__ as module data.

* bpo-15471: Do not use mutable objects as defaults for
  "importlib.__import__()".

* bpo-15559: To avoid a problematic failure mode when passed to the
  bytes constructor, objects in the ipaddress module no longer
  implement "__index__()" (they still implement "__int__()" as
  appropriate).

* bpo-15546: Fix handling of pathological input data in the peek()
  and read1() methods of the BZ2File, GzipFile and LZMAFile classes.

* bpo-12655: Instead of requiring a custom type,
  "os.sched_getaffinity()" and "os.sched_setaffinity()" now use
  regular sets of integers to represent the CPUs a process is
  restricted to.

* bpo-15538: Fix compilation of the "socket.getnameinfo()" /
  "socket.getaddrinfo()" emulation code.  Patch by Philipp
  Hagemeister.

* bpo-15519: Properly expose WindowsRegistryFinder in importlib (and
  use the correct term for it).  Original patch by Eric Snow.

* bpo-15502: Bring the importlib ABCs into line with the current
  state of the import protocols given PEP 420.  Original patch by Eric
  Snow.

* bpo-15499: Launching a webbrowser in Unix used to sleep for a few
  seconds. Original patch by Anton Barkovsky.

* bpo-15463: The faulthandler module truncates strings to 500
  characters, instead of 100, to be able to display long file paths.

* bpo-6056: Make "multiprocessing" use setblocking(True) on the
  sockets it uses. Original patch by J Derek Wilson.

* bpo-15364: Fix sysconfig.get_config_var('srcdir') to be an
  absolute path.

* bpo-15413: "os.times()" had disappeared under Windows.

* bpo-15402: An issue in the struct module that caused
  "sys.getsizeof()" to return incorrect results for struct.Struct
  instances has been fixed. Initial patch by Serhiy Storchaka.

* bpo-15232: When mangle_from is True, "email.Generator" now
  correctly mangles lines that start with 'From ' that occur in a MIME
  preamble or epilogue.

* bpo-15094: Incorrectly placed #endif in _tkinter.c.  Patch by
  Serhiy Storchaka.

* bpo-13922: "argparse" no longer incorrectly strips '--'s that
  appear after the first one.

* bpo-12353: "argparse" now correctly handles null argument values.

* bpo-10017: Fix TypeError using pprint on dictionaries with user-
  defined types as keys or other unorderable keys. (See also:
  bpo-14998)

* bpo-15397: "inspect.getmodulename()" is now based directly on
  importlib via a new "importlib.machinery.all_suffixes()" API.

* bpo-14635: "telnetlib" will use poll() rather than select() when
  possible to avoid failing due to the select() file descriptor limit.

* bpo-15180: Clarify posixpath.join() error message when mixing str
  & bytes.

* bpo-15343: pkgutil now includes an iter_importer_modules
  implementation for importlib.machinery.FileFinder (similar to the
  way it already handled zipimport.zipimporter).

* bpo-15314: runpy now sets __main__.__loader__ correctly.

* bpo-15357: The import emulation in pkgutil is now deprecated.
  pkgutil uses importlib internally rather than the emulation.

* bpo-15233: Python now guarantees that callables registered with
  the atexit module will be called in a deterministic order.

* bpo-15238: "shutil.copystat()" now copies Linux "extended
  attributes".

* bpo-15230: runpy.run_path now correctly sets __package__ as
  described in the documentation.

* bpo-15315: Support VS 2010 in distutils cygwincompiler.

* bpo-15294: Fix a regression in pkgutil.extend_path()'s handling of
  nested namespace packages.

* bpo-15056: "imp.cache_from_source()" and "imp.source_from_cache()"
  raise NotImplementedError when "sys.implementation.cache_tag" is set
  to None.

* bpo-15256: Grammatical mistake in exception raised by
  "imp.find_module()".

* bpo-5931: "wsgiref" environ variable SERVER_SOFTWARE will specify
  an implementation specific term like CPython, Jython instead of
  generic "Python".

* bpo-13248: Remove obsolete argument "max_buffer_size" of
  BufferedWriter and BufferedRWPair, from the io module.

* bpo-13248: Remove obsolete argument "version" of
  "argparse.ArgumentParser".

* bpo-14814: Implement more consistent ordering and sorting
  behaviour for ipaddress objects.

* bpo-14814: "ipaddress" network objects correctly return
  NotImplemented when compared to arbitrary objects instead of raising
  TypeError.

* bpo-14990: Correctly fail with SyntaxError on invalid encoding
  declaration.

* bpo-14814: "ipaddress" now provides more informative error
  messages when constructing instances directly (changes permitted
  during beta due to provisional API status).

* bpo-15247: "io.FileIO" now raises an error when given a file
  descriptor pointing to a directory.

* bpo-15261: Stop os.stat(fd) crashing on Windows when fd not open.

* bpo-15166: Implement "imp.get_tag()" using
  "sys.implementation.cache_tag".

* bpo-15210: Catch KeyError when "importlib.__init__()" can't find
  _frozen_importlib in sys.modules, not ImportError.

* bpo-15030: "importlib.abc.PyPycLoader" now supports the new source
  size header field in .pyc files.

* bpo-5346: Preserve permissions of mbox, MMDF and Babyl mailbox
  files on flush().

* bpo-10571: Fix the "--sign" option of distutils' upload command.
  Patch by Jakub Wilk.

* bpo-9559: If messages were only added, a new file is no longer
  created and renamed over the old file when flush() is called on an
  mbox, MMDF or Babyl mailbox.

* bpo-10924: Fixed "crypt.mksalt()" to use a RNG that is suitable
  for cryptographic purpose.

* bpo-15184: Ensure consistent results of OS X configuration
  tailoring for universal builds by factoring out common OS X-specific
  customizations from sysconfig, distutils.sysconfig, distutils.util,
  and distutils.unixccompiler into a new module _osx_support.


C API
-----

* bpo-15610: "PyImport_ImportModuleEx()" now uses a 'level' of 0
  instead of -1.

* bpo-15169: Strip out the C implementation of
  "imp.source_from_cache()" used by
  PyImport_ExecCodeModuleWithPathnames() and used the Python code
  instead. Leads to PyImport_ExecCodeModuleObject() to not try to
  infer the source path from the bytecode path as
  PyImport_ExecCodeModuleWithPathnames() does. (See also: bpo-14599)


Library
-------

* bpo-6493: An issue in ctypes on Windows that caused structure
  bitfields of type "ctypes.c_uint32" and width 32 to incorrectly be
  set has been fixed.

* bpo-15194: Update libffi to the 3.0.11 release.


IDLE
----

* bpo-13052: Fix IDLE crashing when replace string in Search/Replace
  dialog ended with "\".  Patch by Roger Serwy.


Tools/Demos
-----------

* bpo-15458: python-config gets a new option --configdir to print
  the $LIBPL value.

* Move importlib.test.benchmark to Tools/importbench.

* bpo-12605: The gdb hooks for debugging CPython (within Tools/gdb)
  have been enhanced to show information on more C frames relevant to
  CPython within the "py-bt" and "py-bt-full" commands:

  * C frames that are waiting on the GIL

  * C frames that are garbage-collecting

  * C frames that are due to the invocation of a PyCFunction


Documentation
-------------

* bpo-15041: Update "see also" list in tkinter documentation.

* bpo-15444: Use proper spelling for non-ASCII contributor names.
  Patch by Serhiy Storchaka.

* bpo-15295: Reorganize and rewrite the documentation on the import
  system.

* bpo-15230: Clearly document some of the limitations of the runpy
  module and nudge readers towards importlib when appropriate.

* bpo-15053: Copy Python 3.3 import lock change notice to all
  relevant functions in imp instead of just at the top of the relevant
  section.

* bpo-15288: Link to the term "loader" in notes in pkgutil about how
  things won't work as expected in Python 3.3 and mark the requisite
  functions as "changed" since they will no longer work with modules
  directly imported by import itself.

* bpo-13557: Clarify effect of giving two different namespaces to
  "exec()" or "execfile()".

* bpo-15250: Document that "filecmp.dircmp()" compares files
  shallowly. Patch contributed by Chris Jerdonek.

* bpo-15442: Expose the default list of directories ignored by
  "filecmp.dircmp()" as a module attribute, and expand the list to
  more modern values.


Tests
-----

* bpo-15467: Move helpers for "__sizeof__()" tests into
  test_support. Patch by Serhiy Storchaka.

* bpo-15320: Make iterating the list of tests thread-safe when
  running tests in multiprocess mode. Patch by Chris Jerdonek.

* bpo-15168: Move "importlib.test" to "test.test_importlib".

* bpo-15091: Reactivate a test on UNIX which was failing thanks to a
  forgotten "importlib.invalidate_caches()" call.

* bpo-15230: Adopted a more systematic approach in the runpy tests.

* bpo-15300: Ensure the temporary test working directories are in
  the same parent folder when running tests in multiprocess mode from
  a Python build. Patch by Chris Jerdonek.

* bpo-15284: Skip {send,recv}msg tests in test_socket when IPv6 is
  not enabled. Patch by Brian Brazil.

* bpo-15277: Fix a resource leak in support.py when IPv6 is
  disabled. Patch by Brian Brazil.


Build
-----

* bpo-11715: Fix multiarch detection without having Debian
  development tools (dpkg-dev) installed.

* bpo-15037: Build OS X installers with local copy of ncurses 5.9
  libraries to avoid curses.unget_wch bug present in older versions of
  ncurses such as those shipped with OS X.

* bpo-15560: Fix building _sqlite3 extension on OS X with an SDK.
  Also, for OS X installers, ensure consistent sqlite3 behavior and
  feature availability by building a local copy of libsqlite3 rather
  than depending on the wide range of versions supplied with various
  OS X releases.

* bpo-8847: Disable COMDAT folding in Windows PGO builds.

* bpo-14018: Fix OS X Tcl/Tk framework checking when using OS X
  SDKs.

* bpo-16256: OS X installer now sets correct permissions for doc
  directory.

* bpo-15431: Add _freeze_importlib project to regenerate importlib.h
  on Windows. Patch by Kristján Valur Jónsson.

* bpo-14197: For OS X framework builds, ensure links to the shared
  library are created with the proper ABI suffix.

* bpo-14330: For cross builds, don't use host python, use host
  search paths for host compiler.

* bpo-15235: Allow Berkley DB versions up to 5.3 to build the dbm
  module.

* bpo-15268: Search curses.h in /usr/include/ncursesw.


Python 3.3.0 beta 1
===================

*Release date: 27-Jun-2012*


Core and Builtins
-----------------

* Fix a (most likely) very rare memory leak when calling main() and
  not being able to decode a command-line argument.

* bpo-14815: Use Py_ssize_t instead of long for the object hash, to
  preserve all 64 bits of hash on Win64.

* bpo-12268: File readline, readlines and read() or readall()
  methods no longer lose data when an underlying read system call is
  interrupted. IOError is no longer raised due to a read system call
  returning EINTR from within these methods.

* bpo-11626: Add _SizeT functions to stable ABI.

* bpo-15142: Fix reference leak when deallocating instances of types
  created using PyType_FromSpec().

* bpo-10053: Don't close FDs when FileIO.__init__ fails. Loosely
  based on the work by Hirokazu Yamamoto.

* bpo-15096: Removed support for ur'' as the raw notation isn't
  compatible with Python 2.x's raw unicode strings.

* bpo-13783: Generator objects now use the identifier APIs
  internally

* bpo-14874: Restore charmap decoding speed to pre-PEP 393 levels.
  Patch by Serhiy Storchaka.

* bpo-15026: utf-16 encoding is now significantly faster (up to
  10x). Patch by Serhiy Storchaka.

* bpo-11022: open() and io.TextIOWrapper are now calling
  locale.getpreferredencoding(False) instead of
  locale.getpreferredencoding() in text mode if the encoding is not
  specified. Don't change temporary the locale encoding using
  locale.setlocale(), use the current locale encoding instead of the
  user preferred encoding.

* bpo-14673: Add Eric Snow's sys.implementation implementation.

* bpo-15038: Optimize python Locks on Windows.


Library
-------

* bpo-12288: Consider '0' and '0.0' as valid initialvalue for
  tkinter SimpleDialog.

* bpo-15512: Add a __sizeof__ implementation for parser. Patch by
  Serhiy Storchaka.

* bpo-15469: Add a __sizeof__ implementation for deque objects.
  Patch by Serhiy Storchaka.

* bpo-15489: Add a __sizeof__ implementation for BytesIO objects.
  Patch by Serhiy Storchaka.

* bpo-15487: Add a __sizeof__ implementation for buffered I/O
  objects. Patch by Serhiy Storchaka.

* bpo-15514: Correct __sizeof__ support for cpu_set. Patch by Serhiy
  Storchaka.

* bpo-15177: Added dir_fd parameter to os.fwalk().

* bpo-15061: Re-implemented hmac.compare_digest() in C to prevent
  further timing analysis and to support all buffer protocol aware
  objects as well as ASCII only str instances safely.

* bpo-15164: Change return value of platform.uname() from a plain
  tuple to a collections.namedtuple.

* Support Mageia Linux in the platform module.

* bpo-11678: Support Arch linux in the platform module.

* bpo-15118: Change return value of os.uname() and os.times() from
  plain tuples to immutable iterable objects with named attributes
  (structseq objects).

* Speed up _decimal by another 10-15% by caching the thread local
  context that was last accessed. In the pi benchmark (64-bit
  platform, prec=9), _decimal is now only 1.5x slower than float.

* Remove the packaging module, which is not ready for prime time.

* bpo-15154: Add "dir_fd" parameter to os.rmdir, remove "rmdir"
  parameter from os.remove / os.unlink.

* bpo-4489: Add a shutil.rmtree that isn't susceptible to symlink
  attacks. It is used automatically on platforms supporting the
  necessary os.openat() and os.unlinkat() functions. Main code by
  Martin von Löwis.

* bpo-15156: HTMLParser now uses the new "html.entities.html5"
  dictionary.

* bpo-11113: add a new "html5" dictionary containing the named
  character references defined by the HTML5 standard and the
  equivalent Unicode character(s) to the html.entities module.

* bpo-15114: the strict mode of HTMLParser and the HTMLParseError
  exception are deprecated now that the parser is able to parse
  invalid markup.

* bpo-3665: u and U escapes are now supported in unicode regular
  expressions.  Patch by Serhiy Storchaka.

* bpo-15153: Added inspect.getgeneratorlocals to simplify white box
  testing of generator state updates

* bpo-13062: Added inspect.getclosurevars to simplify testing
  stateful closures

* bpo-11024: Fixes and additional tests for Time2Internaldate.

* bpo-14626: Large refactoring of functions / parameters in the os
  module. Many functions now support "dir_fd" and "follow_symlinks"
  parameters; some also support accepting an open file descriptor in
  place of a path string. Added os.support_* collections as LBYL
  helpers.  Removed many functions only previously seen in 3.3 alpha
  releases (often starting with "f" or "l", or ending with "at").
  Originally suggested by Serhiy Storchaka; implemented by Larry
  Hastings.

* bpo-15008: Implement PEP 362 "Signature Objects". Patch by Yury
  Selivanov.

* bpo-15138: base64.urlsafe_{en,de}code() are now 3-4x faster.

* bpo-444582: Add shutil.which, for finding programs on the system
  path. Original patch by Erik Demaine, with later iterations by Jan
  Killian and Brian Curtin.

* bpo-14837: SSL errors now have "library" and "reason" attributes
  describing precisely what happened and in which OpenSSL submodule.
  The str() of a SSLError is also enhanced accordingly.

* bpo-9527: datetime.astimezone() method will now supply a class
  timezone instance corresponding to the system local timezone when
  called with no arguments.

* bpo-14653: email.utils.mktime_tz() no longer relies on system
  mktime() when timezone offest is supplied.

* bpo-14684: zlib.compressobj() and zlib.decompressobj() now support
  the use of predefined compression dictionaries. Original patch by
  Sam Rushing.

* Fix GzipFile's handling of filenames given as bytes objects.

* bpo-14772: Return destination values from some shutil functions.

* bpo-15064: Implement context manager protocol for multiprocessing
  types

* bpo-15101: Make pool finalizer avoid joining current thread.

* bpo-14657: The frozen instance of importlib used for bootstrap is
  now also the module imported as importlib._bootstrap.

* bpo-14055: Add __sizeof__ support to _elementtree.

* bpo-15054: A bug in tokenize.tokenize that caused string literals
  with 'b' prefixes to be incorrectly tokenized has been fixed. Patch
  by Serhiy Storchaka.

* bpo-15006: Allow equality comparison between naive and aware time
  or datetime objects.

* bpo-15036: Mailbox no longer throws an error if a flush is done
  between operations when removing or changing multiple items in mbox,
  MMDF, or Babyl mailboxes.

* bpo-14059: Implement multiprocessing.Barrier.

* bpo-15061: The inappropriately named hmac.secure_compare has been
  renamed to hmac.compare_digest, restricted to operating on bytes
  inputs only and had its documentation updated to more accurately
  reflect both its intent and its limitations

* bpo-13841: Make child processes exit using sys.exit() on Windows.

* bpo-14936: curses_panel was converted to PEP 3121 and PEP 384 API.
  Patch by Robin Schreiber.

* bpo-1667546: On platforms supporting tm_zone and tm_gmtoff fields
  in struct tm, time.struct_time objects returned by time.gmtime(),
  time.localtime() and time.strptime() functions now have tm_zone and
  tm_gmtoff attributes. Original patch by Paul Boddie.

* Rename adjusted attribute to adjustable in time.get_clock_info()
  result.

* bpo-3518: Remove references to non-existent
  BaseManager.from_address() method.

* bpo-13857: Added textwrap.indent() function (initial patch by Ezra
  Berch)

* bpo-2736: Added datetime.timestamp() method.

* bpo-13854: Make multiprocessing properly handle non-integer non-
  string argument to SystemExit.

* bpo-12157: Make pool.map() empty iterables correctly.  Initial
  patch by mouad.

* bpo-11823: disassembly now shows argument counts on calls with
  keyword args.

* bpo-14711: os.stat_float_times() has been deprecated.

* LZMAFile now accepts the modes "rb"/"wb"/"ab" as synonyms of
  "r"/"w"/"a".

* The bz2 and lzma modules now each contain an open() function,
  allowing compressed files to readily be opened in text mode as well
  as binary mode.

* BZ2File.__init__() and LZMAFile.__init__() now accept a file
  object as their first argument, rather than requiring a separate
  "fileobj" argument.

* gzip.open() now accepts file objects as well as filenames.

* bpo-14992: os.makedirs(path, exist_ok=True) would raise an OSError
  when the path existed and had the S_ISGID mode bit set when it was
  not explicitly asked for.  This is no longer an exception as mkdir
  cannot control if the OS sets that bit for it or not.

* bpo-14989: Make the CGI enable option to http.server available via
  command line.

* bpo-14987: Add a missing import statement to inspect.

* bpo-1079: email.header.decode_header now correctly parses all the
  examples in RFC2047. There is a necessary visible behavior change:
  the leading and/or trailing whitespace on ASCII parts is now
  preserved.

* bpo-14969: Better handling of exception chaining in
  contextlib.ExitStack

* bpo-14963: Convert contextlib.ExitStack.__exit__ to use an
  iterative algorithm (Patch by Alon Horev)

* bpo-14785: Add sys._debugmallocstats() to help debug low-level
  memory allocation issues

* bpo-14443: Ensure that .py files are byte-compiled with the
  correct Python executable within bdist_rpm even on older versions of
  RPM


C API
-----

* bpo-15146: Add PyType_FromSpecWithBases. Patch by Robin Schreiber.

* bpo-15042: Add PyState_AddModule and PyState_RemoveModule. Add
  version guard for Py_LIMITED_API additions. Patch by Robin
  Schreiber.

* bpo-13783: Inadvertent additions to the public C API in the PEP
  380 implementation have either been removed or marked as private
  interfaces.


Library
-------

* bpo-15000: Support the "unique" x32 architecture in
  _posixsubprocess.c.


IDLE
----

* bpo-9803: Don't close IDLE on saving if breakpoint is open. Patch
  by Roger Serwy.

* bpo-14962: Update text coloring in IDLE shell window after
  changing options.  Patch by Roger Serwy.


Documentation
-------------

* bpo-15176: Clarified behavior, documentation, and implementation
  of os.listdir().

* bpo-14982: Document that pkgutil's iteration functions require the
  non-standard iter_modules() method to be defined by an importer
  (something the importlib importers do not define).

* bpo-15081: Document PyState_FindModule. Patch by Robin Schreiber.

* bpo-14814: Added first draft of ipaddress module API reference


Tests
-----

* bpo-15187: Bugfix: remove temporary directories test_shutil was
  leaving behind.

* bpo-14769: test_capi now has SkipitemTest, which cleverly checks
  for "parity" between PyArg_ParseTuple() and the Python/getargs.c
  static function skipitem() for all possible "format units".

* test_nntplib now tolerates being run from behind NNTP gateways
  that add "X-Antivirus" headers to articles

* bpo-15043: test_gdb is now skipped entirely if gdb security
  settings block loading of the gdb hooks

* bpo-14963: Add test cases for exception handling behaviour in
  contextlib.ExitStack (Initial patch by Alon Horev)


Build
-----

* bpo-13590: Improve support for OS X Xcode 4:   * Try to avoid
  building Python or extension modules with problematic     llvm-gcc
  compiler.   * Since Xcode 4 removes ppc support, extension module
  builds now     check for ppc compiler support and automatically
  remove ppc and     ppc64 archs when not available. * Since Xcode 4
  no longer install SDKs in default locations,     extension module
  builds now revert to using installed headers     and libs if the SDK
  used to build the interpreter is not available.   * Update
  ./configure to use better defaults for universal builds;     in
  particular, --enable- universalsdk=yes uses the Xcode default SDK
  and --with-universal-archs now defaults to "intel" if ppc not
  available.

* bpo-14225: Fix Unicode support for curses (#12567) on OS X

* bpo-14928: Fix importlib bootstrap issues by using a custom
  executable (Modules/_freeze_importlib) to build Python/importlib.h.


Python 3.3.0 alpha 4
====================

*Release date: 31-May-2012*


Core and Builtins
-----------------

* bpo-14835: Make plistlib output empty arrays & dicts like OS X.
  Patch by Sidney San Martín.

* bpo-14744: Use the new _PyUnicodeWriter internal API to speed up
  str%args and str.format(args).

* bpo-14930: Make memoryview objects weakrefable.

* bpo-14775: Fix a potential quadratic dict build-up due to the
  garbage collector repeatedly trying to untrack dicts.

* bpo-14857: fix regression in references to PEP 3135 implicit
  __class__ closure variable (Reopens issue #12370)

* bpo-14712: Virtual environments. Implemented by Vinay Sajip. (See
  also: PEP 405)

* bpo-14660: Namespace packages. Implemented by Eric Smith. (See
  also: PEP 420)

* bpo-14494: Fix __future__.py and its documentation to note that
  absolute imports are the default behavior in 3.0 instead of 2.7.
  Patch by Sven Marnach.

* bpo-9260: A finer-grained import lock.  Most of the import
  sequence now uses per- module locks rather than the global import
  lock, eliminating well-known issues with threads and imports.

* bpo-14624: UTF-16 decoding is now 3x to 4x faster on various
  inputs. Patch by Serhiy Storchaka.

* asdl_seq and asdl_int_seq are now Py_ssize_t sized.

* bpo-14133: Implement suppression of __context__ display with an
  attribute on BaseException. This replaces the original mechanism of
  PEP 409. (See also: PEP 415)

* bpo-14417: Mutating a dict during lookup now restarts the lookup
  instead of raising a RuntimeError (undoes issue #14205).

* bpo-14738: Speed-up UTF-8 decoding on non-ASCII data.  Patch by
  Serhiy Storchaka.

* bpo-14700: Fix two broken and undefined-behaviour-inducing
  overflow checks in old-style string formatting.


Library
-------

* bpo-14690: Use monotonic clock instead of system clock in the
  sched, subprocess and trace modules.

* bpo-14443: Tell rpmbuild to use the correct version of Python in
  bdist_rpm. Initial patch by Ross Lagerwall.

* bpo-12515: email now registers a defect if it gets to EOF while
  parsing a MIME part without seeing the closing MIME boundary.

* bpo-1672568: email now always decodes base64 payloads, adding
  padding and ignoring non- base64-alphabet characters if needed, and
  registering defects for any such problems.

* bpo-14925: email now registers a defect when the parser decides
  that there is a missing header/body separator line.
  MalformedHeaderDefect, which the existing code would never actually
  generate, is deprecated.

* bpo-10365: File open dialog now works instead of crashing even
  when the parent window is closed before the dialog. Patch by Roger
  Serwy.

* bpo-8739: Updated smtpd to support RFC 5321, and added support for
  the RFC 1870 SIZE extension.

* bpo-665194: Added a localtime function to email.utils to provide
  an aware local datetime for use in setting Date headers.

* bpo-12586: Added new provisional policies that implement
  convenient unicode support for email headers.  See What's New for
  details.

* bpo-14731: Refactored email Policy framework to support full
  backward compatibility with Python 3.2 by default yet allow for the
  introduction of new features through new policies.  Note that
  Policy.must_be_7bit is renamed to cte_type.

* bpo-14876: Use user-selected font for highlight configuration.

* bpo-14920: Fix the help(urllib.parse) failure on locale C on
  terminals. Have ascii characters in help.

* bpo-14548: Make multiprocessing finalizers check pid before
  running to cope with possibility of gc running just after fork.

* bpo-14036: Add an additional check to validate that port in
  urlparse does not go in illegal range and returns None.

* bpo-14862: Add missing names to os.__all__

* bpo-14875: Use float('inf') instead of float('1e66666') in the
  json module.

* bpo-13585: Added contextlib.ExitStack

* PEP 3144, Issue #14814: Added the ipaddress module

* bpo-14426: Correct the Date format in Expires attribute of Set-
  Cookie Header in Cookie.py.

* bpo-14588: The types module now provide new_class() and
  prepare_class() functions to support PEP 3115 compliant dynamic
  class creation. Patch by Daniel Urban and Nick Coghlan.

* bpo-13152: Allow to specify a custom tabsize for expanding tabs in
  textwrap. Patch by John Feuerstein.

* bpo-14721: Send the correct 'Content-length: 0' header when the
  body is an empty string ''. Initial Patch contributed by Arve
  Knudsen.

* bpo-14072: Fix parsing of 'tel' URIs in urlparse by making the
  check for ports stricter.

* bpo-9374: Generic parsing of query and fragment portions of url
  for any scheme. Supported both by RFC3986 and RFC2396.

* bpo-14798: Fix the functions in pyclbr to raise an ImportError
  when the first part of a dotted name is not a package. Patch by
  Xavier de Gaye.

* bpo-12098: multiprocessing on Windows now starts child processes
  using the same sys.flags as the current process.  Initial patch by
  Sergey Mezentsev.

* bpo-13031: Small speed-up for tarfile when unzipping tarfiles.
  Patch by Justin Peel.

* bpo-14780: urllib.request.urlopen() now has a "cadefault" argument
  to use the default certificate store.  Initial patch by James
  Oakley.

* bpo-14829: Fix bisect and range() indexing with large indices (>=
  2 ** 32) under 64-bit Windows.

* bpo-14732: The _csv module now uses PEP 3121 module
  initialization. Patch by Robin Schreiber.

* bpo-14809: Add HTTP status codes introduced by RFC 6585 to
  http.server and http.client. Patch by EungJun Yi.

* bpo-14777: tkinter may return undecoded UTF-8 bytes as a string
  when accessing the Tk clipboard.  Modify clipboad_get() to first
  request type UTF8_STRING when no specific type is requested in an
  X11 windowing environment, falling back to the current default type
  STRING if that fails. Original patch by Thomas Kluyver.

* bpo-14773: Fix os.fwalk() failing on dangling symlinks.

* bpo-12541: Be lenient with quotes around Realm field of HTTP Basic
  Authentation in urllib2.

* bpo-14807: move undocumented tarfile.filemode() to stat.filemode()
  and add doc entry. Add tarfile.filemode alias with deprecation
  warning.

* bpo-13815: TarFile.extractfile() now returns io.BufferedReader
  objects.

* bpo-14532: Add a secure_compare() helper to the hmac module, to
  mitigate timing attacks. Patch by Jon Oberheide.

* Add importlib.util.resolve_name().

* bpo-14366: Support lzma compression in zip files. Patch by Serhiy
  Storchaka.

* bpo-13959: Introduce importlib.find_loader() and document
  imp.find_module/load_module as deprecated.

* bpo-14082: shutil.copy2() now copies extended attributes, if
  possible. Patch by Hynek Schlawack.

* bpo-13959: Make
  importlib.abc.FileLoader.load_module()/get_filename() and
  importlib.machinery.ExtensionFileLoader.load_module() have their
  single argument be optional. Allows for the replacement (and thus
  deprecation) of imp.load_source()/load_package()/load_compiled().

* bpo-13959: imp.get_suffixes() has been deprecated in favour of the
  new attributes on importlib.machinery: SOURCE_SUFFIXES,
  DEBUG_BYTECODE_SUFFIXES, OPTIMIZED_BYTECODE_SUFFIXES,
  BYTECODE_SUFFIXES, and EXTENSION_SUFFIXES. This led to an indirect
  deprecation of inspect.getmoduleinfo().

* bpo-14662: Prevent shutil failures on OS X when destination does
  not support chflag operations.  Patch by Hynek Schlawack.

* bpo-14157: Fix time.strptime failing without a year on February
  29th. Patch by Hynek Schlawack.

* bpo-14753: Make multiprocessing's handling of negative timeouts
  the same as it was in Python 3.2.

* bpo-14583: Fix importlib bug when a package's __init__.py would
  first import one of its modules then raise an error.

* bpo-14741: Fix missing support for Ellipsis ('...') in parser
  module.

* bpo-14697: Fix missing support for set displays and set
  comprehensions in parser module.

* bpo-14701: Fix missing support for 'raise ... from' in parser
  module.

* Add support for timeouts to the acquire() methods of
  multiprocessing's lock/semaphore/condition proxies.

* bpo-13989: Add support for text mode to gzip.open().

* bpo-14127: The os.stat() result object now provides three
  additional fields: st_ctime_ns, st_mtime_ns, and st_atime_ns,
  providing those times as an integer with nanosecond resolution.  The
  functions os.utime(), os.lutimes(), and os.futimes() now accept a
  new parameter, ns, which accepts mtime and atime as integers with
  nanosecond resolution.

* bpo-14127: shutil.copystat now preserves exact mtime and atime on
  filesystems providing nanosecond resolution. (See also: bpo-10148)


IDLE
----

* bpo-14958: Change IDLE systax highlighting to recognize all string
  and byte literals supported in Python 3.3.

* bpo-10997: Prevent a duplicate entry in IDLE's "Recent Files"
  menu.

* bpo-14929: Stop IDLE 3.x from closing on Unicode decode errors
  when grepping. Patch by Roger Serwy.

* bpo-12510: Attempting to get invalid tooltip no longer closes
  IDLE. Other tooltipss have been corrected or improved and the number
  of tests has been tripled. Original patch by Roger Serwy.


Tools/Demos
-----------

* bpo-14695: Bring Tools/parser/unparse.py support up to date with
  the Python 3.3 Grammar.


Build
-----

* bpo-14472: Update .gitignore. Patch by Matej Cepl.

* Upgrade Windows library versions: bzip 1.0.6, OpenSSL 1.0.1c.

* bpo-14693: Under non-Windows platforms, hashlib's fallback modules
  are always compiled, even if OpenSSL is present at build time.

* bpo-13210: Windows build now uses VS2010, ported from VS2008.


C API
-----

* bpo-14705: The PyArg_Parse() family of functions now support the
  'p' format unit, which accepts a "boolean predicate" argument.  It
  converts any Python value into an integer--0 if it is "false", and 1
  otherwise.


Documentation
-------------

* bpo-14863: Update the documentation of os.fdopen() to reflect the
  fact that it's only a thin wrapper around open() anymore.

* bpo-14588: The language reference now accurately documents the
  Python 3 class definition process. Patch by Nick Coghlan.

* bpo-14943: Correct a default argument value for winreg.OpenKey and
  correctly list the argument names in the function's explanation.


Python 3.3.0 alpha 3
====================

*Release date: 01-May-2012*


Core and Builtins
-----------------

* bpo-14699: Fix calling the classmethod descriptor directly.

* bpo-14433: Prevent msvcrt crash in interactive prompt when stdin
  is closed.

* bpo-14521: Make result of float('nan') and float('-nan') more
  consistent across platforms.

* bpo-14646: __import__() sets __loader__ if the loader did not.

* bpo-14605: No longer have implicit entries in sys.meta_path. If
  sys.meta_path is found to be empty, raise ImportWarning.

* bpo-14605: No longer have implicit entries in sys.path_hooks. If
  sys.path_hooks is found to be empty, a warning will be raised. None
  is now inserted into sys.path_importer_cache if no finder was
  discovered. This also means imp.NullImporter is no longer implicitly
  used.

* bpo-13903: Implement PEP 412. Individual dictionary instances can
  now share their keys with other dictionaries. Classes take advantage
  of this to share their instance dictionary keys for improved memory
  and performance.

* bpo-11603: Setting __repr__ to __str__ now raises a RuntimeError
  when repr() or str() is called on such an object.

* bpo-14658: Fix binding a special method to a builtin
  implementation of a special method with a different name.

* bpo-14630: Fix a memory access bug for instances of a subclass of
  int with value 0.

* bpo-14339: Speed improvements to bin, oct and hex functions.
  Patch by Serhiy Storchaka.

* bpo-14385: It is now possible to use a custom type for the
  __builtins__ namespace, instead of a dict. It can be used for
  sandboxing for example. Raise also a NameError instead of
  ImportError if __build_class__ name if not found in __builtins__.

* bpo-12599: Be more strict in accepting None compared to a false-
  like object for importlib.util.module_for_loader and
  importlib.machinery.PathFinder.

* bpo-14612: Fix jumping around with blocks by setting f_lineno.

* bpo-14592: Attempting a relative import w/o __package__ or
  __name__ set in globals raises a KeyError.

* bpo-14607: Fix keyword-only arguments which started with "__".

* bpo-10854: The ImportError raised when an extension module on
  Windows fails to import now uses the new path and name attributes
  from Issue #1559549.

* bpo-13889: Check and (if necessary) set FPU control word before
  calling any of the dtoa.c string <-> float conversion functions, on
  MSVC builds of Python. This fixes issues when embedding Python in a
  Delphi app.

* __import__() now matches PEP 328 and documentation by defaulting
  'index' to 0 instead of -1 and removing support for negative values.

* bpo-2377: Make importlib the implementation of __import__().

* bpo-1559549: ImportError now has 'name' and 'path' attributes that
  are set using keyword arguments to its constructor. They are
  currently not set by import as they are meant for use by importlib.

* bpo-14474: Save and restore exception state in
  thread.start_new_thread() while writing error message if the thread
  leaves a unhandled exception.

* bpo-13019: Fix potential reference leaks in bytearray.extend().
  Patch by Suman Saha.


Library
-------

* bpo-14768: os.path.expanduser('~/a') doesn't works correctly when
  HOME is '/'.

* bpo-14371: Support bzip2 in zipfile module.  Patch by Serhiy
  Storchaka.

* bpo-13183: Fix pdb skipping frames after hitting a breakpoint and
  running step.  Patch by Xavier de Gaye.

* bpo-14696: Fix parser module to understand 'nonlocal'
  declarations.

* bpo-10941: Fix imaplib.Internaldate2tuple to produce correct
  result near the DST transition.  Patch by Joe Peterson.

* bpo-9154: Fix parser module to understand function annotations.

* bpo-6085: In http.server.py SimpleHTTPServer.address_string
  returns the client ip address instead client hostname. Patch by
  Charles- François Natali.

* bpo-14309: Deprecate time.clock(), use time.perf_counter() or
  time.process_time() instead.

* bpo-14428: Implement the PEP 418. Add time.get_clock_info(),
  time.perf_counter() and time.process_time() functions, and rename
  time.steady() to time.monotonic().

* bpo-14646: importlib.util.module_for_loader() now sets __loader__
  and __package__ (when possible).

* bpo-14664: It is now possible to use @unittest.skip{If,Unless} on
  a test class that doesn't inherit from TestCase (i.e. a mixin).

* bpo-4892: multiprocessing Connections can now be transferred over
  multiprocessing Connections.  Patch by Richard Oudkerk (sbt).

* bpo-14160: TarFile.extractfile() failed to resolve symbolic links
  when the links were not located in an archive subdirectory.

* bpo-14638: pydoc now treats non-string __name__ values as if they
  were missing, instead of raising an error.

* bpo-13684: Fix httplib tunnel issue of infinite loops for certain
  sites which send EOF without trailing rn.

* bpo-14605: Add importlib.abc.FileLoader,
  importlib.machinery.(FileFinder, SourceFileLoader,
  SourcelessFileLoader, ExtensionFileLoader).

* bpo-13959: imp.cache_from_source()/source_from_cache() now follow
  os.path.join()/split() semantics for path manipulation instead of
  its prior, custom semantics of caring the right-most path separator
  forward in path joining.

* bpo-2193: Allow ":" character in Cookie NAME values.

* bpo-14629: tokenizer.detect_encoding will specify the filename in
  the SyntaxError exception if found at readline.__self__.name.

* bpo-14629: Raise SyntaxError in tokenizer.detect_encoding if the
  first two lines have non-UTF-8 characters without an encoding
  declaration.

* bpo-14308: Fix an exception when a "dummy" thread is in the
  threading module's active list after a fork().

* bpo-11750: The Windows API functions scattered in the _subprocess
  and _multiprocessing.win32 modules now live in a single module
  "_winapi". Patch by sbt.

* bpo-14087: multiprocessing: add Condition.wait_for(). Patch by
  sbt.

* bpo-14538: HTMLParser can now parse correctly start tags that
  contain a bare '/'.

* bpo-14452: SysLogHandler no longer inserts a UTF-8 BOM into the
  message.

* bpo-14386: Expose the dict_proxy internal type as
  types.MappingProxyType.

* bpo-13959: Make imp.reload() always use a module's __loader__ to
  perform the reload.

* bpo-13959: Add imp.py and rename the built-in module to _imp,
  allowing for re- implementing parts of the module in pure Python.

* bpo-13496: Fix potential overflow in bisect.bisect algorithm when
  applied to a collection of size > sys.maxsize / 2.

* Have importlib take advantage of ImportError's new 'name' and
  'path' attributes.

* bpo-14399: zipfile now recognizes that the archive has been
  modified even if only the comment is changed.  In addition, the
  TypeError that results from trying to set a non-binary value as a
  comment is now raised at the time the comment is set rather than at
  the time the zipfile is written.

* trace.CoverageResults.is_ignored_filename() now ignores any name
  that starts with "<" and ends with ">" instead of special-casing
  "<string>" and "<doctest ".

* bpo-12537: The mailbox module no longer depends on knowledge of
  internal implementation details of the email package Message object.

* bpo-7978: socketserver now restarts the select() call when EINTR
  is returned.  This avoids crashing the server loop when a signal is
  received. Patch by Jerzy Kozera.

* bpo-14522: Avoid duplicating socket handles in
  multiprocessing.connection. Patch by sbt.

* Don't Py_DECREF NULL variable in io.IncrementalNewlineDecoder.

* bpo-3033: Add displayof parameter to tkinter font. Patch by
  Guilherme Polo.

* bpo-14482: Raise a ValueError, not a NameError, when trying to
  create a multiprocessing Client or Listener with an AF_UNIX type
  address under Windows.  Patch by Popa Claudiu.

* bpo-802310: Generate always unique tkinter font names if not
  directly passed.

* bpo-14151: Raise a ValueError, not a NameError, when trying to
  create a multiprocessing Client or Listener with an AF_PIPE type
  address under non-Windows platforms. Patch by Popa Claudiu.

* bpo-14493: Use gvfs-open or xdg-open in webbrowser.


Build
-----

* "make touch" will now touch generated files that are checked into
  Mercurial, after a "hg update" which failed to bring the timestamps
  into the right order.


Tests
-----

* bpo-14026: In test_cmd_line_script, check that sys.argv is
  populated correctly for the various invocation approaches (Patch by
  Jason Yeo)

* bpo-14032: Fix incorrect variable name in test_cmd_line_script
  debugging message (Patch by Jason Yeo)

* bpo-14589: Update certificate chain for sha256.tbs-internet.com,
  fixing a test failure in test_ssl.

* bpo-14355: Regrtest now supports the standard unittest test
  loading, and will use it if a test file contains no "test_main"
  method.


IDLE
----

* bpo-8515: Set __file__ when run file in IDLE. Initial patch by
  Bruce Frederiksen.

* bpo-14496: Fix wrong name in idlelib/tabbedpages.py. Patch by Popa
  Claudiu.


Tools/Demos
-----------

* bpo-3561: The Windows installer now has an option, off by default,
  for placing the Python installation into the system "Path"
  environment variable.

* bpo-13165: stringbench is now available in the Tools/stringbench
  folder. It used to live in its own SVN project.


C API
-----

* bpo-14098: New functions PyErr_GetExcInfo and PyErr_SetExcInfo.
  Patch by Stefan Behnel.


Python 3.3.0 alpha 2
====================

*Release date: 01-Apr-2012*


Core and Builtins
-----------------

* bpo-1683368: object.__new__ and object.__init__ raise a TypeError
  if they are passed arguments and their complementary method is not
  overridden.

* bpo-14378: Fix compiling ast.ImportFrom nodes with a "__future__"
  string as the module name that was not interned.

* bpo-14331: Use significantly less stack space when importing
  modules by allocating path buffers on the heap instead of the stack.

* bpo-14334: Prevent in a segfault in type.__getattribute__ when it
  was not passed strings.

* bpo-1469629: Allow cycles through an object's __dict__ slot to be
  collected. (For example if "x.__dict__ is x").

* bpo-14205: dict lookup raises a RuntimeError if the dict is
  modified during a lookup.

* bpo-14220: When a generator is delegating to another iterator with
  the yield from syntax, it needs to have its "gi_running" flag set to
  True.

* bpo-14435: Remove dedicated block allocator from floatobject.c and
  rely on the PyObject_Malloc() api like all other objects.

* bpo-14471: Fix a possible buffer overrun in the winreg module.

* bpo-14288: Allow the serialization of builtin iterators


Library
-------

* bpo-14300: Under Windows, sockets created using socket.dup() now
  allow overlapped I/O. Patch by sbt.

* bpo-13872: socket.detach() now marks the socket closed (as
  mirrored in the socket repr()).  Patch by Matt Joiner.

* bpo-14406: Fix a race condition when using
  "concurrent.futures.wait( return_when=ALL_COMPLETED)".  Patch by
  Matt Joiner.

* bpo-5136: deprecate old, unused functions from tkinter.

* bpo-14416: syslog now defines the LOG_ODELAY and LOG_AUTHPRIV
  constants if they are defined in <syslog.h>.

* bpo-14295: Add unittest.mock

* bpo-7652: Add --with-system-libmpdec option to configure for
  linking the _decimal module against an installed libmpdec.

* bpo-14380: MIMEText now defaults to utf-8 when passed non-ASCII
  unicode with no charset specified.

* bpo-10340: asyncore - properly handle EINVAL in dispatcher
  constructor on OSX; avoid to call handle_connect in case of a
  disconnected socket which was not meant to connect.

* bpo-14204: The ssl module now has support for the Next Protocol
  Negotiation extension, if available in the underlying OpenSSL
  library. Patch by Colin Marc.

* bpo-3035: Unused functions from tkinter are marked as pending
  deprecated.

* bpo-12757: Fix the skipping of doctests when python is run with
  -OO so that it works in unittest's verbose mode as well as non-
  verbose mode.

* bpo-7652: Integrate the decimal floating point libmpdec library to
  speed up the decimal module. Performance gains of the new C
  implementation are between 10x and 100x, depending on the
  application.

* bpo-14269: SMTPD now conforms to the RFC and requires a HELO
  command before MAIL, RCPT, or DATA.

* bpo-13694: asynchronous connect in asyncore.dispatcher does not
  set addr attribute.

* bpo-14344: fixed the repr of email.policy objects.

* bpo-11686: Added missing entries to email package __all__ lists
  (mostly the new Bytes classes).

* bpo-14335: multiprocessing's custom Pickler subclass now inherits
  from the C-accelerated implementation.  Patch by sbt.

* bpo-10484: Fix the CGIHTTPServer's PATH_INFO handling problem.

* bpo-11199: Fix the with urllib which hangs on particular ftp urls.

* Improve the memory utilization and speed of functools.lru_cache.

* bpo-14222: Use the new time.steady() function instead of
  time.time() for timeout in queue and threading modules to not be
  affected of system time update.

* bpo-13248: Remove lib2to3.pytree.Base.get_prefix/set_prefix.

* bpo-14234: CVE-2012-0876: Randomize hashes of xml attributes in
  the hash table internal to the pyexpat module's copy of the expat
  library to avoid a denial of service due to hash collisions.  Patch
  by David Malcolm with some modifications by the expat project.

* bpo-12818: format address no longer needlessly escapes ()s in
  names when the name ends up being quoted.

* bpo-14062: BytesGenerator now correctly folds Header objects,
  including using linesep when folding.

* bpo-13839: When invoked on the command-line, the pstats module now
  accepts several filenames of profile stat files and merges them all.
  Patch by Matt Joiner.

* bpo-14291: Email now defaults to utf-8 for non-ASCII unicode
  headers instead of raising an error.  This fixes a regression
  relative to 2.7.

* bpo-989712: Support using Tk without a mainloop.

* bpo-3835: Refuse to use unthreaded Tcl in threaded Python.

* bpo-2843: Add new Tk API to Tkinter.

* bpo-14184: Increase the default stack size for secondary threads
  on Mac OS X to avoid interpreter crashes when using threads on 10.7.

* bpo-14180: datetime.date.fromtimestamp(),
  datetime.datetime.fromtimestamp() and
  datetime.datetime.utcfromtimestamp() now raise an OSError instead of
  ValueError if localtime() or gmtime() failed.

* bpo-14180: time.ctime(), gmtime(), time.localtime(),
  datetime.date.fromtimestamp(), datetime.datetime.fromtimestamp() and
  datetime.datetime.utcfromtimestamp() now raises an OverflowError,
  instead of a ValueError, if the timestamp does not fit in time_t.

* bpo-14180: datetime.datetime.fromtimestamp() and
  datetime.datetime.utcfromtimestamp() now round microseconds towards
  zero instead of rounding to nearest with ties going away from zero.

* bpo-10543: Fix unittest test discovery with Jython bytecode files.

* bpo-1178863: Separate initialisation from setting when
  initializing Tkinter.Variables; harmonize exceptions to ValueError;
  only delete variables that have not been deleted; assert that
  variable names are strings.

* bpo-14104: Implement time.monotonic() on Mac OS X, patch written
  by Nicholas Riley.

* bpo-13394: the aifc module now uses warnings.warn() to signal
  warnings.

* bpo-14252: Fix subprocess.Popen.terminate() to not raise an error
  under Windows when the child process has already exited.

* bpo-14223: curses.addch() is no more limited to the range 0-255
  when the Python curses is not linked to libncursesw. It was a
  regression introduced in Python 3.3a1.

* bpo-14168: Check for presence of Element._attrs in minidom before
  accessing it.

* bpo-12328: Fix multiprocessing's use of overlapped I/O on Windows.
  Also, add a multiprocessing.connection.wait(rlist, timeout=None)
  function for polling multiple objects at once.  Patch by sbt.

* bpo-14007: Accept incomplete TreeBuilder objects (missing start,
  end, data or close method) for the Python implementation as well.
  Drop the no-op TreeBuilder().xml() method from the C implementation.

* bpo-14210: pdb now has tab-completion not only for command names,
  but also for their arguments, wherever possible.

* bpo-14310: Sockets can now be with other processes on Windows
  using the api socket.socket.share() and socket.fromshare().

* bpo-10576: The gc module now has a 'callbacks' member that will
  get called when garbage collection takes place.


Build
-----

* bpo-14557: Fix extensions build on HP-UX. Patch by Adi Roiban.

* bpo-14387: Do not include accu.h from Python.h.

* bpo-14359: Only use O_CLOEXEC in _posixmodule.c if it is defined.
  Based on patch from Hervé Coatanhay.

* bpo-14321: Do not run pgen during the build if files are up to
  date.


Documentation
-------------

* bpo-14034: added the argparse tutorial.

* bpo-14324: Fix configure tests for cross builds.

* bpo-14327: Call AC_CANONICAL_HOST in configure.ac and check in
  config.{guess,sub}. Don't use uname calls for cross builds.


Library
-------

* bpo-9041: An issue in ctypes.c_longdouble, ctypes.c_double, and
  ctypes.c_float that caused an incorrect exception to be returned in
  the case of overflow has been fixed.

* bpo-14212: The re module didn't retain a reference to buffers it
  was scanning, resulting in segfaults.

* bpo-14259: The finditer() method of re objects did not take any
  keyword arguments, contrary to the documentation.

* bpo-10142: Support for SEEK_HOLE/SEEK_DATA (for example, under
  ZFS).


Tests
-----

* bpo-14442: Add missing errno import in test_smtplib.

* bpo-8315: (partial fix) python -m unittest test.test_email now
  works.


Python 3.3.0 alpha 1
====================

*Release date: 05-Mar-2012*


Core and Builtins
-----------------

* bpo-14172: Fix reference leak when marshalling a buffer-like
  object (other than a bytes object).

* bpo-13521: dict.setdefault() now does only one lookup for the
  given key, making it "atomic" for many purposes.  Patch by Filip
  Gruszczyński.

* PEP 409, Issue #6210: "raise X from None" is now supported as a
  means of suppressing the display of the chained exception context.
  The chained context still remains available as the __context__
  attribute.

* bpo-10181: New memoryview implementation fixes multiple ownership
  and lifetime issues of dynamically allocated Py_buffer members
  (#9990) as well as crashes (#8305, #7433). Many new features have
  been added (See whatsnew/3.3), and the documentation has been
  updated extensively. The ndarray test object from _testbuffer.c
  implements all aspects of PEP-3118, so further development towards
  the complete implementation of the PEP can proceed in a test-driven
  manner.

  Thanks to Nick Coghlan, Antoine Pitrou and Pauli Virtanen for review
  and many ideas.

* bpo-12834: Fix incorrect results of memoryview.tobytes() for non-
  contiguous arrays.

* bpo-5231: Introduce memoryview.cast() method that allows changing
  format and shape without making a copy of the underlying memory.

* bpo-14084: Fix a file descriptor leak when importing a module with
  a bad encoding.

* Upgrade Unicode data to Unicode 6.1.

* bpo-14040: Remove rarely used file name suffixes for C extensions
  (under POSIX mainly).

* bpo-14051: Allow arbitrary attributes to be set of classmethod and
  staticmethod.

* bpo-13703: oCERT-2011-003: Randomize hashes of str and bytes to
  protect against denial of service attacks due to hash collisions
  within the dict and set types. Patch by David Malcolm, based on work
  by Victor Stinner.

* bpo-13020: Fix a reference leak when allocating a structsequence
  object fails.  Patch by Suman Saha.

* bpo-13908: Ready types returned from PyType_FromSpec.

* bpo-11235: Fix OverflowError when trying to import a source file
  whose modification time doesn't fit in a 32-bit timestamp.

* bpo-12705: A SyntaxError exception is now raised when attempting
  to compile multiple statements as a single interactive statement.

* Fix the builtin module initialization code to store the init
  function for future reinitialization.

* bpo-8052: The posix subprocess module would take a long time
  closing all possible file descriptors in the child process rather
  than just open file descriptors.  It now closes only the open fds if
  possible for the default close_fds=True behavior.

* bpo-13629: Renumber the tokens in token.h so that they match the
  indexes into _PyParser_TokenNames.

* bpo-13752: Add a casefold() method to str.

* bpo-13761: Add a "flush" keyword argument to the print() function,
  used to ensure flushing the output stream.

* bpo-13645: pyc files now contain the size of the corresponding
  source code, to avoid timestamp collisions (especially on
  filesystems with a low timestamp resolution) when checking for
  freshness of the bytecode.

* PEP 380, Issue #11682: Add "yield from <x>" to support easy
  delegation to subgenerators (initial patch by Greg Ewing,
  integration into 3.3 by Renaud Blanch, Ryan Kelly, Zbigniew
  Jędrzejewski-Szmek and Nick Coghlan)

* bpo-13748: Raw bytes literals can now be written with the "rb"
  prefix as well as "br".

* bpo-12736: Use full unicode case mappings for upper, lower, and
  title case.

* bpo-12760: Add a create mode to open(). Patch by David Townshend.

* bpo-13738: Simplify implementation of bytes.lower() and
  bytes.upper().

* bpo-13577: Built-in methods and functions now have a __qualname__.
  Patch by sbt.

* bpo-6695: Full garbage collection runs now clear the freelist of
  set objects.  Initial patch by Matthias Troffaes.

* Fix OSError.__init__ and OSError.__new__ so that each of them can
  be overriden and take additional arguments (followup to issue
  #12555).

* Fix the fix for issue #12149: it was incorrect, although it had
  the side effect of appearing to resolve the issue.  Thanks to Mark
  Shannon for noticing.

* bpo-13505: Pickle bytes objects in a way that is compatible with
  Python 2 when using protocols <= 2.

* bpo-11147: Fix an unused argument in _Py_ANNOTATE_MEMORY_ORDER.
  (Fix given by Campbell Barton).

* bpo-13503: Use a more efficient reduction format for bytearrays
  with pickle protocol >= 3.  The old reduction format is kept with
  older protocols in order to allow unpickling under Python 2.  Patch
  by Irmen de Jong.

* bpo-7111: Python can now be run without a stdin, stdout or stderr
  stream. It was already the case with Python 2.  However, the
  corresponding sys module entries are now set to None (instead of an
  unusable file object).

* bpo-11849: Ensure that free()d memory arenas are really released
  on POSIX systems supporting anonymous memory mappings.  Patch by
  Charles-François Natali.

* PEP 3155 / issue #13448: Qualified name for classes and functions.

* bpo-13436: Fix a bogus error message when an AST object was passed
  an invalid integer value.

* bpo-13411: memoryview objects are now hashable when the underlying
  object is hashable.

* bpo-13338: Handle all enumerations in _Py_ANNOTATE_MEMORY_ORDER to
  allow compiling extension modules with -Wswitch-enum on gcc. Initial
  patch by Floris Bruynooghe.

* bpo-10227: Add an allocation cache for a single slice object.
  Patch by Stefan Behnel.

* bpo-13393: BufferedReader.read1() now asks the full requested size
  to the raw stream instead of limiting itself to the buffer size.

* bpo-13392: Writing a pyc file should now be atomic under Windows
  as well.

* bpo-13333: The UTF-7 decoder now accepts lone surrogates (the
  encoder already accepts them).

* bpo-13389: Full garbage collection passes now clear the freelists
  for list and dict objects.  They already cleared other freelists in
  the interpreter.

* bpo-13327: Remove the need for an explicit None as the second
  argument to os.utime, os.lutimes, os.futimes, os.futimens,
  os.futimesat, in order to update to the current time. Also added
  keyword argument handling to os.utimensat in order to remove the
  need for explicit None.

* bpo-13350: Simplify some C code by replacing most usages of
  PyUnicode_Format by PyUnicode_FromFormat.

* bpo-13342: input() used to ignore sys.stdin's and sys.stdout's
  unicode error handler in interactive mode (when calling into
  PyOS_Readline()).

* bpo-9896: Add start, stop, and step attributes to range objects.

* bpo-13343: Fix a SystemError when a lambda expression uses a
  global variable in the default value of a keyword-only argument:
  "lambda *, arg=GLOBAL_NAME: None"

* bpo-12797: Added custom opener parameter to builtin open() and
  FileIO.open().

* bpo-10519: Avoid unnecessary recursive function calls in
  setobject.c.

* bpo-10363: Deallocate global locks in Py_Finalize().

* bpo-13018: Fix reference leaks in error paths in dictobject.c.
  Patch by Suman Saha.

* bpo-13201: Define '==' and '!=' to compare range objects based on
  the sequence of values they define (instead of comparing based on
  object identity).

* bpo-1294232: In a few cases involving metaclass inheritance, the
  interpreter would sometimes invoke the wrong metaclass when building
  a new class object. These cases now behave correctly. Patch by
  Daniel Urban.

* bpo-12753: Add support for Unicode name aliases and named
  sequences. Both "unicodedata.lookup()" and 'N{...}' now resolve
  aliases, and "unicodedata.lookup()" resolves named sequences too.

* bpo-12170: The count(), find(), rfind(), index() and rindex()
  methods of bytes and bytearray objects now accept an integer between
  0 and 255 as their first argument.  Patch by Petri Lehtinen.

* bpo-12604: VTRACE macro expanded to no-op in _sre.c to avoid
  compiler warnings. Patch by Josh Triplett and Petri Lehtinen.

* bpo-12281: Rewrite the MBCS codec to handle correctly replace and
  ignore error handlers on all Windows versions. The MBCS codec is now
  supporting all error handlers, instead of only replace to encode and
  ignore to decode.

* bpo-13188: When called without an explicit traceback argument,
  generator.throw() now gets the traceback from the passed exception's
  "__traceback__" attribute. Patch by Petri Lehtinen.

* bpo-13146: Writing a pyc file is now atomic under POSIX.

* bpo-7833: Extension modules built using distutils on Windows will
  no longer include a "manifest" to prevent them failing at import
  time in some embedded situations.

* PEP 3151 / issue #12555: reworking the OS and IO exception
  hierarchy.

* Add internal API for static strings (_Py_identifier et al.).

* bpo-13063: the Windows error ERROR_NO_DATA (numbered 232 and
  described as "The pipe is being closed") is now mapped to POSIX
  errno EPIPE (previously EINVAL).

* bpo-12911: Fix memory consumption when calculating the repr() of
  huge tuples or lists.

* PEP 393: flexible string representation. Thanks to Torsten Becker
  for the initial implementation, and Victor Stinner for various bug
  fixes.

* bpo-14081: The 'sep' and 'maxsplit' parameter to str.split,
  bytes.split, and bytearray.split may now be passed as keyword
  arguments.

* bpo-13012: The 'keepends' parameter to str.splitlines may now be
  passed as a keyword argument: "my_string.splitlines(keepends=True)".
  The same change also applies to bytes.splitlines and
  bytearray.splitlines.

* bpo-7732: Don't open a directory as a file anymore while importing
  a module. Ignore the direcotry if its name matchs the module name
  (e.g. "__init__.py") and raise a ImportError instead.

* bpo-13021: Missing decref on an error path.  Thanks to Suman Saha
  for finding the bug and providing a patch.

* bpo-12973: Fix overflow checks that relied on undefined behaviour
  in list_repeat (listobject.c) and islice_next (itertoolsmodule.c).
  These bugs caused test failures with recent versions of Clang.

* bpo-12904: os.utime, os.futimes, os.lutimes, and os.futimesat now
  write atime and mtime with nanosecond precision on modern POSIX
  platforms.

* bpo-12802: the Windows error ERROR_DIRECTORY (numbered 267) is now
  mapped to POSIX errno ENOTDIR (previously EINVAL).

* bpo-9200: The str.is* methods now work with strings that contain
  non-BMP characters even in narrow Unicode builds.

* bpo-12791: Break reference cycles early when a generator exits
  with an exception.

* bpo-12773: Make __doc__ mutable on user-defined classes.

* bpo-12766: Raise a ValueError when creating a class with a class
  variable that conflicts with a name in __slots__.

* bpo-12266: Fix str.capitalize() to correctly uppercase/lowercase
  titlecased and cased non-letter characters.

* bpo-12732: In narrow unicode builds, allow Unicode identifiers
  which fall outside the BMP.

* bpo-12575: Validate user-generated AST before it is compiled.

* Make type(None), type(Ellipsis), and type(NotImplemented)
  callable. They return the respective singleton instances.

* Forbid summing bytes with sum().

* Verify the types of AST strings and identifiers provided by the
  user before compiling them.

* bpo-12647: The None object now has a __bool__() method that
  returns False. Formerly, bool(None) returned False only because of
  special case logic in PyObject_IsTrue().

* bpo-12579: str.format_map() now raises a ValueError if used on a
  format string that contains positional fields. Initial patch by
  Julian Berman.

* bpo-10271: Allow warnings.showwarning() be any callable.

* bpo-11627: Fix segfault when __new__ on a exception returns a non-
  exception class.

* bpo-12149: Update the method cache after a type's dictionary gets
  cleared by the garbage collector.  This fixes a segfault when an
  instance and its type get caught in a reference cycle, and the
  instance's deallocator calls one of the methods on the type (e.g.
  when subclassing IOBase).  Diagnosis and patch by Davide Rizzo.

* bpo-9611: FileIO.read() clamps the length to INT_MAX on Windows.
  (See also: bpo-9015)

* bpo-9642: Uniformize the tests on the availability of the mbcs
  codec, add a new HAVE_MBCS define.

* bpo-9642: Fix filesystem encoding initialization: use the ANSI
  code page on Windows if the mbcs codec is not available, and fail
  with a fatal error if we cannot get the locale encoding (if
  nl_langinfo(CODESET) is not available) instead of using UTF-8.

* When a generator yields, do not retain the caller's exception
  state on the generator.

* bpo-12475: Prevent generators from leaking their exception state
  into the caller's frame as they return for the last time.

* bpo-12291: You can now load multiple marshalled objects from a
  stream, with other data interleaved between marshalled objects.

* bpo-12356: When required positional or keyword-only arguments are
  not given, produce a informative error message which includes the
  name(s) of the missing arguments.

* bpo-12370: Fix super with no arguments when __class__ is overriden
  in the class body.

* bpo-12084: os.stat on Windows now works properly with relative
  symbolic links when called from any directory.

* Loosen type restrictions on the __dir__ method. __dir__ can now
  return any sequence, which will be converted to a list and sorted by
  dir().

* bpo-12265: Make error messages produced by passing an invalid set
  of arguments to a function more informative.

* bpo-12225: Still allow Python to build if Python is not in its hg
  repo or mercurial is not installed.

* bpo-1195: my_fgets() now always clears errors before calling
  fgets(). Fix the following case: sys.stdin.read() stopped with
  CTRL+d (end of file), raw_input() interrupted by CTRL+c.

* bpo-12216: Allow unexpected EOF errors to happen on any line of
  the file.

* bpo-12199: The TryExcept and TryFinally and AST nodes have been
  unified into a Try node.

* bpo-9670: Increase the default stack size for secondary threads on
  Mac OS X and FreeBSD to reduce the chances of a crash instead of a
  "maximum recursion depth" RuntimeError exception. (patch by Ronald
  Oussoren)

* bpo-12106: The use of the multiple-with shorthand syntax is now
  reflected in the AST.

* bpo-12190: Try to use the same filename object when compiling
  unmarshalling a code objects in the same file.

* bpo-12166: Move implementations of dir() specialized for various
  types into the __dir__() methods of those types.

* bpo-5715: In socketserver, close the server socket in the child
  process.

* Correct lookup of __dir__ on objects. Among other things, this
  causes errors besides AttributeError found on lookup to be
  propagated.

* bpo-12060: Use sig_atomic_t type and volatile keyword in the
  signal module. Patch written by Charles-François Natali.

* bpo-1746656: Added the if_nameindex, if_indextoname,
  if_nametoindex methods to the socket module.

* bpo-12044: Fixed subprocess.Popen when used as a context manager
  to wait for the process to end when exiting the context to avoid
  unintentionally leaving zombie processes around.

* bpo-1195: Fix input() if it is interrupted by CTRL+d and then
  CTRL+c, clear the end- of-file indicator after CTRL+d.

* bpo-1856: Avoid crashes and lockups when daemon threads run while
  the interpreter is shutting down; instead, these threads are now
  killed when they try to take the GIL.

* bpo-9756: When calling a method descriptor or a slot wrapper
  descriptor, the check of the object type doesn't read the __class__
  attribute anymore. Fix a crash if a class override its __class__
  attribute (e.g. a proxy of the str type). Patch written by Andreas
  Stührk.

* bpo-10517: After fork(), reinitialize the TLS used by the
  PyGILState_* APIs, to avoid a crash with the pthread implementation
  in RHEL 5.  Patch by Charles-François Natali.

* bpo-10914: Initialize correctly the filesystem codec when creating
  a new subinterpreter to fix a bootstrap issue with codecs
  implemented in Python, as the ISO-8859-15 codec.

* bpo-11918: OS/2 and VMS are no more supported because of the lack
  of maintainer.

* bpo-6780: fix starts/endswith error message to mention that tuples
  are accepted too.

* bpo-5057: fix a bug in the peepholer that led to non-portable pyc
  files between narrow and wide builds while optimizing BINARY_SUBSCR
  on non-BMP chars (e.g. "U00012345"[0]).

* bpo-11845: Fix typo in rangeobject.c that caused a crash in
  compute_slice_indices. Patch by Daniel Urban.

* bpo-5673: Added a "timeout" keyword argument to
  subprocess.Popen.wait, subprocess.Popen.communicated,
  subprocess.call, subprocess.check_call, and subprocess.check_output.
  If the blocking operation takes more than "timeout" seconds, the
  "subprocess.TimeoutExpired" exception is raised.

* bpo-11650: PyOS_StdioReadline() retries fgets() if it was
  interrupted (EINTR), for example if the program is stopped with
  CTRL+z on Mac OS X. Patch written by Charles-Francois Natali.

* bpo-9319: Include the filename in "Non-UTF8 code ..." syntax
  error.

* bpo-10785: Store the filename as Unicode in the Python parser.

* bpo-11619: _PyImport_LoadDynamicModule() doesn't encode the path
  to bytes on Windows.

* bpo-10998: Remove mentions of -Q, sys.flags.division_warning and
  Py_DivisionWarningFlag left over from Python 2.

* bpo-11244: Remove an unnecessary peepholer check that was
  preventing negative zeros from being constant-folded properly.

* bpo-11395: io.FileIO().write() clamps the data length to 32,767
  bytes on Windows if the file is a TTY to workaround a Windows bug.
  The Windows console returns an error (12: not enough space error) on
  writing into stdout if stdout mode is binary and the length is
  greater than 66,000 bytes (or less, depending on heap usage).

* bpo-11320: fix bogus memory management in Modules/getpath.c,
  leading to a possible crash when calling Py_SetPath().

* bpo-11432: A bug was introduced in subprocess.Popen on posix
  systems with 3.2.0 where the stdout or stderr file descriptor being
  the same as the stdin file descriptor would raise an exception.
  webbrowser.open would fail. fixed.

* bpo-9856: Change object.__format__ with a non-empty format string
  to be a DeprecationWarning. In 3.2 it was a
  PendingDeprecationWarning. In 3.4 it will be a TypeError.

* bpo-11244: The peephole optimizer is now able to constant-fold
  arbitrarily complex expressions.  This also fixes a 3.2 regression
  where operations involving negative numbers were not constant-
  folded.

* bpo-11450: Don't truncate hg version info in Py_GetBuildInfo()
  when there are many tags (e.g. when using mq).  Patch by Nadeem
  Vawda.

* bpo-11335: Fixed a memory leak in list.sort when the key function
  throws an exception.

* bpo-8923: When a string is encoded to UTF-8 in strict mode, the
  result is cached into the object. Examples: str.encode(),
  str.encode('utf-8'), PyUnicode_AsUTF8String() and
  PyUnicode_AsEncodedString(unicode, "utf-8", NULL).

* bpo-10829: Refactor PyUnicode_FromFormat(), use the same function
  to parse the format string in the 3 steps, fix crashs on invalid
  format strings.

* bpo-13007: whichdb should recognize gdbm 1.9 magic numbers.

* bpo-11286: Raise a ValueError from calling PyMemoryView_FromBuffer
  with a buffer struct having a NULL data pointer.

* bpo-11272: On Windows, input() strips 'r' (and not only 'n'), and
  sys.stdin uses universal newline (replace 'rn' by 'n').

* bpo-11828: startswith and endswith now accept None as slice index.
  Patch by Torsten Becker.

* bpo-11168: Remove filename debug variable from
  PyEval_EvalFrameEx(). It encoded the Unicode filename to UTF-8, but
  the encoding fails on undecodable filename (on surrogate characters)
  which raises an unexpected UnicodeEncodeError on recursion limit.

* bpo-11187: Remove bootstrap code (use ASCII) of
  PyUnicode_AsEncodedString(), it was replaced by a better fallback
  (use the locale encoding) in PyUnicode_EncodeFSDefault().

* Check for NULL result in PyType_FromSpec.

* bpo-10516: New copy() and clear() methods for lists and
  bytearrays.

* bpo-11386: bytearray.pop() now throws IndexError when the
  bytearray is empty, instead of OverflowError.

